#ifndef _SLPCOMPOSER_H_
#define _SLPCOMPOSER_H_

#include "composer/composer.h"
#include "protocol/slpmsg.h"



typedef struct slp_service_discover {
	int stream_id;
	char* service_type;
	SLPMSG_PTR slpmsg;
} SLP_SERVICE_DISCOVER;
typedef SLP_SERVICE_DISCOVER* SLP_SERVICE_DISCOVER_PTR;


typedef struct slp_service_discover_table {
	SLP_SERVICE_DISCOVER services[100];
	int n_services;
} SLP_SERVICE_DISCOVER_TABLE;

void slp_service_discover_table_init(SLP_SERVICE_DISCOVER_TABLE* table);
void slp_service_discover_table_add_entry(SLP_SERVICE_DISCOVER_TABLE* table, int stream_id, char* service_type, SLPMSG_PTR slpmsg);
int slp_service_discover_table_contains_stream_id(SLP_SERVICE_DISCOVER_TABLE table, int stream_id);
SLPMSG_PTR slp_service_discover_table_get_slpmsg_by_service_type(SLP_SERVICE_DISCOVER_TABLE table, char* service_type);
SLPMSG_PTR slp_service_discover_table_get_slpmsg_by_stream_id(SLP_SERVICE_DISCOVER_TABLE table, int stream_id);
void slp_service_discover_table_set_service_type(SLP_SERVICE_DISCOVER_TABLE table, int stream_id, char* service_type);

#endif //_SLPCOMPOSER_H_
