#ifndef _SSDPCOMPOSER_H_
#define _SSDPCOMPOSER_H_

#include "composer/composer.h"
#include "protocol/ssdpmsg.h"



typedef struct ssdp_service_discover {
	int stream_id;
	char location_url_nopath[255];
	char location_url_path[255];
	char location[255];
	char service_type[255];
	SSDPMSG_PTR ssdpmsg;
} SSDP_SERVICE_DISCOVER;
typedef SSDP_SERVICE_DISCOVER* SSDP_SERVICE_DISCOVER_PTR;


typedef struct ssdp_service_discover_table {
	SSDP_SERVICE_DISCOVER services[100];
	int n_services;
} SSDP_SERVICE_DISCOVER_TABLE;

void ssdp_service_discover_table_init(SSDP_SERVICE_DISCOVER_TABLE* table);

void ssdp_service_discover_table_add_entry(SSDP_SERVICE_DISCOVER_TABLE* table, int stream_id, SSDPMSG_PTR ssdpmsg);
int ssdp_service_discover_table_contains_stream_id(SSDP_SERVICE_DISCOVER_TABLE table, int stream_id);

SSDPMSG_PTR ssdp_service_discover_table_get_ssdpmsg_by_stream_id(SSDP_SERVICE_DISCOVER_TABLE table, int stream_id);

char* ssdp_service_discover_table_get_location_url_path(SSDP_SERVICE_DISCOVER_TABLE table, int stream_id);
char* ssdp_service_discover_table_get_location_url_nopath(SSDP_SERVICE_DISCOVER_TABLE table, int stream_id);
char* ssdp_service_discover_table_get_location(SSDP_SERVICE_DISCOVER_TABLE table, int stream_id);
char* ssdp_service_discover_table_get_service_type(SSDP_SERVICE_DISCOVER_TABLE table, int stream_id);

void ssdp_service_discover_table_set_location_url_nopath(SSDP_SERVICE_DISCOVER_TABLE* table, int stream_id, char* location_url_nopath);
void ssdp_service_discover_table_set_location_url_path(SSDP_SERVICE_DISCOVER_TABLE* table, int stream_id, char* location_url_path);
void ssdp_service_discover_table_set_location(SSDP_SERVICE_DISCOVER_TABLE* table, int stream_id, char* location);
void ssdp_service_discover_table_set_service_type(SSDP_SERVICE_DISCOVER_TABLE* table, int stream_id, char* service_type);

#endif //_SSDPCOMPOSER_H_
