#ifndef _ACTION_H_
#define _ACTION_H_
#include <malloc.h>
#include <string.h>

#include "event/event.h"


typedef void (* prototype_function1)(char*);
typedef void (* prototype_function2)(EVENT_PTR);
typedef void (* prototype_function3)(void*, char * , char * , EVENT_PTR);
typedef void (* prototype_function4)(EVENT_PTR, void*);
typedef void (* prototype_function5)(void*, char * , char * , char * , EVENT_PTR);
typedef void (* prototype_function6)(void* , char* , EVENT_PTR );


typedef struct  action{
	char * name;
	int type;
	union {
		//void (* function1)(char*);
		//void (* function2)(SDPEVENT);
		prototype_function1 function1;
		prototype_function2 function2;
		prototype_function3 function3;
		prototype_function4 function4;
		prototype_function5 function5;
		prototype_function6 function6;
	} function;
	char ** arguments;
	struct action* next_action;
} ACTION; 
typedef ACTION* ACTION_PTR;

ACTION_PTR action_create_function1(char* name, prototype_function1 function /*, char* arguments*/);

ACTION_PTR action_create_function2(char* name, prototype_function2 function/*, char* arguments*/);

ACTION_PTR action_create_function3(char* name, prototype_function3 function/*, char* arguments*/);

ACTION_PTR action_create_function4(char* name, prototype_function4 function/*, char* arguments*/);

ACTION_PTR action_create_function5(char* name, prototype_function5 function/*, char* arguments*/);

ACTION_PTR action_create_function6(char* name, prototype_function6 function/*, char* arguments*/);

#endif //_ACTION_H_

