/*
 * 
 *             Author  @Youssef Laarouchi : laarouchi_yous@yahoo.fr
 * 
 * 
 */

#ifndef ENGINE_H_
#define ENGINE_H_

#include <pthread.h>
#include <time.h>


#include "engine/parser.h"

#define BUFFER_SIZE 50

#define MAX_THREADS 100

#define TIMEOUT 300 //timeout in seconds, corresponding to the last received event.

typedef struct threadkey THREADKEY;

typedef struct threadargs THREADARGS; 

typedef struct engine ENGINE; 
typedef ENGINE* ENGINE_PTR;

//ENGINE * engineCreate(FILE * fp, ACTION* actions,void * unit_ptr);
ENGINE * engineCreate(int fp, ACTION* actions,void * unit_ptr);

void engineDispatchEvent (ENGINE * engine, EVENT * event);

int initEngine(char * state, int tid,ENGINE_PTR engine);

char * getCurrentState(int tid,ENGINE_PTR engine) ;

struct threadargs {
	ENGINE_PTR engine;
	int position;
};

struct threadkey {
	char * current_state;
	int tid;
	pthread_t consumer;
	pthread_t * producer;
	pthread_mutex_t mutex;
	pthread_cond_t condition_var;
	EVENT_PTR eventstab[BUFFER_SIZE];
	int nb_events;
	
};


struct engine {
	THREADKEY threads[MAX_THREADS];
	int unused_threads[MAX_THREADS];
	//int n_threads;
	EVENTDEF * events;
	int nb_defined_events;
	GRAPH * graph;
	pthread_mutex_t threads_mutex; //Critical section for threads table	
	void * unit_ptr;
	int test;
};	


int streamExists(ENGINE_PTR engine,int tid);
int insertStream(ENGINE_PTR engine, char * state,int tid);

#endif /*ENGINE_H_*/
