/*
 * 
 *             Author  @Youssef Laarouchi : laarouchi_yous@yahoo.fr
 * 
 * 
 */

#ifndef GRAPH_H_
#define GRAPH_H_

//#include "event/event.h"
#include "engine/action.h"
#include <stdio.h>

#define NODE struct _NODE
#define ARC struct _arc

/*
typedef struct action ACTION; 

struct  action{
	char * name;
	int type;
	union {
		void (* function1)(char*);
		void (* function2)(SDPEVENT);
	} function;
	char * arguments;
	ACTION * next_action;
} ;
*/

NODE
{
  char *name;
  int marque;
  ARC *arcs;                    /* liste d'arcs */
  NODE *next;               /* dans le GRAPH */
  ACTION * entry;
};

ARC
{
  NODE *node;
  int cost;
  ARC *next;
  char * filter;
  ACTION * actions;
  
};

typedef struct
{
  NODE *nodes;
  int n_nodes;
  //int n_processes;
  //char ** processes;
  
  
} GRAPH;

#define CHEMIN struct _chemin

struct _chemin
{
  NODE *node;
  int cost;
  CHEMIN *next;
};

NODE * new_node(const char *nom,ACTION * entry);

NODE * insert_node(GRAPH *graph, NODE *node);

NODE * find_node(const GRAPH *GRAPH, const char *nom);

NODE * add_node(GRAPH *GRAPH, const char *nom,ACTION * entry);

void add_arc(NODE *depart, const NODE *arrivee, char *filter, ACTION * actions);

GRAPH * read_graph(FILE *entree);

void printGraph(GRAPH * graph);

int stateExists(const GRAPH *graph, const char *name);

void printPaths(const GRAPH *graph, NODE *depart,const NODE *arrivee);





#endif /*GRAPH_H_*/
