#ifndef _LISTENERS_H_

#define _LISTENERS_H_

//#include "event/event.h"
#include "unit/unit.h"
#include "parser/parser.h"
#include "composer/composer.h"
#include "monitor/monitor.h"

typedef struct listener {
	enum list_type {
		LISTENER_PARSER = 0,
		LISTENER_COMPOSER = 1,
		LISTENER_UNIT = 2,
		LISTENER_SOCKET = 3,
		LISTENER_MONITOR = 4,
		LISTENER_UNIT_PROXY = 5
	} type;
	union {
		struct parser* parser;
		struct composer* composer;
		struct unit* unit;
		struct socket* socket;
		struct monitor* monitor;
	} listener;
} LISTENER;
typedef LISTENER* LISTENER_PTR;

typedef struct listener_list_entry {
	LISTENER_PTR node;
	//struct listener* node;
	struct listener_list_entry* next;
} LISTENER_LIST_ENTRY;
typedef LISTENER_LIST_ENTRY* LISTENER_LIST_ENTRY_PTR;
typedef LISTENER_LIST_ENTRY* LISTENER_LIST_PTR;


#endif //_LISTENERS_H_
