#ifndef _MONITOR_H_
#define _MONITOR_H_

#include "socket/socket.h"
#include "unit/unit.h"
#include "event/servicedef.h"


typedef struct unit* (*FUNC_UNIT_FACTORY)();


typedef struct monitor_entry 
{
	struct socket* socket;
	FUNC_UNIT_FACTORY unit_factory;
	
	struct unit* unit;
	
} MONITORENTRY;
typedef MONITORENTRY* MONITORENTRY_PTR;


typedef struct monitor {
	
	// unit is a msg subscriber 
	void (*func_msg_received)(struct msg*, struct listener*);
	
} MONITOR;
typedef MONITOR* MONITOR_PTR;

// monitor is a msg subscriber 
void monitor_msg_received(struct msg* msg, struct listener* node);


/*
 * AVOID LOOP ENTRY TABLE
 * 
 */
typedef struct avoidlooptable_entry
{
	char* src_ip;
	int src_port;
	char* dest_ip;
	int dest_port;	
	struct avoidlooptable_entry* next;
} AVOIDLOOPTABLEENTRY;
typedef AVOIDLOOPTABLEENTRY* AVOIDLOOPTABLEENTRY_PTR;

void avoidlooptable_addentry(char* src_ip, int src_port, char* dest_ip, int dest_port);
int avoidlooptable_containsentry(char* src_ip, int src_port, char* dest_ip, int dest_port);

static AVOIDLOOPTABLEENTRY_PTR AvoidLoopTable = NULL;

/*
 * SERVICE DEFINITON TABLE
 * 
 */

PATH_SERVICEDEF_PTR ServiceDefinitionTable; // table that associates servicedefinitions to 
					    // the related path used in SOAP message calls 
					    // in POST of the HTTP HEADER





void *exec_rmi_registry(void* port_ptr);

#endif //_MONITOR_H_

