#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>

#include "parser/parser.h"
#include "event/event.h"

#include "protocol/WSDL.h"
#include "protocol/wsdlmsg.h"
#define TAG_START '<'
#define TAG_END '>'
#define SPACE ' '
#define QUESTIONMARK '?'
#define MARKUP_END_TAG "</"
#define MARKUP_END_TAG_OTHER "/>"

#define TRUE 0
#define FALSE 1

#define FILE_PATH "wsdl.xml"

#define STR_XML_TAG "?xml"
#define STR_DEFINITION_TAG "wsdl:definitions"
#define STR_TYPES_TAG "wsdl:types"
#define STR_MESSAGE_TAG "wsdl:message"
#define STR_PORTTYPE_TAG "wsdl:portType"
#define STR_BINDING_TAG "wsdl:binding"
#define STR_SOAP_BINDING_TAG "soap:binding"
#define STR_SERVICE_TAG "wsdl:service"
#define STR_PORT_TAG "wsdl:port"
#define STR_ADDRESS_TAG "soap:address"
#define STR_SCHEMA_TAG "s:schema"
#define STR_PART_TAG "wsdl:part"
#define STR_OPERATION_TAG "wsdl:operation"
#define STR_INPUT_TAG "wsdl:input"
#define STR_OUTPUT_TAG "wsdl:output"
#define STR_PART_TAG "wsdl:part"
#define STR_SOAP_OP_TAG "soap:operation"
#define STR_SOAP_BODY_TAG "soap:body"
#define STR_COMPLEX_TYPE "s:complexType"
#define STR_SEQUENCE "s:sequence"

#define STR_NAME "name"
#define STR_ELEMENT "element"
#define STR_TYPE "type"
#define STR_MESSAGE "message"
#define STR_BINDING "binding"
#define STR_LOCATION "location"
#define STR_TRANSPORT "transport"
#define STR_STYLE "style"
#define STR_SOAP_ACTION "soapAction"
#define STR_USE "use"
#define STR_ELEMENT_FORM_DEFAULT "elementFormDefault"
#define STR_TARGET_NAMESPACE "targetNamespace"
#define STR_MINOCCURS "minOccurs"
#define STR_MAXOCCURS "maxOccurs"

void ExtractFunctionDefinitions(PARSER_PTR , EVENTSRC_PTR );
void readFile();
void ParseDefinition(WSDLMSG*,char *);
void ParseTypes(WSDLMSG*,char *);
void ParseSchema(WSDLMSG*,char *);
void ParseSequence(WSDLMSG*,SEQUENCE*,char *);
void ParseComplexType(WSDLMSG*,COMPLEX_TYPE*,char *);
void ParseElementHead(WSDLMSG*,ELEMENT_HEAD*,char *);
void ParsePartElement(char *);
void ParsePortType(WSDLMSG*,char *);
void ParseBinding(WSDLMSG*,char *);
//void ParseBindingOperation(WSDLMSG*,BINDIN_OP*,char *);
void ParseBindingOperation(WSDLMSG*,BINDING_OP*, char *);
void ParseOperation(OPERATION*,char *);
void ParseInputSoapBody(WSDLMSG*,char *);
void ParseOutputSoapBody(WSDLMSG*,char *);
void ParseService(WSDLMSG*,char *);
void ParsePort(WSDLMSG*,char *);
void ParseMessageElement(char *);
void ParseMessage(WSDLMSG *,char *);
void ParsePartElement(char *);
char* ExtractAttributeByTag(char *,char *);





