#ifndef _HTTPMSG_H_

#define _HTTPMSG_H_


typedef struct http_header {
	char* name;
	char* value;
	struct http_header* next;
}HTTP_HEADER;
typedef HTTP_HEADER* HTTP_HEADER_PTR;

typedef struct http_msg {		

	char* method;
	char* version;
	char* uri;
	char* code;
	
	HTTP_HEADER_PTR headers;
	
	char* src_addr;
	int src_port;
	char* dest_addr;
	int dest_port;

	char* content;
	int content_size;
	
} HTTPMSG;
typedef HTTPMSG* HTTPMSG_PTR;

HTTPMSG_PTR httpmsg_create();
int httpmsg_set_method(HTTPMSG_PTR msg, char* method);
char* httpmsg_get_method(HTTPMSG_PTR msg);
int httpmsg_set_version(HTTPMSG_PTR msg, char* version);
char* httpmsg_get_version(HTTPMSG_PTR msg);
int httpmsg_set_uri(HTTPMSG_PTR msg, char* uri);
char* httpmsg_get_uri(HTTPMSG_PTR msg);
int httpmsg_set_code(HTTPMSG_PTR msg, char* code);
char* httpmsg_get_code(HTTPMSG_PTR msg);

int httpmsg_add_header(HTTPMSG_PTR msg, char* name, char* value);
char* httpmsg_get_header(HTTPMSG_PTR msg, char* name);
HTTP_HEADER_PTR httpmsg_get_headers(HTTPMSG_PTR msg);



char* httpmsg_get_src_addr(HTTPMSG_PTR msg);
int httpmsg_get_src_port(HTTPMSG_PTR msg);
char* httpmsg_get_dest_addr(HTTPMSG_PTR msg);
int httpmsg_get_dest_port(HTTPMSG_PTR msg);

void httpmsg_get_content(HTTPMSG_PTR msg, char** content, int* content_size);
void httpmsg_set_content(HTTPMSG_PTR msg, char* content, int content_size);


#endif //_HTTPMSG_H_
