#ifndef _RMI_H_
#define _RMI_H_

       /** Transport magic number: "JRMI"*/
    #define Magic 0x4a524d49
    /** Transport version number */
    #define Version 2

    /** Connection uses stream protocol */
    #define StreamProtocol  0x4b
    /** Protocol for single operation per connection; no ack required */
    #define SingleOpProtocol  0x4c
    /** Connection uses multiplex protocol - not used in rmime */
    #define MultiplexProtocol  0x4d

    /** Ack for transport protocol */
    #define ProtocolAck  0x4e
    /** Negative ack for transport protocol (protocol not supported) */
    #define ProtocolNack  0x4f

    /** RMI call */
    #define Call  0x50
    /** RMI return */
    #define Return  0x51
    /** Ping operation */
    #define Ping  0x52
    /** Acknowledgment for Ping operation */
    #define PingAck  0x53
    /** Acknowledgment for distributed GC */
    #define DGCAck  0x54

    /** Normal return (with or without return value) */
    #define NormalReturn  0x01
    /** Exceptional return */
    #define ExceptionalReturn  0x02

    /** Well known port for registry. */
    #define REGISTRY_PORT  1099

//    #define STREAM_MAGIC  0xaced;
    #define STREAM_VERSION  5
/*
    #define TC_BLOCKDATA     0x77
    #define TC_RESET         0x79
    #define TC_MAX           0x7B
    #define TC_BASE  0x70
*/
    #define interfaceHash  4905912898345647071L

#endif
