#ifndef _SSDPMSG_H_

#define _SSDPMSG_H_


typedef struct ssdp_header {
	char* name;
	char* value;
	struct ssdp_header* next;
}SSDP_HEADER;
typedef SSDP_HEADER* SSDP_HEADER_PTR;

typedef struct ssdp_msg {		

	char* method;
	char* version;
	char* uri;
	char* code;
	
	SSDP_HEADER_PTR headers;
	
	char* src_addr;
	int src_port;
	char* dest_addr;
	int dest_port;

	int isSearch;
	int isReply;
	
} SSDPMSG;
typedef SSDPMSG* SSDPMSG_PTR;

SSDPMSG_PTR ssdpmsg_create();
int ssdpmsg_set_method(SSDPMSG_PTR msg, char* method);
char* ssdpmsg_get_method(SSDPMSG_PTR msg);
int ssdpmsg_set_version(SSDPMSG_PTR msg, char* version);
char* ssdpmsg_get_version(SSDPMSG_PTR msg);
int ssdpmsg_set_uri(SSDPMSG_PTR msg, char* uri);
char* ssdpmsg_get_uri(SSDPMSG_PTR msg);
int ssdpmsg_set_code(SSDPMSG_PTR msg, char* code);
char* ssdpmsg_get_code(SSDPMSG_PTR msg);
int ssdpmsg_add_header(SSDPMSG_PTR msg, char* name, char* value);
char* ssdpmsg_get_header(SSDPMSG_PTR msg, char* name);
SSDP_HEADER_PTR ssdpmsg_get_headers(SSDPMSG_PTR msg);

char* ssdp_get_location(SSDPMSG_PTR msg);

char* ssdpmsg_get_src_addr(SSDPMSG_PTR msg);
int ssdpmsg_get_src_port(SSDPMSG_PTR msg);
char* ssdpmsg_get_dest_addr(SSDPMSG_PTR msg);
int ssdpmsg_get_dest_port(SSDPMSG_PTR msg);


int ssdpmsg_isSearch(SSDPMSG_PTR msg);
int ssdpmsg_set_isSearch(SSDPMSG_PTR msg);
int ssdpmsg_isReply(SSDPMSG_PTR msg);
int ssdpmsg_set_isReply(SSDPMSG_PTR msg);


#endif //_SSDPMSG_H_
