#ifndef _WSDMSG_H_

#define _WSDMSG_H_ 

typedef struct wsd_msg 
{		
	int message_type;
	char *action;
	char *message_id;
	char *to;
	char *relates_to;
	char *instance_id;
	int message_number;
	
	char *types;
	char *matchby;
	char *scopes;
	char *address;
	char *xaddrs;
	char *meta_data_version;		
	
	char *no_url;
	char *url;
	
	char* src_addr;
	int src_port;
	char* dest_addr;
	int dest_port;
}WSDMSG;
typedef WSDMSG* WSDMSG_PTR;

WSDMSG_PTR wsdmsg_create();

void wsd_PrintWSDMSG(WSDMSG_PTR);

int wsdmsg_set_message_type(WSDMSG_PTR msg, int message_type);
int wsdmsg_set_action(WSDMSG_PTR msg, char* action);
int wsdmsg_set_message_id(WSDMSG_PTR msg, char* message_id);
int wsdmsg_set_to(WSDMSG_PTR msg,char* to);
int wsdmsg_set_relates_to(WSDMSG_PTR msg, char* relates_to);
int wsdmsg_set_instance_id(WSDMSG_PTR msg, char* instance_id);
int wsdmsg_set_message_number(WSDMSG_PTR msg, int message_number);
int wsdmsg_set_types(WSDMSG_PTR msg, char* types);
int wsdmsg_set_matchby(WSDMSG_PTR msg, char* matchby);
int wsdmsg_set_scopes(WSDMSG_PTR msg, char* scopes);
int wsdmsg_set_address(WSDMSG_PTR msg, char* address);
int wsdmsg_set_xaddrs(WSDMSG_PTR msg, char* xaddrs);
int wsdmsg_set_meta_data_version(WSDMSG_PTR msg, char* meta_data_version);
int wsdmsg_set_src_addr(WSDMSG_PTR msg, char* src_addr);
int wsdmsg_set_src_port(WSDMSG_PTR msg, int src_port);
int wsdmsg_set_dest_addr(WSDMSG_PTR msg, char* dest_addr);
int wsdmsg_set_dest_port(WSDMSG_PTR msg, int dest_port);
int wsdmsg_set_no_url(WSDMSG_PTR msg, char* no_url);
int wsdmsg_set_url(WSDMSG_PTR msg, char* url);

int wsdmsg_get_message_type(WSDMSG_PTR msg);
char* wsdmsg_get_action(WSDMSG_PTR msg);
char* wsdmsg_get_message_id(WSDMSG_PTR msg);
char* wsdmsg_get_to(WSDMSG_PTR msg);
char* wsdmsg_get_relates_to(WSDMSG_PTR msg);
char* wsdmsg_get_instance_id(WSDMSG_PTR msg);
int wsdmsg_get_message_number(WSDMSG_PTR msg);
char* wsdmsg_get_types(WSDMSG_PTR msg);
char* wsdmsg_get_matchby(WSDMSG_PTR msg);
char* wsdmsg_get_scopes(WSDMSG_PTR msg);
char* wsdmsg_get_address(WSDMSG_PTR msg);
char* wsdmsg_get_xaddrs(WSDMSG_PTR msg);
char* wsdmsg_get_no_url(WSDMSG_PTR msg);
char* wsdmsg_get_url(WSDMSG_PTR msg);
char* wsdmsg_get_meta_data_version(WSDMSG_PTR msg);
char* wsdmsg_get_src_addr(WSDMSG_PTR msg);
int wsdmsg_get_src_port(WSDMSG_PTR msg);
char* wsdmsg_get_dest_addr(WSDMSG_PTR msg);
int wsdmsg_get_dest_port(WSDMSG_PTR msg);

#endif
