#ifndef _JFIELDS_H_
#define _JFIELDS_H_
#ifndef _JTYPE_H_
#include <io/jtype.h>
#endif 
#ifndef _JCONST_H_
#include <io/jconst.h>
#endif 
#ifndef _CLASSFILE_H_
#include <vm/jclass.h>
#endif
#ifndef _ATTRIBUTES_H_
#include <vm/attributes.h>
#endif

#define ACC_PUBLIC 		0x0001 	
#define ACC_PRIVATE 	0x0002 	
#define ACC_PROTECTED 	0x0004 	
#define ACC_STATIC 		0x0008 	
#define ACC_FINAL 		0x0010 	
#define ACC_VOLATILE 	0x0040 	
#define ACC_TRANSIENT 	0x0080 	


struct Field {
	POOL_PTR pool;
	uint16 access_flags;
	uint16* name_index;
	uint16* descriptor_index;
	uint16 attributes_count;
	list_t* listAttributes;
};

typedef struct Field FIELD;
typedef FIELD* FIELD_PTR;


extern FIELD_PTR field_new(POOL_PTR pool,uint16 flag,const char* name,const char* signature);
extern ATTR_PTR field_add_attribute(FIELD_PTR field, const char* type);


FIELD_PTR field_new_with_fixed_index(POOL_PTR pool, uint16 flag, uint16 name_index, uint16 descriptor_index);
ATTR_PTR field_get_attribute(FIELD_PTR field, const char* type);

#endif
