#ifndef _CLASSFILE_H_
#define _CLASSFILE_H_
#ifndef _JTYPE_H_
#include <io/jtype.h>
#endif 
#ifndef _CONSTANTPOOL_H_
#include <vm/constantpoolinfo.h>
#endif 
#ifndef _FIELDS_H_
#include <vm/fields.h>
#endif 

#include <vm/jmethods.h>



#define ACC_PUBLIC     	0x0001 	
#define ACC_PRIVATE 	0x0002 	
#define ACC_PROTECTED 	0x0004 	
#define ACC_STATIC     	0x0008 	
#define ACC_FINAL      	0x0010 	
#define ACC_VOLATILE 	0x0040 	
#define ACC_TRANSIENT 	0x0080 	

struct jClass
{
	uint16 minor;
	uint16 major;
	j_short modifier;
	POOL_PTR pool; 	
	uint16* indexClassName;
	uint16* indexSuperClassName;
	j_short nbInterfaces;		
	uint16** tabInterface; 		
	list_t* listFields; 		
	list_t* listMethods; 		
	list_t* listAttributes;		
};

typedef struct jClass JCLASS;
typedef JCLASS* JCLASS_PTR;
extern JCLASS_PTR new_class(const char* name,const char* signature);
extern FIELD_PTR class_add_field(JCLASS_PTR jclass,uint16 flag,const char* fieldName\
								,const char* signature);
extern FIELD_PTR class_add_method(JCLASS_PTR jclass,uint16 access,const char* methodName\
								,const char* signature);


extern int class_finalize(JCLASS_PTR jclass);
extern int class_write_to_byte_array(JCLASS_PTR jclass);
extern void class_write_attributes(int fd, FIELD_PTR field);
extern void class_write_fields(int fd,uint8 b,JCLASS_PTR cls);
extern void class_print_pool(JCLASS_PTR,TAG tag);
extern void class_write_code(int fd, ATTR_PTR attr);
extern void class_write_exception(int fd, ATTR_CODE_PTR  instr);
extern int class_nb_arguments(const char* str);


JCLASS_PTR new_class0();

FIELD_PTR class_get_method(JCLASS_PTR jclass, uint16 flag, const char* methodName, const char* signature);
FIELD_PTR class_get_field(JCLASS_PTR jclass, uint16 flag, const char* fieldName, const char* type);


FIELD_PTR class_add_field_with_fixed_index(JCLASS_PTR jclass, uint16 flag, uint16 name_index, uint16 descriptor_index);
FIELD_PTR class_add_method_with_fixed_index(JCLASS_PTR jclass, uint16 flag, uint16 name_index, uint16 descriptor_index);


JCLASS_PTR class_parse_charPtr(char* stream);
void get_method_arg_names(FIELD_PTR meth, JMETHOD_PTR meth_tmp);
void get_methods(JCLASS_PTR jclass, uint16 access_flags, JMETHODS_PTR jmeths/*char* methNames[], char* methSignatures[], int* nMeth*/);
void get_public_methods(JCLASS_PTR jclass, JMETHODS_PTR meths/*char* methNames[], char* methSignatures[],  int* nMeth */);
JMETHODS_PTR create_JMethods();
JMETHOD_PTR create_JMethod();
JMETHOD_PTR create_JMethod_2(char* name, char* signature);
int JMethod_add_arg(JMETHOD_PTR meth, char* name, char* type);

#endif
