#ifndef _OPCODE_H_
#define _OPCODE_H_


#define OP_NOP              0 //0x00
#define OP_ACONST_NULL      1 //0x01
#define OP_ICONST_M1        2 //0x02
#define OP_ICONST_0         3 //0x03
#define OP_ICONST_1         4 //0x04
#define OP_ICONST_2         5 //0x05
#define OP_ICONST_3         6 //0x06
#define OP_ICONST_4         7 //0x07
#define OP_ICONST_5         8 //0x08
#define OP_LCONST_0         9 //0x09
#define OP_LCONST_1         10//0x0a
#define OP_FCONST_0         11//0x0b
#define OP_FCONST_1         12//0x0c
#define OP_FCONST_2         13//0x0d
#define OP_DCONST_0         14//0x0e
#define OP_DCONST_1         15//0x0f
#define OP_BIPUSH           16//0x10
#define OP_SIPUSH           17//0x11
#define OP_LDC              18//0x12
#define OP_LDC_W            19//0x13
#define OP_LDC2_W           20//0x14
#define OP_ILOAD            21//0x15
#define OP_LLOAD            22//0x16
#define OP_FLOAD            23//0x17
#define OP_DLOAD            24//0x18
#define OP_ALOAD            25//0x19
#define OP_ILOAD_0          26//0x1a
#define OP_ILOAD_1          27//0x1b
#define OP_ILOAD_2          28//0x1c
#define OP_ILOAD_3          29//0x1d
#define OP_LLOAD_0          30//0x1e
#define OP_LLOAD_1          31//0x1f
#define OP_LLOAD_2          32//0x20
#define OP_LLOAD_3          33//0x21
#define OP_FLOAD_0          34//0x22
#define OP_FLOAD_1          35//0x23
#define OP_FLOAD_2          36//0x24
#define OP_FLOAD_3          37//0x25
#define OP_DLOAD_0          38//0x26
#define OP_DLOAD_1          39//0x27
#define OP_DLOAD_2          40//0x28
#define OP_DLOAD_3          41//0x29
#define OP_ALOAD_0          42//0x2a
#define OP_ALOAD_1          43//0x2b
#define OP_ALOAD_2          44//0x2c
#define OP_ALOAD_3          45//0x2d
#define OP_IALOAD           46//0x2e
#define OP_LALOAD           47//0x2f
#define OP_FALOAD           48//0x30
#define OP_DALOAD           49//0x31
#define OP_AALOAD           50//0x32
#define OP_BALOAD           51//0x33
#define OP_CALOAD           52//0x34	
#define OP_SALOAD           53//0x35
#define OP_ISTORE           54//0x36
#define OP_LSTORE           55//0x37
#define OP_FSTORE           56//0x38
#define OP_DSTORE           57//0x39
#define OP_ASTORE           58//0x3a
#define OP_ISTORE_0         59//0x3b
#define OP_ISTORE_1         60//0x3c
#define OP_ISTORE_2         61//0x3d
#define OP_ISTORE_3         62//0x3e
#define OP_LSTORE_0         63//0x3f
#define OP_LSTORE_1         64//0x40
#define OP_LSTORE_2         65//0x41
#define OP_LSTORE_3         66//0x42
#define OP_FSTORE_0         67//0x43
#define OP_FSTORE_1         68//0x44
#define OP_FSTORE_2         69//0x45
#define OP_FSTORE_3         70//0x46
#define OP_DSTORE_0         71//0x47
#define OP_DSTORE_1         72//0x48
#define OP_DSTORE_2         73//0x49
#define OP_DSTORE_3         74//0x4a
#define OP_ASTORE_0         75//0x4b
#define OP_ASTORE_1         76//0x4c
#define OP_ASTORE_2         77//0x4d
#define OP_ASTORE_3         78//0x4e
#define OP_IASTORE          79//0x4f
#define OP_LASTORE          80//0x50
#define OP_FASTORE          81//0x51
#define OP_DASTORE          82//0x52
#define OP_AASTORE          83//0x53
#define OP_BASTORE          84//0x54
#define OP_CASTORE          85//0x55
#define OP_SASTORE          86//0x56
#define OP_POP              87//0x57
#define OP_POP2             88//0x58
#define OP_DUP              89//0x59
#define OP_DUP_X1           90//0x5a
#define OP_DUP_X2           91//0x5b
#define OP_DUP2             92//0x5c
#define OP_DUP2_X1          93//0x5d
#define OP_DUP2_X2          94//0x5e
#define OP_SWAP             95//0x5f
#define OP_IADD             96//0x60
#define OP_LADD             97//0x61
#define OP_FADD             98//0x62
#define OP_DADD             99//0x63
#define OP_ISUB             100//0x64
#define OP_LSUB             101//0x65
#define OP_FSUB             102//0x66
#define OP_DSUB             103//0x67
#define OP_IMUL             104//0x68
#define OP_LMUL             105//0x69
#define OP_FMUL             106//0x6a
#define OP_DMUL             107//0x6b
#define OP_IDIV             108//0x6c
#define OP_LDIV             109//0x6d
#define OP_FDIV             110//0x6e
#define OP_DDIV             111//0x6f
#define OP_IREM             112//0x70
#define OP_LREM             113//0x71
#define OP_FREM             114//0x72
#define OP_DREM             115//0x73
#define OP_INEG             116//0x74
#define OP_LNEG             117//0x75
#define OP_FNEG             118//0x76
#define OP_DNEG             119//0x77
#define OP_ISHL             120//0x78
#define OP_LSHL             121//0x79
#define OP_ISHR             122
#define OP_LSHR             123
#define OP_IUSHR            124
#define OP_LUSHR            125
#define OP_IAND             126
#define OP_LAND             127
#define OP_IOR              (uint8) 128
#define OP_LOR              (uint8) 129
#define OP_IXOR             (uint8) 130
#define OP_LXOR             (uint8) 131
#define OP_IINC             (uint8) 132
#define OP_I2L              (uint8) 133
#define OP_I2F              (uint8) 134
#define OP_I2D              (uint8) 135
#define OP_L2I              (uint8) 136
#define OP_L2F              (uint8) 137
#define OP_L2D              (uint8) 138
#define OP_F2I              (uint8) 139
#define OP_F2L              (uint8) 140
#define OP_F2D              (uint8) 141
#define OP_D2I              (uint8) 142
#define OP_D2L              (uint8) 143
#define OP_D2F              (uint8) 144
#define OP_I2B              (uint8) 145
#define OP_I2C              (uint8) 146
#define OP_I2S              (uint8) 147
#define OP_LCMP             (uint8) 148
#define OP_FCMPL            (uint8) 149
#define OP_FCMPG            (uint8) 150
#define OP_DCMPL            (uint8) 151
#define OP_DCMPG            (uint8) 152
#define OP_IFEQ             (uint8) 153
#define OP_IFNE             (uint8) 154
#define OP_IFLT             (uint8) 155
#define OP_IFGE             (uint8) 156
#define OP_IFGT             (uint8) 157
#define OP_IFLE             (uint8) 158
#define OP_IF_ICMPEQ        (uint8) 159
#define OP_IF_ICMPNE        (uint8) 160
#define OP_IF_ICMPLT        (uint8) 161
#define OP_IF_ICMPGE        (uint8) 162
#define OP_IF_ICMPGT        (uint8) 163
#define OP_IF_ICMPLE        (uint8) 164
#define OP_IF_ACMPEQ        (uint8) 165
#define OP_IF_ACMPNE        (uint8) 166
#define OP_GOTO             (uint8) 167//oxa7
#define OP_JSR              (uint8) 168
#define OP_RET              (uint8) 169
#define OP_TABLESWITCH      (uint8) 170
#define OP_LOOKUPSWITCH     (uint8) 171
#define OP_IRETURN          (uint8) 172//0xac
#define OP_LRETURN          (uint8) 173
#define OP_FRETURN          (uint8) 174
#define OP_DRETURN          (uint8) 175
#define OP_ARETURN          (uint8) 176
#define OP_RETURN           (uint8) 177
#define OP_GETSTATIC        (uint8) 178//0xb2
#define OP_PUTSTATIC        (uint8) 179//0xb3
#define OP_GETFIELD         (uint8) 180//0xb4
#define OP_PUTFIELD         (uint8) 181//0xb5
#define OP_INVOKEVIRTUAL    (uint8) 182//0xb6
#define OP_INVOKESPECIAL    (uint8) 183//0xb7
#define OP_INVOKESTATIC     (uint8) 184//0xb8
#define OP_INVOKEINTERFACE  (uint8) 185//0xb9
#define OP_NEW              (uint8) 187
#define OP_NEWARRAY         (uint8) 188
#define OP_ANEWARRAY        (uint8) 189
#define OP_ARRAYLENGTH      (uint8) 190
#define OP_ATHROW           (uint8) 191
#define OP_CHECKCAST        (uint8) 192 //0xc0
#define OP_INSTANCEOF       (uint8) 193
#define OP_MONITORENTER     (uint8) 194
#define OP_MONITOREXIT      (uint8) 195
#define OP_WIDE             (uint8) 196
#define OP_MULTIANEWARRAY   (uint8) 197
#define OP_IFNULL           (uint8) 198//0xc6
#define OP_IFNONNULL        (uint8) 199
#define OP_GOTO_W           (uint8) 200
#define OP_JSR_W            (uint8) 201

/*
* Global variable perhaps need to be defined as private : static
*/
static char* opcode[][3] = {
      {"0x00", "1", "nop"},
      {"0x01", "1", "aconst_null"},
      {"0x02", "1", "iconst_m1"},
      {"0x03", "1", "iconst_0"},
      {"0x04", "1", "iconst_1"},
      {"0x05", "1", "iconst_2"},
      {"0x06", "1", "iconst_3"},
      {"0x07", "1", "iconst_4"},
      {"0x08", "1", "iconst_5"},
      {"0x09", "1", "lconst_0"},
      {"0x0a", "1", "lconst_1"},
      {"0x0b", "1", "fconst_0"},
      {"0x0c", "1", "fconst_1"},
      {"0x0d", "1", "fconst_2"},
      {"0x0e", "1", "dconst_0"},
      {"0x0f", "1", "dconst_1"},
      {"0x10", "2", "bipush"},
      {"0x11", "3", "sipush"},
      {"0x12", "2", "ldc"},
      {"0x13", "3", "ldc_w"},
      {"0x14", "3", "ldc2_w"},
      {"0x15", "2", "iload"},
      {"0x16", "2", "lload"},
      {"0x17", "2", "fload"},
      {"0x18", "2", "dload"},
      {"0x19", "2", "aload"},
      {"0x1a", "1", "iload_0"},
      {"0x1b", "1", "iload_1"},
      {"0x1c", "1", "iload_2"},
      {"0x1d", "1", "iload_3"},
      {"0x1e", "1", "lload_0"},
      {"0x1f", "1", "lload_1"},
      {"0x20", "1", "lload_2"},
      {"0x21", "1", "lload_3"},
      {"0x22", "1", "fload_0"},
      {"0x23", "1", "fload_1"},
      {"0x24", "1", "fload_2"},
      {"0x25", "1", "fload_3"},
      {"0x26", "1", "dload_0"},
      {"0x27", "1", "dload_1"},
      {"0x28", "1", "dload_2"},
      {"0x29", "1", "dload_3"},
      {"0x2a", "1", "aload_0"},
      {"0x2b", "1", "aload_1"},
      {"0x2c", "1", "aload_2"},
      {"0x2d", "1", "aload_3"},
      {"0x2e", "1", "iaload"},
      {"0x2f", "1", "laload"},
      {"0x30", "1", "faload"},
      {"0x31", "1", "daload"},
      {"0x32", "1", "aaload"},
      {"0x33", "1", "baload"},
      {"0x34", "1", "caload"},
      {"0x35", "1", "saload"},
      {"0x36", "2", "istore"},
      {"0x37", "2", "lstore"},
      {"0x38", "2", "fstore"},
      {"0x39", "2", "dstore"},
      {"0x3a", "2", "astore"},
      {"0x3b", "1", "istore_0"},
      {"0x3c", "1", "istore_1"},
      {"0x3d", "1", "istore_2"},
      {"0x3e", "1", "istore_3"},
      {"0x3f", "1", "lstore_0"},
      {"0x40", "1", "lstore_1"},
      {"0x41", "1", "lstore_2"},
      {"0x42", "1", "lstore_3"},
      {"0x43", "1", "fstore_0"},
      {"0x44", "1", "fstore_1"},
      {"0x45", "1", "fstore_2"},
      {"0x46", "1", "fstore_3"},
      {"0x47", "1", "dstore_0"},
      {"0x48", "1", "dstore_1"},
      {"0x49", "1", "dstore_2"},
      {"0x4a", "1", "dstore_3"},
      {"0x4b", "1", "astore_0"},
      {"0x4c", "1", "astore_1"},
      {"0x4d", "1", "astore_2"},
      {"0x4e", "1", "astore_3"},
      {"0x4f", "1", "iastore"},
      {"0x50", "1", "lastore"},
      {"0x51", "1", "fastore"},
      {"0x52", "1", "dastore"},
      {"0x53", "1", "aastore"},
      {"0x54", "1", "bastore"},
      {"0x55", "1", "castore"},
      {"0x56", "1", "sastore"},
      {"0x57", "1", "pop"},
      {"0x58", "1", "pop2"},
      {"0x59", "1", "dup"},
      {"0x5a", "1", "dup_x1"},
      {"0x5b", "1", "dup_x2"},
      {"0x5c", "1", "dup2"},
      {"0x5d", "1", "dup2_x1"},
      {"0x5e", "1", "dup2_x2"},
      {"0x5f", "1", "swap"},
      {"0x60", "1", "iadd"},
      {"0x61", "1", "ladd"},
      {"0x62", "1", "fadd"},
      {"0x63", "1", "dadd"},
      {"0x64", "1", "isub"},
      {"0x65", "1", "lsub"},
      {"0x66", "1", "fsub"},
      {"0x67", "1", "dsub"},
      {"0x68", "1", "imul"},
      {"0x69", "1", "lmul"},
      {"0x6a", "1", "fmul"},
      {"0x6b", "1", "dmul"},
      {"0x6c", "1", "idiv"},
      {"0x6d", "1", "ldiv"},
      {"0x6e", "1", "fdiv"},
      {"0x6f", "1", "ddiv"},
      {"0x70", "1", "irem"},
      {"0x71", "1", "lrem"},
      {"0x72", "1", "frem"},
      {"0x73", "1", "drem"},
      {"0x74", "1", "ineg"},
      {"0x75", "1", "lneg"},
      {"0x76", "1", "fneg"},
      {"0x77", "1", "dneg"},
      {"0x78", "1", "ishl"},
      {"0x79", "1", "lshl"},
      {"0x7a", "1", "ishr"},
      {"0x7b", "1", "lshr"},
      {"0x7c", "1", "iushr"},
      {"0x7d", "1", "lushr"},
      {"0x7e", "1", "iand"},
      {"0x7f", "1", "land"},
      {"0x80", "1", "ior"},
      {"0x81", "1", "lor"},
      {"0x82", "1", "ixor"},
      {"0x83", "1", "lxor"},
      {"0x84", "3", "iinc"},
      {"0x85", "1", "i2l"},
      {"0x86", "1", "i2f"},
      {"0x87", "1", "i2d"},
      {"0x88", "1", "l2i"},
      {"0x89", "1", "l2f"},
      {"0x8a", "1", "l2d"},
      {"0x8b", "1", "f2i"},
      {"0x8c", "1", "f2l"},
      {"0x8d", "1", "f2d"},
      {"0x8e", "1", "d2i"},
      {"0x8f", "1", "d2l"},
      {"0x90", "1", "d2f"},
      {"0x91", "1", "i2b"},
      {"0x92", "1", "i2c"},
      {"0x93", "1", "i2s"},
      {"0x94", "1", "lcmp"},
      {"0x95", "1", "fcmpl"},
      {"0x96", "1", "fcmpg"},
      {"0x97", "1", "dcmpl"},
      {"0x98", "1", "dcmpg"},
      {"0x99", "3", "ifeq"},
      {"0x9a", "3", "ifne"},
      {"0x9b", "3", "iflt"},
      {"0x9c", "3", "ifge"},
      {"0x9d", "3", "ifgt"},
      {"0x9e", "3", "ifle"},
      {"0x9f", "3", "if_icmpeq"},
      {"0xa0", "3", "if_icmpne"},
      {"0xa1", "3", "if_icmplt"},
      {"0xa2", "3", "if_icmpge"},
      {"0xa3", "3", "if_icmpgt"},
      {"0xa4", "3", "if_icmple"},
      {"0xa5", "3", "if_acmpeq"},
      {"0xa6", "3", "if_acmpne"},
      {"0xa7", "3", "goto"},
      {"0xa8", "3", "jsr"},
      {"0xa9", "2", "ret"},
      {"0xaa", "0", "tableswitch"},
      {"0xab", "0", "lookupswitch"},
      {"0xac", "1", "ireturn"},
      {"0xad", "1", "lreturn"},
      {"0xae", "1", "freturn"},
      {"0xaf", "1", "dreturn"},
      {"0xb0", "1", "areturn"},
      {"0xb1", "1", "return"},
      {"0xb2", "3", "getstatic"},
      {"0xb3", "3", "putstatic"},
      {"0xb4", "3", "getfield"},
      {"0xb5", "3", "putfield"},
      {"0xb6", "3", "invokevirtual"},
      {"0xb7", "3", "invokespecial"},
      {"0xb8", "3", "invokestatic"},
      {"0xb9", "5", "invokeinterface"},
      {"0xba", "1", "xxxunusedxxx"},
      {"0xbb", "3", "new"},
      {"0xbc", "2", "newarray"},
      {"0xbd", "3", "anewarray"},
      {"0xbe", "1", "arraylength"},
      {"0xbf", "1", "athrow"},
      {"0xc0", "3", "checkcast"},
      {"0xc1", "3", "instanceof"},
      {"0xc2", "1", "monitorenter"},
      {"0xc3", "1", "monitorexit"},
      {"0xc4", "4", "wide"},
      {"0xc5", "4", "multianewarray"},
      {"0xc6", "3", "ifnull"},
      {"0xc7", "3", "ifnonnull"},
      {"0xc8", "5", "goto_w"},
      {"0xc9", "5", "jsr_w"},
      {"0xca", "1", "breakpoint"},
      {"0xcb", "1", "xxxunusedxxx"},
      {"0xcc", "1", "xxxunusedxxx"},
      {"0xcd", "1", "xxxunusedxxx"},
      {"0xce", "1", "xxxunusedxxx"},
      {"0xcf", "1", "xxxunusedxxx"},
      {"0xd0", "1", "xxxunusedxxx"},
      {"0xd1", "1", "xxxunusedxxx"},
      {"0xd2", "1", "xxxunusedxxx"},
      {"0xd3", "1", "xxxunusedxxx"},
      {"0xd4", "1", "xxxunusedxxx"},
      {"0xd5", "1", "xxxunusedxxx"},
      {"0xd6", "1", "xxxunusedxxx"},
      {"0xd7", "1", "xxxunusedxxx"},
      {"0xd8", "1", "xxxunusedxxx"},
      {"0xd9", "1", "xxxunusedxxx"},
      {"0xda", "1", "xxxunusedxxx"},
      {"0xdb", "1", "xxxunusedxxx"},
      {"0xdc", "1", "xxxunusedxxx"},
      {"0xdd", "1", "xxxunusedxxx"},
      {"0xde", "1", "xxxunusedxxx"},
      {"0xdf", "1", "xxxunusedxxx"},
      {"0xe0", "1", "xxxunusedxxx"},
      {"0xe1", "1", "xxxunusedxxx"},
      {"0xe2", "1", "xxxunusedxxx"},
      {"0xe3", "1", "xxxunusedxxx"},
      {"0xe4", "1", "xxxunusedxxx"},
      {"0xe5", "1", "xxxunusedxxx"},
      {"0xe6", "1", "xxxunusedxxx"},
      {"0xe7", "1", "xxxunusedxxx"},
      {"0xe8", "1", "xxxunusedxxx"},
      {"0xe9", "1", "xxxunusedxxx"},
      {"0xea", "1", "xxxunusedxxx"},
      {"0xeb", "1", "xxxunusedxxx"},
      {"0xec", "1", "xxxunusedxxx"},
      {"0xed", "1", "xxxunusedxxx"},
      {"0xee", "1", "xxxunusedxxx"},
      {"0xef", "1", "xxxunusedxxx"},
      {"0xf0", "1", "xxxunusedxxx"},
      {"0xf1", "1", "xxxunusedxxx"},
      {"0xf2", "1", "xxxunusedxxx"},
      {"0xf3", "1", "xxxunusedxxx"},
      {"0xf4", "1", "xxxunusedxxx"},
      {"0xf5", "1", "xxxunusedxxx"},
      {"0xf6", "1", "xxxunusedxxx"},
      {"0xf7", "1", "xxxunusedxxx"},
      {"0xf8", "1", "xxxunusedxxx"},
      {"0xf9", "1", "xxxunusedxxx"},
      {"0xfa", "1", "xxxunusedxxx"},
      {"0xfb", "1", "xxxunusedxxx"},
      {"0xfc", "1", "xxxunusedxxx"},
      {"0xfd", "1", "xxxunusedxxx"},
      {"0xfe", "1", "impdep1"},
      {"0xff", "1", "impdep2"}};

#endif
