/*
 * 
 *             Author  @Youssef Laarouchi : laarouchi_yous@yahoo.fr
 * 
 * 
 */

#include <time.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <errno.h>

#include "engine/engine.h"



char * getEventDescription(int eventtype,ENGINE_PTR engine) 
{

	int i;
	char * result;
	int nb_defined_events=engine->nb_defined_events;
	EVENTDEF * events=engine->events;
//	printf("getEventDescription toto O1 event type == %d  nbevents ==%d\n",eventtype,nb_defined_events);


	for(i=0;i<nb_defined_events;i++)
	{
		if (eventtype==(events[i].sdpevent)->type) 
		{
			result=events[i].name;
			break;
		}
	}
//	printf("getEventDescription toto O3 \n");
	return result;
	
}


int getEventCode(char * eventdesc,ENGINE_PTR engine) 
{

	int i;
	int result=0;
	int nb_defined_events=engine->nb_defined_events;
	EVENTDEF * events=engine->events;
	//printf("nombre d'evenements == %d\n",nb_defined_events);	
	for(i=0;i<nb_defined_events;i++) 
	{
		//printf("event desc == |%s| event[i]=|%s|\n",eventdesc,events[i].name);
		if (strcmp(eventdesc,events[i].name)==0) 
		{
			result=events[i].sdpevent->type;
			break;
		}
	}
	return result;
	
}


char * getCurrentState(int tid,ENGINE_PTR engine) 
{
	int i;
	char * result;
	
	//int n_threads=engine->n_threads;
	
	
	for(i=0;(i<MAX_THREADS) && (engine->threads[i].tid!=-1);i++)
	{
		if(engine->threads[i].tid==tid) 
		{
			result=engine->threads[i].current_state;
			break;
		}
	}
	
	return result;	
}


void setCurrentState(char * new_state,int tid,ENGINE_PTR engine) {
	int i;


	

	if(streamExists(engine,tid)==-1)
	{
			insertStream(engine, new_state,tid);
	}
	else 
	{
		for(i=0;(i<MAX_THREADS) && (engine->threads[i].tid!=-1);i++){
			if(engine->threads[i].tid==tid) {
				engine->threads[i].current_state=new_state;
				//printf("Changed current state to %s \n",new_state);
				break;
			}
		}
	}
	
	
	
	
	
}

void runActions (ACTION * actionslist, ENGINE_PTR engine, EVENT * event) 
{
	
	ACTION * action;
	for(action=actionslist;action!=NULL;action=action->next_action) {
				
				switch (action->type) {
						case 1 : 
								(* action->function.function1)(action->arguments[0]);	
								break;
						case 2 : 
								(* action->function.function2)(event);	
								break;
						case 3 : 
							 	(* action->function.function3)(engine->unit_ptr,action->arguments[0],action->arguments[1],event);	
								break;
                        case 4 :
                            (* action->function.function4)(event, engine->unit_ptr);
                             break;
                        case 5 :
                            (* action->function.function5)(engine->unit_ptr,action->arguments[0],action->arguments[1],action->arguments[2],event);
                             break;								
                        case 6 :
                            (* action->function.function6)(engine->unit_ptr,action->arguments[0],event);
                             break;	
                        default :
								printf("unknown function prototype \n");
								break;

				}		
	}
	
	
}





void treatEvent(ENGINE_PTR engine, EVENT * event) 
{

	int tid=(int)event->stream_id;

//	printf("current state == %s \n", getCurrentState(tid,engine));
	//printf("current event  %d == %s \n", event->type, getEventDescription(event->type));
	//sleep(2);
	NODE * node=find_node(engine->graph,getCurrentState(tid,engine));
	ARC * arc;
	
	int test=0;

//	printf("received events %s from thread %d\n",	
//				getEventDescription(event->type,engine),tid);
	for(arc=node->arcs;arc!=NULL;arc=arc->next) {
		//printf("event type == %d et filtre == %d",
		//		event->type,getEventCode(arc->filter));
		if((test==0)&&((strcmp(arc->filter,"")==0) || (event->type==getEventCode(arc->filter,engine))))
		{
			test=1;
			
			
			runActions(arc->actions,engine,event);
			
			if (node->entry!=NULL) {
				runActions(node->entry,engine,event);
			}
			setCurrentState(arc->node->name,tid,engine);
			printf("moved to %s\n",arc->node->name);
			//sleep(3);
			//break;			
			
		} 
	}
	
	if(test==0){
	//		printf("received event IGNORED\n");
	}
}

void * consumeEvent (void * args) {
	
	THREADARGS * threadargs =(THREADARGS *) args;
	//printf("consumeEvent : 00\n");
	ENGINE_PTR engine = threadargs->engine;
	int position = threadargs->position;
	EVENT_PTR event;
	int i;
	struct timespec ts;	
	
	
	int return_wait=0;
	
	
	while (1) {

		
		//gmtime(&ts.tv_sec);
		
		//getclock((timer_t)TIMEOFDAY, &ts);
		ts.tv_nsec=0;
		//ts.tv_sec+=TIMEOUT;		
		
		ts.tv_sec = time(NULL) + TIMEOUT;
				
	//	printf("consumeEvent : nb_events in list == %d\n",engine->threads[position].nb_events);
		pthread_mutex_lock(&(engine->threads[position].mutex));
		//printf("consumeEvent : 02\n");
		while(engine->threads[position].nb_events==0) {
			//printf("consumeEvent : 03\n");
			return_wait=pthread_cond_timedwait(&(engine->threads[position].condition_var),
									&(engine->threads[position].mutex),
									&ts);
			
			if (return_wait == ETIMEDOUT) {
				pthread_mutex_lock(&(engine->threads_mutex));
				for(i=0;(i<MAX_THREADS)&&(engine->unused_threads[i]!=-1);i++);
				
				if(i!=MAX_THREADS)
					engine->unused_threads[i]=position;
        		printf("Thread %d Wait timed out! je mets  disposition la position %d dans unused_thread[%d]\n",
        				engine->threads[position].tid,
        				position,i);
        		pthread_mutex_unlock(&(engine->threads_mutex));
        		pthread_mutex_unlock(&(engine->threads[position].mutex));
        		pthread_exit(NULL);
      		}
			
			//break;
		}
		//pthread_mutex_lock(&(engine->threads[position].mutex));
		engine->threads[position].nb_events--;
		event=engine->threads[position].eventstab[0];
		//printf("consumeEvent00001 : nb_events in list == %d\n",engine->threads[position].nb_events);
	
		if(engine->threads[position].nb_events<BUFFER_SIZE) 
			pthread_cond_signal(&(engine->threads[position].condition_var));
			
	
		for(i=0;i<engine->threads[position].nb_events;i++)
			engine->threads[position].eventstab[i]=engine->threads[position].eventstab[i+1];
		
		//printf("consumeEvent : 05\n");
		treatEvent(engine,event);
		//sleep(1);
		pthread_mutex_unlock(&(engine->threads[position].mutex));
		
		//printf("TIMEOUT 001 %d\n",time(NULL)-engine->threads[position].last_run_time);
		
		
			
	}
	pthread_exit(NULL);
}


int streamExists(ENGINE_PTR engine,int tid)
{
	int i,res;
	
	for(i=0;(i<MAX_THREADS) && (engine->threads[i].tid!=-1);i++){
			//printf("i = %d, n_threads=%d \n",i, *n_threads);
			//pthread_cond_signal(&(engine->threads[i].condition_var));
			if(engine->threads[i].tid==tid) {
				//printf("Thread already existant, don't nead initialisation\n");
				res=i;
				return res;
			}
	}
	
	if(engine->threads[i].tid==-1) 
		res=-1;
	return res;
	
}

int insertStream(ENGINE_PTR engine, char * state,int tid)
{
	
	int i=0;
	int index;
	
	
	pthread_attr_t attr;
	THREADARGS * threadargs= malloc(sizeof(THREADARGS));
	
//	printf("The event belongs to a new stream, i== %d\n",i);
	if(engine->unused_threads[0]!=-1) 
	{
		index=engine->unused_threads[0];
		engine->unused_threads[0]=-1;
//		printf("Found an empty place at position %d\n",index);
		for(i=0;(i<MAX_THREADS)&&(engine->unused_threads[i]!=-1);i++) 
			engine->unused_threads[i]=engine->unused_threads[i+1];
	} else {
		for(i=0;(i<MAX_THREADS) && (engine->threads[i].tid!=-1);i++);
		index=i;
	}
			
	engine->threads[index].current_state=state;
	engine->threads[index].tid=tid;
		
		
	pthread_mutex_init(&(engine->threads[index].mutex), NULL);
  	pthread_cond_init (&(engine->threads[index].condition_var), NULL);
  	engine->threads[index].nb_events=0;

	threadargs->engine=engine;
	threadargs->position=index;

		
	pthread_attr_init(&attr);
	pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_JOINABLE);
	pthread_create(&(engine->threads[index].consumer), &attr, consumeEvent, (void *)threadargs);

//	printf("inserted new thread n%d in position %d with current state == %s\n",
//			tid,index,engine->threads[index].current_state);
	
	return index;
}




/*
 * This function dispatches received events to a specific thread, respecting the source. 
 * One thread is created for each event stream, and mutex and condition variables are 
 * used to block the event treating threads until a new event is accepted.  
 */


void engineDispatchEvent (ENGINE * engine, EVENT * event) 
{
	
	int position;
	//pthread_attr_t attr;
	
	THREADARGS * threadargs= malloc(sizeof(THREADARGS));
	
//	printf("New event received from thread %d\n",event->stream_id);
	//During the initialisation of threads, no other process should access the engine
	pthread_mutex_lock(&(engine->threads_mutex));
	//position contains the position of the TID of event in the threads table
	//position=initEngine("IDLE",(int)event->stream_id,engine);
	
	if((position=streamExists(engine,(int)event->stream_id))==-1) 
	{
		NODE * node=find_node(engine->graph,"IDLE");
		if (node->entry!=NULL) {
			runActions(node->entry,engine,event);
		}
		position=insertStream(engine, "IDLE",(int)event->stream_id);
	}
	
	pthread_mutex_unlock(&(engine->threads_mutex));
	
	threadargs->engine=engine;
	threadargs->position=position;
	
		
	//Lock mutex before modifying the event list
	pthread_mutex_lock(&(engine->threads[position].mutex));
	
	
	engine->threads[position].eventstab[engine->threads[position].nb_events++]=event;
	
//	printf("Positio = %d Added event %s in waiting list and nb_events ==%d\n",position,
//			getEventDescription(event->type,engine),
//			engine->threads[position].nb_events);
	
	
	
	
	//The event is added, send a signal to wake up waiting threads.
	pthread_cond_signal(&(engine->threads[position].condition_var));
	
	//If the buffer size is reached, wait until an event is consumed
	if(engine->threads[position].nb_events==BUFFER_SIZE) 
	{
//		printf("waiting for a place in the event list \n");
		pthread_cond_wait(&(engine->threads[position].condition_var),&(engine->threads[position].mutex));
	}
	pthread_mutex_unlock(&(engine->threads[position].mutex));
	
	
	
	//pthread_join(engine->threads[position].consumer, NULL);
	//pthread_yield ();
	//sleep(1);
		
	
	
}



//ENGINE * engineCreate(FILE * fp, ACTION* actions,void * unit_ptr)
ENGINE * engineCreate(int fp, ACTION* actions,void * unit_ptr)
{

	ENGINE * engine = (ENGINE *) malloc(sizeof(ENGINE));
	
	PARSERESULT * parseresult;

	if(fp == NULL) 
	{
		fprintf(stderr, "Problem in file pointer\n");
	}
		
	int i;
	fprintf(stdout, "Creating unit10\n");
	parseresult=parse(fp, actions);
	engine->test=0;
	fprintf(stdout, "Creating unit11\n");
	engine->graph=parseresult->graph;
	engine->events=parseresult->events;
	engine->nb_defined_events=parseresult->nb_defined_events;
	engine->unit_ptr=unit_ptr;
	
	for(i=0;i<MAX_THREADS;i++) 
	{
		engine->unused_threads[i]=-1;
		engine->threads[i].tid=-1;
	}
	
		
	return engine;	
	
}








