#include <stdio.h>
#include <unistd.h>
#include <errno.h>

#include <sys/types.h>

#include <sys/time.h>
#include <string.h> //for strerror
#ifdef __WIN32__
#include <winsock2.h>
#else
#include <netinet/in.h> //for ntohl
#endif
#include <io/jtype.h>
#include <io/io.h>
#include <io/jconst.h>
//#include <io/utf8.h>



static j_byte peekb=-1;

int parseBytes_charPtr(char** stream,j_byte *buf, int *len)
{
 //int r= read(fd,(char *)buf,*len);
  int i;
  for (i=0; i< *len; i++)
    buf[i] = (*stream)[i];

  *stream += *len; 

 
  /*
  if(errno == EINTR)
  {		
  	fprintf(stdout, "CWD : %s %i\n", "parseBytes", errno);  
  	if (r < 1){
  		fprintf(stdout, "Error : %s %s\n", "parseBytes", strerror(errno));
  	}
  	return -1;
  }
	return 0;
  */
}

int parsejByte_charPtr(char** stream,j_byte *b)
{
    int len = sizeof(j_byte);
    return parseBytes_charPtr(stream, b, &len);
}

int parsejInt_charPtr(char** stream, j_int *ji)
{
	int ret=0;
	*ji=0;
	int len = sizeof(j_int);
	j_byte *b=(j_byte*)ji;
	ret=parseBytes_charPtr(stream,b,&len);
   *ji=(((*ji&0x000000ff)<<24)|
   		 ((*ji&0x0000ff00)<<8)|
   		 ((*ji&0x00ff0000)>>8)|
   		 ((*ji&0xff000000)>>24));
   		 
	if(ret<0)
		return ret;
	return 0;
}
	
int parsejLong_charPtr(char** stream, j_long *jl)
{
	int ret;

	int len = sizeof(j_long);
	*jl=0LL;
	j_byte *b=(j_byte*)jl;
	ret=parseBytes_charPtr(stream,b,&len);

	*jl=(((*jl& 	CONST_INT_64(0x00000000000000ff)) << 56) |
	((*jl & 	CONST_INT_64(0x000000000000ff00)) << 40) |
	((*jl & 	CONST_INT_64(0x0000000000ff0000)) << 24) |
	((*jl &		CONST_INT_64(0x00000000ff000000)) <<  8) |
	((*jl & 	CONST_INT_64(0x000000ff00000000)) >>  8) |
	((*jl & 	CONST_INT_64(0x0000ff0000000000)) >> 24) |
	((*jl & 	CONST_INT_64(0x00ff000000000000)) >> 40) |
	((*jl & 	CONST_INT_64(0xff00000000000000)) >> 56));
	if(ret<0)
		return ret;
	return 0;
}

/**
 *  2 octets
 * */
int parsejShort_charPtr(char** stream, j_short *sh)
{
	*sh=0;
	int len = sizeof(j_short);

	int ret;	
	j_byte * b=(j_byte*)sh;
	ret=parseBytes_charPtr(stream,b,&len);
	*sh=(((*sh & 0x00ff) << 8) |((*sh &0xff00)>>8));
	
	if(ret<0)
		return ret;
	return 0;
}

 /**
  
j_byte parseCode(int fd)
{
	j_byte code=0;
 		if(peekb>=0)
 			{
 				code=peekb;
 				peekb=-1;
 				return code;
 			} else
				if(parsejByte(fd,&code)>=0)
					return code;
				else
					return -1;
}
	
static j_byte peek(int fd) 
 {
	if (peekb >= 0)
		return peekb;
	else
		if(parsejByte(fd,&peekb)>=0)
			return peekb;
		else
			return -1;
 }


j_byte peekCode(int fd) 
 {
 	j_byte code= peek(fd);
	 	switch(code)
	{
	 case TC_OBJECT:
    	fprintf(stdout, "CODE : %s = TC_OBJECT\n",toHexString(code));
    	break;
	 case TC_CLASS:
	 	fprintf(stdout, "CODE : %s = TC_CLASS\n",toHexString(code));
    	break;
	 case TC_ARRAY:
	 	fprintf(stdout, "CODE : %s = TC_ARRAY\n",toHexString(code));
    	break;
	 case TC_BLOCKDATA:	
	 	fprintf(stdout, "CODE : %s = TC_BLOCKDATA\n",toHexString(code));
    	break;
    case TC_ENDBLOCKDATA: 
    	fprintf(stdout, "CODE : %s = TC_ENDBLOCKDATA\n",toHexString(code));
    	break;
    case TC_STRING:
    	fprintf(stdout, "CODE : %s = TC_STRING\n",toHexString(code));
    	break;
    case TC_REFERENCE:
    	fprintf(stdout, "CODE : %s = TC_REFERENCE\n",toHexString(code));
    	break;
    default:
    	fprintf(stdout, "CODE : %s = UNKNOWN\n",toHexString(code));
	}
 	return code;
 }

static char* HEX = "0123456789abcdef";

char *toHexString(j_byte b)
{
	char *ptr,*str;
 	ptr=(char *)malloc(5*sizeof(char));
 	str=ptr;
	*ptr++='0';
	*ptr++='x';
	*ptr++=HEX[((char)b >> 4 & 0x0F)];
    *ptr++=HEX[((char)b & 0x0F)];
    *ptr='\0';
 	return str;
}



*/

char* parsejUTF8String_charPtr(char** stream)
{
  j_short utflen=0;

  parsejShort_charPtr(stream, &utflen);

  char* cString = (char*) malloc(utflen + 1);
  cString[0] = '\0';
  j_byte c=0,char2=0,char3=0;
  j_short count=0;
  j_short strlen=0;
  
  while (count < utflen) {

    parsejByte_charPtr(stream, &c);

    switch (c >> 4) { 
    case 0: case 1: case 2: case 3: case 4: case 5: case 6: case 7:
	  count++;
      cString[strlen++] = (char) c;
      break;
    case 12: case 13:
      // 110x xxxx   10xx xxxx
      count+=2;
      if (count > utflen) {
	fprintf(stdout,"Error URFDataFormatException\n");
      }

      parsejByte_charPtr(stream, &char2);

      if ((char2 & 0xc0) != 0x80) {
	fprintf(stdout,"Error URFDataFormatException\n");
      }
      cString[strlen++] = (char)(((c & 0x1f) << 6) | (char2 & 0x3f));
      break;
    case 14:
    count+=3;
      // 1110 xxxx  10xx xxxx  10xx xxxx
      if (count > utflen) {
	fprintf(stdout,"Error URFDataFormatException\n");
      }

      parsejByte_charPtr(stream, &char2);

      parsejByte_charPtr(stream, &char3);

      if (((char2 & 0xc0) != 0x80) || ((char3 & 0xc0) != 0x80)) {
	fprintf(stdout,"Error URFDataFormatException\n");
      }
      cString[strlen++] = (char)(((c & 0x0f) << 12) |
				 ((char2 & 0x3f) << 6) |
				 ((char3 & 0x3f) << 0));
      break;
    default:
      // 10xx xxxx,  1111 xxxx
      fprintf(stdout,"Error URFDataFormatException\n");
    }
  }
  cString[strlen]='\0';
  return cString;

}     


/*
UTF8_PTR stringToUTF8(const char* str) 
{
    UTF8_PTR utf8=malloc(sizeof(UTF8));
	int len = strlen(str);
	j_short utflen = 0;
	int pos=0;
	int i;
	int c;
	for ( i = 0 ; i < len ; i++) {
		c =(int) str[i];
		
		if ((c >= 0x0001) && (c <= 0x007f)) {	
			utflen++;
			} else if (c > 0x07ff) {
	                utflen += 3;
	            } else {
	                utflen += 2;
	            }
	        }
	utf8->size=(utflen+2);
	uint8* buff = malloc((utflen+2)*sizeof(uint8));
	utf8->utf8=buff;
	buff[pos++]=(uint8)(0xff&(utflen >> 8));
	buff[pos++]=(uint8)(0xff&(utflen >> 0));
	for (  i = 0 ; i < len ; i++) {
		c = (int) str[i];
	    if ((c >= 0x0001) && (c <= 0x007F)) {
			buff[pos++]=(uint8)c;
		} else if (c > 0x07ff) {
		buff[pos++]=(uint8)(0xe0 | ((c >> 12) & 0x0f));
		buff[pos++]=(uint8)(0x80 | ((c >>  6) & 0x3f));
	    buff[pos++]=(uint8)(0x80 | ((c >>  0) & 0x3f));
	    } else {
	    buff[pos++]=(uint8)(0xc0 | ((c >>  6) & 0x1f));
	    buff[pos++]=(uint8)(0x80 | ((c >>  0) & 0x3f));
	    }
	}
return utf8;
}


char* utf8ToString(UTF8_PTR utf8)
{

  j_short utflen=utf8->size-2; 
  uint8* buff=utf8->utf8;
  char* cString = (char*) malloc(utflen + 1);	
  cString[0] = '\0';
  uint8 c=0,char2=0,char3=0;
  j_short count=0;
  j_short strlen=0;
  j_short pos=2; 
	
  while (count < utflen) {

    c=buff[pos++];    
    switch (c >> 4) { 
    case 0: case 1: case 2: case 3: case 4: case 5: case 6: case 7:
	  count++;
      cString[strlen++] = (char) c;
      break;
    case 12: case 13:
      // 110x xxxx   10xx xxxx
      count+=2;
      if (count > utflen) {
	fprintf(stdout,"Error URFDataFormatException1\n");
      }
      char2=buff[pos++];
      if ((char2 & 0xc0) != 0x80) {
	fprintf(stdout,"Error URFDataFormatException2\n");
      }
      cString[strlen++] = (char)(((c & 0x1f) << 6) | (char2 & 0x3f));
      break;
    case 14:
    count+=3;
      // 1110 xxxx  10xx xxxx  10xx xxxx
      if (count > utflen) {
	fprintf(stdout,"Error URFDataFormatException3\n");
      }
      char2=buff[pos++];
      char3=buff[pos++];
      if (((char2 & 0xc0) != 0x80) || ((char3 & 0xc0) != 0x80)) {
	fprintf(stdout,"Error URFDataFormatException4\n");
      }
      cString[strlen++] = (char)(((c & 0x0f) << 12) |
				 ((char2 & 0x3f) << 6) |
				 ((char3 & 0x3f) << 0));
      break;
    default:
      // 10xx xxxx,  1111 xxxx
      fprintf(stdout,"Error URFDataFormatException5\n");
    }
  }
  cString[strlen]='\0';
  return cString;
}




int writeBytes(int fd, j_byte* buff, size_t length)
 {
	int w=write(fd,buff,length);
	if(errno == EINTR)
  	{		
  		fprintf(stdout, "CWD : %s %i\n", "writeBytes", errno);  
  		if (w < 1){
  		fprintf(stdout, "Error : %s %s\n", "writeBytes", strerror(errno));
  	}
  	return -1;
  	}
	return 0;
 }
 
 //	*sh=(((*sh & 0x00ff) << 8) |((*sh &0xff00)>>8));

 int writejShort(int fd,j_short sh)
 {
	 size_t len=sizeof(j_short);
	 sh=(\
	 		((sh& 0xff00)>>8)|
	 		((sh &0x00ff)<<8));
	return writeBytes(fd,(j_byte*)(&sh),len);
 }
 
int writejByte(int fd,j_byte b)
{
    size_t len = sizeof(j_byte);
    return writeBytes(fd, &b,len);
}
 
int writejInt(int fd,j_int ji)
{
    size_t len = sizeof(j_int);
	ji=(\
		((ji & 0xff000000)>>24)|
		((ji & 0x00ff0000)>>8) |
		((ji & 0x0000ff00)<<8) |
		((ji & 0x000000ff)<<24));
    return writeBytes(fd,(j_byte*)(&ji),len);	 
}

int writejUtf8(int fd, UTF8_PTR utf8)
{
	j_short s=utf8->size;
	return writeBytes(fd,(j_byte*)utf8->utf8,(size_t)s);
}

int writejLong(int fd, j_long jl)
{
	jl=(\
	((jl& 	CONST_INT_64(0xff00000000000000)) >> 56) |
	((jl & 	CONST_INT_64(0x00ff000000000000)) >> 40) |
	((jl & 	CONST_INT_64(0x0000ff0000000000)) >> 24) |
	((jl &	CONST_INT_64(0x000000ff00000000)) >>  8) |
	((jl & 	CONST_INT_64(0x00000000ff000000)) <<  8) |
	((jl & 	CONST_INT_64(0x0000000000ff0000)) << 24) |
	((jl & 	CONST_INT_64(0x000000000000ff00)) << 40) |
	((jl & 	CONST_INT_64(0x00000000000000ff)) << 56));
	return writeBytes(fd,(j_byte*)(&jl),sizeof(j_long));
}
*/
