#include <stdio.h>
#include "protocol/rmi.h"

#include <io/jtype.h>
#include <io/io.h>
#include <io/jconst.h>

#include <time.h>
#include <limits.h>

#include <sys/types.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <stdio.h>
//#include <linux/in.h>
#include "event/servicedef.h"
#include <ser/classdescription.h>

#include "monitor/monitor.h"

#include "parser/JRMPParser.h"
#include "unit/unit.h"
#include "monitor/tools.h"
#include "composer/proxy_composer.h"



int parseJRMPHeader(int fdIn)
{
	
	int fdOut = fdIn;
	
	   // Parse Header
    fprintf(stdout,"\nHeader RMI: ");
	
	//Lecture par byte
	//Lecture du nombre magic
    j_int magic;
    parsejInt(fdIn, &magic);
    if(magic != Magic)
    {
    	fprintf(stdout,"\nErr RMI Magic\n");
    	return;
    }
    else
    {
    	fprintf(stdout,"\nMagic: %x OK\n",magic); 
    }


	//Lecture de la version
	
    j_short version;	
    parsejShort(fdIn, &version);
    if(version!=2)
    {
       fprintf(stdout,"Version: Mismatch\n");
    }else
    {
    	fprintf(stdout,"Version: %x OK\n",version);
    }

   j_byte proto;
   parsejByte(fdIn, &proto);
   if(proto != StreamProtocol)
   {
	   fprintf(stdout,"Protocol: Unknown %x\n",proto);
	   return;
   }else
   {
	fprintf(stdout,"Protocol: %x OK\n",proto);
   }



	//Protocol negociation 
	//We must send an ack
    writejByte(fdOut, ProtocolAck);

	//Suggest endPoint
	//We must send suggested host
	//writeUTF("127.0.0.1"); //remoteHost

    UTF8_PTR addr1 = stringToUTF8("127.0.0.1");
    writejUtf8(fdOut, addr1);
    int port = 4444;

	//We must send suggested port
	writejByte(fdOut,(0xff&(port>>24))); //remotePort
	writejByte(fdOut,(0xff&(port>>16))); //remotePort
	writejByte(fdOut,(0xff&(port>>8)));	//remotePort
	writejByte(fdOut,(0xff&(port>>0))); 	//remotePort


	//	ReadClientHost and port
   char* clientHost  = parsejUTF8String(fdIn);
   fprintf(stdout,"ClientHost: %s\n",clientHost);

   j_int clientPort;
   parsejInt(fdIn, &clientPort);
   fprintf(stdout,"ClientPort: %d\n",clientPort);

}

void parseJRMP(PARSER_PTR parser, int fdIn, EVENTSRC_PTR evt_src) {

	
	int fdOut = fdIn;

    //j_byte buf[1024];
    //int len = 7, i;
    
	parseJRMPHeader(fdIn);

	//Lecture du code
	j_byte code; 
	parsejByte(fdIn, &code);
		
	switch((int)code)
	{
			//////WARNING /////
			//Commence ici le protocole de serialisation //
			//////		WARNING /////	
		case Call:
			fprintf(stdout,"Code: %x=Call\n",code);
			
			//parseObjID(fdIn);
			parseJRMPCall(parser, fdIn, evt_src);				
					//Recupere l'objet correspondant  l'ObjId
					//Recupere le Target
					//Recupere le Stub du Target
				
					//Stub.dispatch
					//parseCall();
			break;
		case Ping:
		{
			fprintf(stdout,"Code: %x =Ping\n",code);
			//	out.write(PingAck);
			fprintf(stdout,"Ping Ack written\n");
			int test = close(fdIn);
			fprintf(stdout,"ParseJRMP finished. close = %d\n",test);
		}
			break;
		case DGCAck:
		{
			fprintf(stdout,"Code: %x = DGCAck\n",code);
			int test = close(fdIn);
			fprintf(stdout,"ParseJRMP finished. close = %d\n",test);
		}
			break;
		default:
		{
			fprintf(stdout,"Code: %x ERROR\n",code);
		int test = close(fdIn);
		fprintf(stdout,"ParseJRMP finished. close = %d\n",test);
	}
	}
	
	//int test = close(fdIn);
	//fprintf(stdout,"ParseJRMP finished. close = %d\n",test);

//	fflush(stdout);
}





int parseJRMP_InStreamHeader(int fd)
{
	fprintf(stdout,">>P.HEADER \n");
	
	j_short magic1 =-1;
	j_short version1 =-1;

	parsejShort(fd, &magic1);
	parsejShort(fd, &version1);

	if (magic1 != STREAM_MAGIC) {
	    fprintf(stdout,"\nInputStream does not contain a serialized object STREAM_MAGIC = %x\n",STREAM_MAGIC);
	}
	if (version1 != STREAM_VERSION) {
	    fprintf(stdout,"\nVersion Mismatch, Expected %x and got %x\n" +STREAM_VERSION ,version1);
					      
	}
	
	fprintf(stdout,"magic: %x\n",magic1);
	fprintf(stdout,"version: %x\n",version1);


}


int sendVoid(int fd) {

   writejByte(fd, Return);

   	//Write header
   writejByte(fd, (STREAM_MAGIC >>  8) & 0xFF);
   writejByte(fd, (STREAM_MAGIC >>  0) & 0xFF);
	
	//Version
   writejByte(fd, (STREAM_VERSION >>  8) & 0xFF);
   writejByte(fd, (STREAM_VERSION >>  0) & 0xFF);

   writejByte(fd, TC_BLOCKDATA);
   writejByte(fd, (j_byte)15); //remotePort
   writejByte(fd, NormalReturn);

		
	//Send an ID for dgcAck
	//ID= int, long, short
   int unique = 123456789; //(new Object()).hashCode();
   time_t time2;
   time(&time2);
   j_long time1 = (j_long)time2;
   /*short s=Short.MIN_VALUE;*/
   j_short count = SHRT_MIN;

   writejByte(fd, 	(0xff&(unique>>24))); 
   writejByte(fd, 	(0xff&(unique>>16))); 
   writejByte(fd, 	(0xff&(unique>>8))); 
   writejByte(fd, 	(0xff&(unique>>0))); 

   writejByte(fd, 	(0xff&(time1>>56))); 
   writejByte(fd, 	(0xff&(time1>>48))); 
   writejByte(fd, 	(0xff&(time1>>40))); 
   writejByte(fd, 	(0xff&(time1>>32)));
   writejByte(fd, 	(0xff&(time1>>24))); 
   writejByte(fd, 	(0xff&(time1>>16))); 
   writejByte(fd, 	(0xff&(time1>>8))); 
   writejByte(fd, 	(0xff&(time1>>0))); 
	
   writejByte(fd, 	(0xff&(count>>8))); 
   writejByte(fd, 	(0xff&(count>>0))); 
}


void sendStub(int fd, OBJECTDESCPTR obj_ptr)
{
		//Attention suppose qu'il n'y a qu'un seul Stub
	   writejByte(fd, Return);
   		
		//Write header
	   writejByte(fd, (STREAM_MAGIC >>  8) & 0xFF);
	   writejByte(fd, (STREAM_MAGIC >>  0) & 0xFF);
	
		//Version
	   writejByte(fd, (STREAM_VERSION >>  8) & 0xFF);
	   writejByte(fd, (STREAM_VERSION >>  0) & 0xFF);	

	   writejByte(fd, TC_BLOCKDATA);
	   writejByte(fd, (j_byte)15); //remotePort
	   writejByte(fd, NormalReturn);
	   
		//Send an ID for dgcAck
		//ID= int, long, short
/*	   
	   int unique = 32635808; //(new Object()).hashCode();
	   time_t time2;
	   time(&time2);
	   j_long time1 = (j_long)38654705728; //time2;
	   
	   j_short count = -32747; //SHRT_MIN;
*/

	   int unique = obj_ptr->unique; //(new Object()).hashCode();
	   time_t time2;
	   time(&time2);
	   j_long time1 = (j_long)obj_ptr->time ; //time2;
	   
	   j_short count = obj_ptr->count; //SHRT_MIN;
	   
	   
	   writejByte(fd, 	(0xff&(unique>>24))); 
	   writejByte(fd, 	(0xff&(unique>>16))); 
	   writejByte(fd, 	(0xff&(unique>>8))); 
	   writejByte(fd, 	(0xff&(unique>>0))); 

	   writejByte(fd, 	(0xff&(time1>>56))); 
	   writejByte(fd, 	(0xff&(time1>>48))); 
	   writejByte(fd, 	(0xff&(time1>>40))); 
	   writejByte(fd, 	(0xff&(time1>>32)));
	   writejByte(fd, 	(0xff&(time1>>24))); 
	   writejByte(fd, 	(0xff&(time1>>16))); 
	   writejByte(fd, 	(0xff&(time1>>8))); 
	   writejByte(fd, 	(0xff&(time1>>0))); 		

	   writejByte(fd, 	(0xff&(count>>8))); 
	   writejByte(fd, 	(0xff&(count>>0))); 

	   fprintf(stdout,"\n>>unique=%d, time=%llu, count=%d\n",unique, time, count);

		composeObjectOutputStream(fd, obj_ptr);

		fprintf(stdout,"\n finished sendStub\n");

	//	fflush(stdout);	
}



/**
 *  Parse l'identifiant de l'objet
 *  //long objNum + UID space
 *  //UID= int unique + long time + short count
 * @throws IOException
 */
int parseObjID(int fd, j_long* objNum, j_int* unique, j_long* time, j_short* count)
{

//	Parsing de l'object Identifier
	j_int i1, i2;
	parsejInt(fd, &i1);
	parsejInt(fd, &i2);

	/*j_long*/  *objNum  = ((j_long) i1 << 32) + (i2 & 0xFFFFFFFFL);
	//j_int unique;
	parsejInt(fd, unique);
	
	//j_long time;
	parsejLong(fd, time);
	//j_short count;
	parsejShort(fd, count);

	fprintf(stdout,"\nObjID=> ");
	fprintf(stdout,"\n\tObjUnum: %d",*objNum);
	fprintf(stdout,"\n\tunique= %d",*unique);
	fprintf(stdout,"\n\ttime= %d",*time);
	fprintf(stdout,"\n\tcount= %d",*count);	
}


OBJECTDESCPTR getObjDescr(SERVICEDEFPTR service, char* stub_filename)
{
	OBJECTDESCPTR obj_ptr = malloc(sizeof(OBJECTDESC));
	//obj_ptr->name = "washer_rmislp.WasherImpl_Stub";
	obj_ptr->name = "UnicastRef";
	
	/*
	 * hardcoded to test the rmi registry funcitonality.
	 * THESE INFO MUST TO BE GENERATED AT RUNTIME AND STORED IN SERVICETABLE AT DISCOVERY STEP
	 */
	long long RMI_ObjNum;
	long RMI_ObjUnique;
	long long RMI_ObjTime;
	short RMI_ObjCount;
	long RMI_ObjPort;

	
	obj_ptr->ip = get_host_ip()/*"192.168.2.2"*/;
	obj_ptr->port = get_rmiregistry_port(); 
	obj_ptr->objNum = service->RMI_ObjNum; // 0;
	obj_ptr->unique = service->RMI_ObjUnique; //5324016;
	obj_ptr->time = service->RMI_ObjTime; //1141743205631ULL;
	obj_ptr->count = service->RMI_ObjCount; //-32768;
	obj_ptr->bool = 1;	
	/*
	obj_ptr->ip = service->host;
	obj_ptr->port = service->RMI_ObjPort; 
	obj_ptr->objNum = service->RMI_ObjNum;
	obj_ptr->unique = service->RMI_ObjUnique;
	obj_ptr->time = service->RMI_ObjTime;
	obj_ptr->count = service->RMI_ObjCount;
	obj_ptr->bool = 1;	
	*/
	
	obj_ptr->classDescr = malloc(sizeof(CLASSDESC));
	obj_ptr->classDescr->id = 10;
	obj_ptr->classDescr->name = stub_filename; // "defaultPkg.tvImpl0_Stub"; //"defaultPkg.ServiceImpl0_Stub"; /*"defaultPkg.helloserviceImpl0_Stub"; //"defaultPkg.tvImpl0_Stub"; */
	obj_ptr->classDescr->sizeField = 0;
	obj_ptr->classDescr->field = NULL;
	obj_ptr->classDescr->serial = 2ULL; //4550814117179556397ULL; //2; //-2440459149728079141; //4550814117179556397ULL;
	obj_ptr->classDescr->flag = SC_SERIALIZABLE  ;

	CLASSDESCPTR supclass = malloc(sizeof(CLASSDESC));
	obj_ptr->classDescr->superClass = supclass;

	supclass->id = 10;
	supclass->name = "java.rmi.server.RemoteStub";
	supclass->sizeField = 0;
	supclass->field = NULL;
	supclass->serial = REMOTESTUB_CLASS_SERIALNUMBER; //-1585587260594494182ULL;
	supclass->flag = SC_SERIALIZABLE ;

	CLASSDESCPTR supsupclass = malloc(sizeof(CLASSDESC));
	supclass->superClass = supsupclass;

	supsupclass->id = 10;
	supsupclass->name = "java.rmi.server.RemoteObject";
	supsupclass->sizeField = 0;
	supsupclass->field = NULL;
	supsupclass->serial = REMOTEOBJECT_CLASS_SERIALNUMBER; //-3215090123894869218ULL;
	supsupclass->flag = SC_SERIALIZABLE | SC_WRITE_METHOD;
	supsupclass->superClass = NULL;
	
	return obj_ptr;
}


int parseJRMPCall(PARSER_PTR parser, int fd, EVENTSRC_PTR evt_src)
 
{
		
/*		CallData:

		    ObjectIdentifier Operation Hash Arguments
*/

			//Parse Header of the stream
			fprintf(stdout,">>HEADER Object Stream\n");

			parseJRMP_InStreamHeader(fd);
			
			//Parse data
			peekCode(fd);
			j_byte  code = parseCode(fd); //TC_BLOCKDATA
			fprintf(stdout,"code is %x",code);
			j_byte length = -1;
			parsejByte(fd, &length);
			//byte)(din.read()&0xff)); //Longueur du bloc Data
			fprintf(stdout,"\nnbBytes= %d\n",length);

			j_long objNum;
			j_int unique;
			j_long time;
			j_short count;

			parseObjID(fd, &objNum, &unique, &time, &count);
	
			//Parsing du numero de l'operation
			//Si <0 alors jdk1.2
			//Si >0 alors jdk1.1		
	
			j_int opNum;
			parsejInt(fd, &opNum);		
			j_long hash;
			parsejLong(fd, &hash);
			
			if (opNum < 0) {
			   	fprintf(stdout,"\n\t>>JDK 1.2 Call");
	            	
				if (hash == (j_long)7583982177005850366ULL) {
	                	opNum = 0;
	            }
	            else if (hash == 2571371476350237748ULL) {
	               	opNum = 1;
	            }
		        else if (hash == -7538657168040752697ULL) {
	        	    opNum = 2;
			    }
	        	else if (hash == -8381844669958460146ULL) {
			        opNum = 3;
	        	}
			    else if (hash == 7305022919901907578ULL) {
	        	    opNum = 4;
			    }
	        	else {
	            	fprintf(stdout,"\n\t>>Method Hash NOT KNOWN");
	            	opNum = -1;
	            }
				
	            //fprintf(stdout,"\n\t>>Hash method=>%dL",hash);
				fprintf(stdout,"\n\t>>Hash method=>%llu",hash);
	            fprintf(stdout,"\n\t>>Index Method=>%d",opNum);
	        	}
			else
			{
				//Hash => hashcode de l'interface remote
				fprintf(stdout,"\n\t<<JDK 1.1 Call");
				//fprintf(stdout,"\n\t<<Hash interface=>%Ld",hash);
				fprintf(stdout,"\n\t<<Hash interface=>%llu",hash);

			    fprintf(stdout,"\n\t<<Index Method=>%d",opNum);
	            if (hash == 17777547820122932803ULL)
	            {
	            	opNum = -2;
	            	fprintf(stdout,"\n\t<<Hash interface 17777547820122932803ULL NOT KNOWN");
	            }
	            else if(hash != 4905912898345647071ULL)
	            {
	            	opNum = -1;
	            	fprintf(stdout,"\n\t<<Hash interface NOT KNOWN");
	            } 
	            else 
	            	fprintf(stdout,"\n\t<<Registry interface Ok");
			}
			
		//	fflush(stdout);	
	
	
			//Attention, On sait ici que le premier argument est un String
			//On doit le vrifier, le checker avec 
			//l'interface correspondant au hash code prcdent.
			//Attention ici on connait l'interface,
			//C'est l'interface du registry
			//On connait donc les mthodes associes et leurs signatures.
			
			

		/*	
			 
			if(objNum != 0)
			{
				fprintf(stdout,"Request to objNum %d",objNum);
				fprintf(stdout,"Not yet implemented ");
				
				//Faudrait rcuprer le TC_ARRAY
				return;
			}
		*/	
			
			 // Read the next Code in the Stream.
			
			//Parse directly the content of the next thing in the stream
			//That must be an object as described in the rmi specification
			//Dpend de l'interface Registry
			
			switch(opNum) //Interface Registry
			{
				case -2: //ERROR
				{
					fprintf(stdout,"<>Not supported");
					int test = close(fd);
					fprintf(stdout,"ParseJRMP finished. close = %d\n",test);
				}
				break;
				
				case 1: //String[]	list()
				{
					fprintf(stdout,"<>List() Not implemented");
					int test = close(fd);
					fprintf(stdout,"ParseJRMP finished. close = %d\n",test);
				}	
					break;
				
				case 2: // Remote lookup(String name) 
				{
					// Parse TC_STRING for lookup (2): the utf8 name searched is preceded by a TC_STRING byte
					j_byte what;
					parsejByte(fd, &what);
					fprintf(stdout,"\n What ? = %02X ",what);
					
					
					fprintf(stdout,"<>Lookup() Method");
					//Parse the String
					//String correspondant au nom du stub rechercher
					//Stub prealablement telecharger 

					char* str  = parsejUTF8String(fd);
					

					fprintf(stdout,"<>Service searched: %s\n",str);
				//	fflush(stdout);	
		
					// Get service definition for the RMI service searched
					SERVICEDEFPTR srvTmp = Table_get_ServiceDef(ServiceDefinitionTable, str);
					if (srvTmp != NULL)
					{
						servicedef_print( srvTmp );
						
						// Lookup reply: Info should be retrieved in the service table
						char* lookup_str =malloc(sizeof(char)*(strlen(str)+1));
						replace_slash_with_dot(str, lookup_str);
						OBJECTDESCPTR obj_ptr = getObjDescr(srvTmp, lookup_str );
					
						/*
						servicedef_set_RMI_ObjNum(srvTmp, obj_ptr->objNum);
						servicedef_set_RMI_ObjUnique(srvTmp, obj_ptr->unique);
						servicedef_set_RMI_ObjTime(srvTmp, obj_ptr->time);
						servicedef_set_RMI_ObjCount(srvTmp, obj_ptr->count);
						*/
						
						/*
						OBJECTDESCPTR obj_ptr = malloc(sizeof(OBJECTDESC));
						//obj_ptr->name = "washer_rmislp.WasherImpl_Stub";
	
						obj_ptr->name = "UnicastRef";
						obj_ptr->ip = "192.168.2.2";
						obj_ptr->port = 1100; //43021;
						obj_ptr->objNum = 0;
						obj_ptr->unique = 5324016;
						obj_ptr->time = 1141743205631ULL;
						obj_ptr->count = -32768;
						obj_ptr->bool = 1;	
	
						obj_ptr->classDescr = malloc(sizeof(CLASSDESC));
						obj_ptr->classDescr->id = 10;
						obj_ptr->classDescr->name = "defaultPkg.tvImpl0_Stub";
						obj_ptr->classDescr->sizeField = 0;
						obj_ptr->classDescr->field = NULL;
						obj_ptr->classDescr->serial = 2ULL; //4550814117179556397ULL; //2; //-2440459149728079141; //4550814117179556397ULL;
						obj_ptr->classDescr->flag = SC_SERIALIZABLE  ;
						
						CLASSDESCPTR supclass = malloc(sizeof(CLASSDESC));
						obj_ptr->classDescr->superClass = supclass;
		
						supclass->id = 10;
						supclass->name = "java.rmi.server.RemoteStub";
						supclass->sizeField = 0;
						supclass->field = NULL;
						supclass->serial = -1585587260594494182ULL;
						supclass->flag = SC_SERIALIZABLE ;
	
						CLASSDESCPTR supsupclass = malloc(sizeof(CLASSDESC));
						supclass->superClass = supsupclass;
						
						supsupclass->id = 10;
						supsupclass->name = "java.rmi.server.RemoteObject";
						supsupclass->sizeField = 0;
						supsupclass->field = NULL;
						supsupclass->serial = -3215090123894869218ULL;
						supsupclass->flag = SC_SERIALIZABLE | SC_WRITE_METHOD;
						supsupclass->superClass = NULL;
						*/
						
						//fflush(stdout);	
						sendStub(fd, obj_ptr);
	
				
						//fprintf(stdout,"Stub sent: \n ");
						
						//fflush(stdout);	
						
						//Il faudrait envoyer le Stub correspondant au nom
						//Avec lequel il a t associ
						int test = close(fd);
						//fprintf(stdout,"ParseJRMP finished. close = %d\n",test);
					}
				}
					break;
				
				case 0: //void bind(String name, Remote obj) 
				case 3:	//void rebind(String name, Remote obj)
				{
					fprintf(stdout,"<>bind() or rebind() Method\n");


   					char* str1  = parsejUTF8String(fd);
					fprintf(stdout,"str = %s\n",str1);
					/*
					String str=din.readUTF(); //Parse the String
					System.out.println(str);
					*/

					//Il faudrait aussi mettre en cache
					//Le binaire de l'objet parser.
					//Attention ici utiliser des routines autres que celle du jdk 
					//test
					
					//=> invalid stream header
					//We must read the object stream without reading the header.
					//Skip the header is needed but not provided by the jdk
					//=> section de code fait en C
					/*
						Object obj=null;
						ObjectInputStream objIn=new ObjectInputStream(in);
						try {
							obj=objIn.readObject();
						} catch (IOException e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						} catch (ClassNotFoundException e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						}
						sendVoid();
					//Save the Stub
					FileOutputStream fo =new FileOutputStream("Stub.bin");
					ObjectOutputStream objout=new ObjectOutputStream(fo);
					objout.writeObject(obj)
					objout.close();
					fo.close();*/
					
					//Save the stub to a file
					//uncomment to get the Stub
					/*
					int b;
					int i=0;
					FileOutputStream fo =new FileOutputStream("Stub1.bin");
					
					while(peekCode(in)>=0)
					{
						b=parseCode(in);
						fo.write(b);
						System.out.println(i+": "+toHexString((byte)b));
						i++;
					}
					System.out.println("end");
					fo.close();*/

					parseObjectOutputStream(fd);

					sendVoid(fd);
					int test = close(fd);
					fprintf(stdout,"ParseJRMP finished. close = %d\n",test);
				}
					break;
				
				case 4://void unbind(String name)
				{
					fprintf(stdout,"<>unbind() method");
					int test = close(fd);
					fprintf(stdout,"ParseJRMP finished. close = %d\n",test);
						/*
					String str=din.readUTF(); //Parse the String
					System.out.println(str);
					System.out.println("<>Unbind() not implemented");
					//IO.init();
					sendVoid();
						*/
				}
					break;
					
				case -1:
				{
					// Object method call
					fprintf(stdout,"Received RMI call for method %I64d \n",hash);

					
					char* service_path;
					SERVICEDEFPTR serviceFound = Table_get_ServiceDef_and_path_by_RMIObjID(ServiceDefinitionTable, objNum, unique, time, count, &service_path);

					if (serviceFound != NULL)
					{
						servicedef_print(serviceFound);
						
						METHODDEFPTR method_from_servicedef = servicedef_getmethod_byHash(serviceFound, hash);
						
						if (method_from_servicedef != NULL)
						{
							methoddef_print(method_from_servicedef);
			
							parseJRMP_MethodCall(parser, evt_src, fd,  method_from_servicedef, service_path);
							//createSOAPCall(serviceFound, method_from_servicedef);
					/*
							// Parse argument of the RMI call
							int nargs = method_from_servicedef->nArgs;
							int index_arg = 0;
							while (1)
							{
								OBJECTDESCPTR obj = (OBJECTDESCPTR)parseObjectOutputStream(fd);
								fprintf(stdout, "Object read: name=%s, class=%s\n", obj->name,obj->classDescr->name);
								if (!strcmp(obj->classDescr->name, "java.lang.Integer"))
								{
									
									j_int value;
									//parsejInt(fd, &value);
									value = obj->classDescr->field[0].value.int_value;
									fprintf(stdout,"Int read => %d\n",value&0xffffffff);
									
							    		ARGUMENTDEFPTR args1_tmp = method_from_servicedef->args;
							    		int found = 0;
							        	while (!found && args1_tmp != NULL)
							        	{
										if (args1_tmp->dir == ARG_IN && args1_tmp->index == index_arg
												&& (!strcmp(args1_tmp->datatype, "I") || !strcmp(args1_tmp->datatype, "int")))
										{
											found = 1;
											char str_value[20];
											sprintf(str_value, "%d", value&0xffffffff);
											argumentdef_set_value(args1_tmp, str_value);					        		
										}
										args1_tmp = args1_tmp->next;
							        	}
							        
							        
								} 
								else if (!strcmp(obj->classDescr->name, "java.lang.Boolean"))
								{
									j_byte value;
									//parsejByte(fd, &value);
									value = obj->classDescr->field[0].value.boolean_value;
									fprintf(stdout,"Boolean read => %x\n",value&0xff);
								
									ARGUMENTDEFPTR args1_tmp = method_from_servicedef->args;
							    		int found = 0;
							        	while (!found && args1_tmp != NULL)
							        	{
										if (args1_tmp->dir == ARG_IN && args1_tmp->index == index_arg
												&& (!strcmp(args1_tmp->datatype, "B") || !strcmp(args1_tmp->datatype, "boolean")))
										{
											found = 1;
											char str_value[20];
											sprintf(str_value, "%d", value&0xffffffff);
											argumentdef_set_value(args1_tmp, str_value);					        		
										}
										args1_tmp = args1_tmp->next;
							        	}
							        
									
								}
								else if (!strcmp(obj->classDescr->name, "java.lang.String"))
								{
									//j_byte value;
									j_char* value;
									value = obj->classDescr->field[0].value.string_value;
									fprintf(stdout,"String read => %s\n",value);
									
									
									ARGUMENTDEFPTR args1_tmp = method_from_servicedef->args;
							    		int found = 0;
							        	while (!found && args1_tmp != NULL)
							        	{
										if (args1_tmp->dir == ARG_IN && args1_tmp->index == index_arg
												&& (!strcmp(args1_tmp->datatype, "string")))
										{
											found = 1;
											argumentdef_set_value(args1_tmp, (char*)value);					        		
										}
										args1_tmp = args1_tmp->next;
							        	}
							        
								
									
								}
								else if (!strncmp(obj->classDescr->name, "rmiholders.",11))
								{
									fprintf(stdout,"RmiHolder read => !\n");
									
									// TEST: try to modify the value of BooleanHolder on the RMI Client
									//composeJRMP_Call_on_RMIObject(obj);
									
									//sendVoid(fd); 
									
							//		parser_publish_event(event_create_void_pointer(SCP_RMI_STUB_OBJ, evt_stream_id,(void*)evt_src), parser);	
									
									fprintf(stdout,"sendVoid!\n");
								} 
								
								if (peekCode(fd) == TC_ENDBLOCKDATA)
									break;
							}
	
							sendVoid(fd); 
							writejByte(fd, 0);
							
							
							methoddef_print(method_from_servicedef);
							
							jrmp_processEvents(parser,  evt_src, method_from_servicedef, service_path);
						

							
							fprintf(stdout, "SOAP Message Composer: \n ip=%s, port=%d \n", serviceFound->host, serviceFound->port);
			//				compose_SOAP_Call(fd, serviceFound->host, serviceFound->port, serviceFound, method_from_servicedef);
				*/
					}
					else
					{
						sendVoid(fd); 
						int test = close(fd);
						fprintf(stdout,"ParseJRMP finished. close = %d\n",test);
					}
					}
					break;
								
			}			
			}
			//int test = close(fd);
			//fprintf(stdout,"ParseJRMP finished. close = %d\n",test);	
			
		//fprintf(stdout,"END !!!!\n");

		
			//normal Return
		
		//fflush(stdout);	
		

}



void *exec_rmi_registry(void* port_ptr)
//void exec_rmi_registry(int port)
{
	int port = *(int*)port_ptr;
	fprintf(stdout,"\nStarting RMI REGISTRY at port %d ...\n",port);
	

	    char c;
	    FILE *fp;
	    int fromlen;
	    register int i, s, ns, len;
	    struct sockaddr_in sain, fsain;

	    /*
	     * Get a socket to work with.  This socket will
	     * be in the UNIX domain, and will be a
	     * stream socket.
	     */
	    if ((s = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
	        perror("server: socket");
	        exit(1);
	    }

	    /*
	     * Create the address we will be binding to.
	     */
	    bzero((char*)&sain,sizeof(sain));
	    sain.sin_family = AF_INET;      
	    sain.sin_addr.s_addr = htonl (INADDR_ANY);
	    //inet_aton(address, sain.sin_addr);
	    sain.sin_port = htons(port);

	    /*
	     * Try to bind the address to the socket.  We
	     * unlink the name first so that the bind won't
	     * fail.
	     *
	     * The third argument indicates the "length" of
	     * the structure, not just the length of the
	     * socket name.
	     */
//	    unlink(ADDRESS);
	    //len = sizeof(saun.sun_family) + strlen(saun.sun_path);
	    len = sizeof(sain);

	    if (bind(s, (struct sockaddr *)&sain, len) < 0) {
	        perror("server: bind ");
		fprintf(stdout,"server: bind on port %d", port);
	        exit(1);
	    }

	    /*
	     * Listen on the socket.
	     */
	    if (listen(s, 50000) < 0) {
	        perror("server: listen");
	        exit(1);
	    } else
	    	fprintf(stdout,"\nServer is listening at %d\n",port);


	   UNIT_PTR rmi_unit = rmiunit_create("rmiunit.sm");
	    
	  int count_calls;  
	  while (1)
	  //for (count_calls=0; count_calls<16; count_calls++)
	  {
	    /*
	     * Accept connections.  When we accept one, ns
	     * will be connected to the client.  fsaun will
	     * contain the address of the client.
	    
	     */
		  
		  fprintf(stdout,"\nServer Waits for a new connection:\n ");
		  
		  if ((ns = accept(s, 0, 0 /*(struct sockaddr *)&fsain, &fromlen*/)) < 0) {
	        perror("server: accept");
	        exit(1);
	    }

	    fprintf(stdout,"\nServer Accepted a new connection: ");
	    
	    //parseJRMP( ns );

	    PARSER_PTR p = jrmp_parser_create(rmi_unit);
	    parser_add_evtlistener_unit(p, rmi_unit);
	    
	    
		pthread_t parse_thread;
		
		PARSINGTHREADDATA_JRMPPARSER_PTR data_parser = malloc(sizeof(PARSINGTHREADDATA_JRMPPARSER));
		//data->msg = msg;
		data_parser->parser = p;
		data_parser->fd = ns;
		
		fprintf(stdout, "\nCREATING PTHREAD jrmp_parser = %p fd=%d\n", parse_thread, ns);

		pthread_create(&parse_thread, NULL, jrmp_threaded_msg_parsing/* p->func_parse*/, (void*)data_parser);
		
		//pthread_join(parse_thread,  NULL);
		fprintf(stdout, "\nparser_jrmp_msg_received thread finished: %p\n", parse_thread);
	

	    //parseJRMP( ns );
	    
	    
	    
	    //close(ns);
	    
	    
	    
	    /*
	     * We'll use stdio for reading the socket.
	     */
//	    fp = fdopen(ns, "rw");
//	    int fp = open(ns, "r");
//	    return fp;


	    //return ns;
	    /*
	     * We can simply use close() to terminate the
	     * connection, since we're done with both sides.
	     */
	   // close(s);
	  
	}
}
	
void *_exec_rmi_registry(void* port_ptr)
	  {
	    //extern int make_socket (unsigned short int port);
	    int sock;
	    fd_set active_fd_set, read_fd_set;
	    //int i;
	    struct sockaddr_in clientname;
	    //size_t size;

	    
		int port = *(int*)port_ptr;
		fprintf(stdout,"\nStarting RMI REGISTRY at port %d ...\n",port);
		

		    char c;
		    FILE *fp;
		    int fromlen;
		    int i, s, ns, len;
		    struct sockaddr_in sain, fsain;

		    /*
		     * Get a socket to work with.  This socket will
		     * be in the UNIX domain, and will be a
		     * stream socket.
		     */
		    if ((sock = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
		        perror("server: socket");
		        exit(1);
		    }
		    bzero((char*)&sain,sizeof(sain));
		    sain.sin_family = AF_INET;      
		    sain.sin_addr.s_addr = htonl (INADDR_ANY);
		    //inet_aton(address, sain.sin_addr);
		    sain.sin_port = htons(port);

		    /*
		     * Try to bind the address to the socket.  We
		     * unlink the name first so that the bind won't
		     * fail.
		     *
		     * The third argument indicates the "length" of
		     * the structure, not just the length of the
		     * socket name.
		     */
//		    unlink(ADDRESS);
		    //len = sizeof(saun.sun_family) + strlen(saun.sun_path);
		    len = sizeof(sain);

		    if (bind(sock, (struct sockaddr *)&sain, len) < 0) {
		        perror("server: bind ");
			fprintf(stdout,"server: bind on port %d", port);
		        exit(1);
		    }
		    
	    
	    
	    
	    /* Create the socket and set it up to accept connections. */
	    if (listen (sock, 100) < 0)
	      {
	        perror ("listen");
	        exit (1);
	      }

	    /* Initialize the set of active sockets. */
	    FD_ZERO (&active_fd_set);
	    FD_SET (sock, &active_fd_set);

	    
	    UNIT_PTR rmi_unit = rmiunit_create("rmiunit.sm");
	    
	    
	    while (1)
	      {
	        /* Block until input arrives on one or more active sockets. */
	        read_fd_set = active_fd_set;
	        if (select (FD_SETSIZE, &read_fd_set, NULL, NULL, NULL) < 0)
	          {
	            perror ("select");
	            exit (1);
	          }

	        /* Service all the sockets with input pending. */
	        for (i = 0; i < FD_SETSIZE; ++i)
	          if (FD_ISSET (i, &read_fd_set))
	            {
	              if (i == sock)
	                {
	                  /* Connection request on original socket. */
	                  int new;
	                  int size = sizeof (clientname);
	                  new = accept (sock,
	                                (struct sockaddr *) &clientname,
	                                &size);
	                  if (new < 0)
	                    {
	                      perror ("accept");
	                      exit (1);
	                    }
	                  fprintf (stderr,
	                           "Server: connect from host %s, port %hd.\n",
	                           inet_ntoa (clientname.sin_addr),
	                           ntohs (clientname.sin_port));
	                  FD_SET (new, &active_fd_set);
	                  
	          	    PARSER_PTR p = jrmp_parser_create(rmi_unit);
	        	    parser_add_evtlistener_unit(p, rmi_unit);
	        	    
	        	    
	        		pthread_t parse_thread;
	        		
	        		PARSINGTHREADDATA_JRMPPARSER_PTR data_parser = malloc(sizeof(PARSINGTHREADDATA_JRMPPARSER));
	        		//data->msg = msg;
	        		data_parser->parser = p;
	        		data_parser->fd = new;
	        		
	        		fprintf(stdout, "\nCREATING PTHREAD jrmp_parser = %p fd=%d\n", parse_thread, new);

	        		pthread_create(&parse_thread, NULL, jrmp_threaded_msg_parsing/* p->func_parse*/, (void*)data_parser);
	        		
	        		pthread_join(parse_thread,  NULL);
	        		fprintf(stdout, "\nparser_jrmp_msg_received thread finished: %p\n", parse_thread);
	                }
	              else
	                {
	                  /* Data arriving on an already-connected socket. 
	                  if (read_from_client (i) < 0)
	                    {
	                      close (i);
	                      FD_CLR (i, &active_fd_set);
	                    }
	                    */
	                }
	            }
	      }
	  }

