#include "monitor/monitor.h"
#include "unit/unit.h"
#include <stdio.h>
#include <pthread.h>

//#include "nanohttp/nanohttp-server.h"
#include "monitor/tools.h"


#include <mcheck.h>




MONITORENTRY_PTR entry;
MONITORENTRY_PTR entry2;
MONITORENTRY_PTR entry3;
MONITORENTRY_PTR entry4;

static already_received =  0;

MONITORENTRY_PTR monitorentry_create(SOCKET_PTR s, FUNC_UNIT_FACTORY unit_fact )
{
	MONITORENTRY_PTR entry = malloc(sizeof(MONITORENTRY));
	entry->socket = s;
	entry->unit_factory = unit_fact;
	
	entry->unit = NULL;
	
	return entry;
}


// monitor is a msg subscriber 
void monitor_msg_received(MSG_PTR msg, LISTENER_PTR node)
{

	fprintf(stdout, "monitor receives slp msg from SRC=%p.  length=%d src_addr=%s src_port=%d \n", msg->src,msg->length, msg->src_address, msg->src_port);

//if (!already_received) 
//{	
	if (entry->unit == NULL)
	{
		UNIT_PTR unit = entry->unit_factory("slpunit.sm");
		entry->unit = unit;
	}
	
	LISTENER_PTR node2 = (LISTENER_PTR)malloc(sizeof(LISTENER_PTR));
	node2->type = LISTENER_UNIT;
	node2->listener.unit = entry->unit;
	
	entry->unit->func_msg_received(msg, node2);
	//unit->func_msg_received(msg, node2);
	
//already_received = 1;
//}
	
}

//monitor is a msg subscriber 
void monitor_upnpmsg_received(MSG_PTR msg, LISTENER_PTR node)
{

	fprintf(stdout, "monitor receives upnp msg from SRC=%p.  length=%d src_addr=%s src_port=%d \n", msg->src,msg->length, msg->src_address, msg->src_port);

//if (!already_received) 
//{	
	if (entry2->unit == NULL)
	{
		UNIT_PTR unit = entry2->unit_factory("upnpunit.sm");
		entry2->unit = unit;
	}

	LISTENER_PTR node2 = (LISTENER_PTR)malloc(sizeof(LISTENER_PTR));
	node2->type = LISTENER_UNIT;
	node2->listener.unit = entry2->unit;
	
	entry2->unit->func_msg_received(msg, node2);
	//unit->func_msg_received(msg, node2);
	
//already_received = 1;
//}
	
}


//monitor is a msg subscriber 
void monitor_wsdmsg_received(MSG_PTR msg, LISTENER_PTR node)
{

	fprintf(stdout, "monitor receives wsd msg from SRC=%p.  length=%d src_addr=%s src_port=%d \n", msg->src,msg->length, msg->src_address, msg->src_port);

//if (!already_received) 
//{	
	if (entry4->unit == NULL)
	{
		UNIT_PTR unit = entry4->unit_factory("wsdunit.sm");
		entry4->unit = unit;
	}

	LISTENER_PTR node2 = (LISTENER_PTR)malloc(sizeof(LISTENER_PTR));
	node2->type = LISTENER_UNIT;
	node2->listener.unit = entry4->unit;
	
	entry4->unit->func_msg_received(msg, node2);
	//unit->func_msg_received(msg, node2);
	
//already_received = 1;
}

//monitor is a msg subscriber 
void monitor_soapmsg_received(MSG_PTR msg, LISTENER_PTR node)
{

	fprintf(stdout, "monitor receives soap msg from SRC=%p.  length=%d src_addr=%s src_port=%d \n", msg->src,msg->length, msg->src_address, msg->src_port);

	if (entry3->unit == NULL)
	{
		UNIT_PTR unit = entry3->unit_factory("soapunit.sm");
		entry3->unit = unit;
	}

	LISTENER_PTR node2 = (LISTENER_PTR)malloc(sizeof(LISTENER_PTR));
	node2->type = LISTENER_UNIT;
	node2->listener.unit = entry3->unit;
	
	entry3->unit->func_msg_received(msg, node2);
}


int main(int argc, char **argv)
{
	//mtrace();
	
	printf("\nHOST IP IS %s\n",get_host_ip());
	
	//	 table that associates servicedefinitions to 
    // the related path used in SOAP message calls 
    // in POST of the HTTP HEADER

	ServiceDefinitionTable = create_PathServiceDef_Table(); 

	
	if (argc > 1)
	{
		set_httpserver_path(argv[1]); 
	} 
	else
		set_httpserver_path("/opt/jakarta-tomcat-WSAMI/webapps/ROOT"); 

	
	//UNIT_PTR rmi_unit = rmiunit_create("rmiunit.sm");
	
	/*
	 * starting SLP
	 */
	MONITOR_PTR m = malloc(sizeof(MONITOR));
	m->func_msg_received = monitor_msg_received;

	FUNC_UNIT_FACTORY fact_slp = &slpunit_create;
	SOCKET_PTR s = udpmcsocket_create(NULL);
	socket_add_msglistener_monitor(s, m);
	entry = monitorentry_create(s, fact_slp);
	
	char mc_addr_str[255];
	strcpy(mc_addr_str, "239.255.255.253");
	unsigned short mc_port = 427;
	
	fprintf(stdout, "Starting socket SLP %p\n",s);
	socket_listen(s, mc_addr_str, mc_port );
	
	/*
	 * starting UPnP
	 */
	MONITOR_PTR m_upnp = malloc(sizeof(MONITOR));
	m_upnp->func_msg_received = monitor_upnpmsg_received;

	FUNC_UNIT_FACTORY fact_upnp = &upnpunit_create;
	SOCKET_PTR s_upnp = udpmcsocket_create(NULL);
	socket_add_msglistener_monitor(s_upnp, m_upnp);
	entry2 = monitorentry_create(s_upnp, fact_upnp);
	
	char mc_addr_str_upnp[255];
	strcpy(mc_addr_str_upnp, "239.255.255.250");
	unsigned short mc_port_upnp = 1900;
	
	fprintf(stdout, "Starting socket UPnP %p\n",s_upnp);
	socket_listen(s_upnp, mc_addr_str_upnp, mc_port_upnp );
	
	
	   	/*
    	** starting WS-D
    	**/
   	MONITOR_PTR m_wsd = malloc(sizeof(MONITOR));
   	m_wsd->func_msg_received = monitor_wsdmsg_received;

   	FUNC_UNIT_FACTORY fact_wsd = &wsdunit_create;
   	SOCKET_PTR s_wsd = udpmcsocket_create(NULL);
   	socket_add_msglistener_monitor(s_wsd, m_wsd);
   	entry4 = monitorentry_create(s_wsd, fact_wsd);
     	char mc_addr_str_wsd[255];
     	strcpy(mc_addr_str_wsd, "239.255.255.250");
     	unsigned short mc_port_wsd = 3702;
       	fprintf(stdout, "Starting socket WSD %p\n",s_wsd);
       	socket_listen(s_wsd, mc_addr_str_wsd, mc_port_wsd ); 
	
	// run rmi registry
	pthread_t rmi_registry;
	int port = get_rmiregistry_port();
	pthread_create(&rmi_registry, NULL, exec_rmi_registry, (void*)&port);
	//exec_rmi_registry(1100);
	
	
	/*
	 * Starting SOAP unit 
	 */
	MONITOR_PTR m_soap = malloc(sizeof(MONITOR));
	m_soap->func_msg_received = monitor_soapmsg_received;

	FUNC_UNIT_FACTORY fact_soap = &soapunit_create;
	SOCKET_PTR s_soap = http_socket_create(NULL);
	socket_add_msglistener_monitor(s_soap, m_soap);
	entry3 = monitorentry_create(s_soap, fact_soap);
	
	char addr_str_soap[255];
	strcpy(addr_str_soap, get_host_ip()/*"192.168.2.2"*/);
	unsigned short port_soap = get_soapproxy_port();
	
	fprintf(stdout, "Starting socket SOAP %p\n",s_soap);
	
	socket_listen(s_soap, addr_str_soap, port_soap );
	
	
	// run HTTP/SOAP server using functions from csoap/nanohttp
	/*
	log_set_level(HLOG_VERBOSE);
	log_set_file("log_amigo.log");
	MY_httpd_init(0, NULL);
	MY_httpd_run ();

	fprintf(stdout,"\nHTTP SERVER STARTED \n");
	*/
	
	while (1) {}
}



void avoidlooptable_addentry(char* src_ip, int src_port, char* dest_ip, int dest_port)
{
	fprintf(stdout,"\navoidlooptable_addentry src_ip=%s, src_port=%d, dest_ip=%s, dest_port=%d\n",src_ip, src_port, dest_ip, dest_port);
	
	AVOIDLOOPTABLEENTRY_PTR entry = (AVOIDLOOPTABLEENTRY_PTR)malloc(sizeof(AVOIDLOOPTABLEENTRY));
	entry->src_ip = strdup(src_ip);
	entry->src_port = src_port;
	entry->dest_ip = strdup(dest_ip);
	entry->dest_port = dest_port;
	entry->next = NULL;
	
	if (AvoidLoopTable == NULL)
	{
		AvoidLoopTable = entry;
	}
	else
	{
		AVOIDLOOPTABLEENTRY_PTR tmp_AvoidLoopTable = AvoidLoopTable; 
		entry->next = tmp_AvoidLoopTable;
		AvoidLoopTable = entry;
	}
}

int avoidlooptable_containsentry(char* src_ip, int src_port, char* dest_ip, int dest_port)
{
	fprintf(stdout,"\navoidlooptable_containsentry src_ip=%s, src_port=%d, dest_ip=%s, dest_port=%d\n",src_ip, src_port, dest_ip, dest_port);
	
	AVOIDLOOPTABLEENTRY_PTR tmp_AvoidLoopTable = AvoidLoopTable; 
	int found = 0; 
	
	while (!found && tmp_AvoidLoopTable != NULL)
	{
		if (strcmp(src_ip,tmp_AvoidLoopTable->src_ip) == 0 && 
				src_port == tmp_AvoidLoopTable->src_port &&
				strcmp(dest_ip, tmp_AvoidLoopTable->dest_ip) ==0 &&
				dest_port == tmp_AvoidLoopTable->dest_port)
			found = 1;
		tmp_AvoidLoopTable = tmp_AvoidLoopTable->next;
	}
	fprintf(stdout,"\navoidlooptable_containsentry=%d src_ip=%s, src_port=%d, dest_ip=%s, dest_port=%d\n",found,src_ip, src_port, dest_ip, dest_port);
	
	return found;
}

