#include "parser/parser.h"
#include "unit/unit.h"

#include <stdio.h>
#include <pthread.h>

#include "protocol/slp.h"
#include "protocol/slpmsg.h"
#include "io/io.h"


#include "monitor/tools.h"


void slpparser_reference_get_address_and_path(char* reference, char** address, char** path)
{	
	
	if (reference != NULL)
	{
		char* reference_tmp = strdup(reference);
		
		// remove "service:service-type" from reference
		char* service = strtok_r (reference, ":", &reference);
		char* service_type = strtok_r (reference, ":", &reference);
		
		// get protocol from reference
		char* protocol = strtok_r (reference, "//", &reference);
		
		/*
		// remove '/'s from the beginning of the string 
		while (*reference == '/') reference++;
		*/
		
		char* host_port = strtok_r (NULL, "/", &reference);
		/*
		*host = strtok_r (host_port, ":", &host_port);
		
		if (reference != NULL)
			*port = atoi(host_port);
		else
			*port = -1; // should be set to the default value for protocol
		*/
		
		*address = (char*)strndup(reference_tmp + strlen(service) + 1 /* : */ + strlen(service_type) + 1/* : */, 
							strlen(protocol) + 2 /* // */ + strlen(host_port));
		*path = (char*)strdup(reference_tmp + strlen(service) + 1 /* : */ + strlen(service_type) + 1/* : */ +
				strlen(protocol) + 2 /* // */ + strlen(host_port)); 
		
		fprintf(stdout, "\n*address =%s\npath=%s\n",*address, *path);
		
		/*
		fprintf(stdout, "\nreference =%d\nprotocol=%d\nhost_port=%d\n",reference ,protocol,host_port);
		*address = (char*)strndup(protocol, (int)(reference - protocol));
		*path = strdup(reference-1);
		**/
		
	} 
	else
	{
		*address = NULL;
		*path = NULL;
	}
}

	void slp_processEvents(PARSER_PTR parser, SLPMSG_PTR slpmsg, EVENTSRC_PTR evt_src /*, pthread_t thread_event_src*/)
	{
	    int evt_stream_id = (int)(evt_src->src_thread_parser); 
	
		parser_publish_event(event_create(SDP_START, evt_stream_id, /*parser*/(void*)evt_src), parser);	
		parser_publish_event(event_create(SDP_SLP, evt_stream_id, /*parser*/(void*)evt_src), parser);
		
		switch(slpmsg_get_function_id(slpmsg)) 
		{
			case SrvRqst	: 	//CLASS DISCOVERY	
			/*			
				super.dispatchEvents(new SDPEvent(Event.SDP_SERVICE_REQUEST));
				super.dispatchEvents(new SDPEvent(Event.SDP_VERSION,""+msg.getVersion()));
				super.dispatchEvents(new SDPEvent(Event.SDP_REQ_LANGAGE,msg.getLangTag()));
				super.dispatchEvents(new SDPEvent(Event.SDP_REQ_SCOPE,msg.getScopeList()));
				if(!msg.getPredicate().equals(""))
					super.dispatchEvents(new SDPEvent(Event.SDP_REQ_PREDICAT,msg.getPredicate()));
				if(!msg.getPRList().equals(""))
					super.dispatchEvents(new SDPEvent(Event.SDP_REQ_REQUESTER,msg.getPRList()));
				super.dispatchEvents(new SDPEvent(Event.SDP_REQ_ID,msg.getXid()));
				super.dispatchEvents(new SDPEvent(Event.SDP_REQ_SERVICE_TYPE,msg.getServiceType()));
			*/	
			    
				if (strcmp(slpmsg_get_service_type(slpmsg), "service:directory-agent"))
				{
				
				    parser_publish_event(event_create(SDP_SERVICE_REQUEST, evt_stream_id, (void*)evt_src), parser);
				    parser_publish_event(event_create_int(SDP_VERSION, slpmsg_get_version(slpmsg), evt_stream_id, (void*)evt_src), parser);
				    parser_publish_event(event_create_string(SDP_REQ_LANGAGE, slpmsg_get_lang_tag(slpmsg), evt_stream_id, (void*)evt_src), parser);
				    parser_publish_event(event_create_string(SDP_REQ_SCOPE, slpmsg_get_scope_list(slpmsg), evt_stream_id, (void*)evt_src), parser);
				    parser_publish_event(event_create_string(SDP_REQ_PREDICAT, slpmsg_get_predicate(slpmsg), evt_stream_id, (void*)evt_src), parser);
				    parser_publish_event(event_create_string(SDP_REQ_REQUESTER, slpmsg_get_pr_list(slpmsg), evt_stream_id, (void*)evt_src), parser);
				    parser_publish_event(event_create_string(SDP_REQ_ID, slpmsg_get_xid(slpmsg), evt_stream_id, (void*)evt_src), parser);
				    
				    char* service_type = slpmsg_get_service_type(slpmsg);
				    if (!strncmp(service_type, "service:", 8))
				    {
				    	char* service_type_tmp = strdup(service_type + 8*sizeof(char));
				    	parser_publish_event(event_create_string(SDP_REQ_SERVICE_TYPE, service_type_tmp, evt_stream_id, (void*)evt_src), parser);
					}
				}
				break;
				
			case SrvRply	: 	//CLASS DISCOVERY
			{
				
				parser_publish_event(event_create(SDP_SERVICE_RESPONSE, evt_stream_id, (void*)evt_src), parser);
				
				// generate events for url entries
				int url_count = slpmsg_get_n_url_entries(slpmsg);
				int i;
				for (i=0; i<url_count; i++)
				{
					//SDP_SERVICE_DESCR_URL_NOPATH rmi://192.168.2.2:1099
					//	SDP_SERVICE_DESCR_URL_PATH: /washer
						
						
						
					char* url = slpmsg_get_url_entry(slpmsg, i);
					
					char* address;
					char* path;
					
					slpparser_reference_get_address_and_path(url, &address, &path);
					fprintf(stdout,"slpparser_reference_get_address_and_path: url=%s, address=%s, path=%s\n", url, address, path);
					
					
					
					parser_publish_event(event_create_string(SDP_SERVICE_DESCR_URL_NOPATH, address, evt_stream_id, (void*)evt_src), parser);
					parser_publish_event(event_create_string(SDP_SERVICE_DESCR_URL_PATH, path, evt_stream_id, (void*)evt_src), parser);
					
				}
				
				
				//WARNING MAY produce one event for each URL
				//WARNING MAY parse the attributes associated with URL
			/*	
				String urlList = msg.getUrlList();
				
				
				int indexComma = urlList.indexOf(",");
				int firstIndex = 0;
				int indexService = 0;
				while (indexComma != -1) {
					String urlServ = urlList.substring(firstIndex, indexComma);
					String urlServ_noPath = null;
					String urlServ_Path = null;
					
					fprintf(stdout,"SlpParser.srvReply: "+firstIndex+" "+indexComma+" "+urlServ);
					
					String[] url_NoPath_Path = getUrl_NoPath_Path_Strings(urlServ);
					
					urlServ_noPath = url_NoPath_Path[0];
					urlServ_Path = url_NoPath_Path[1];
					
					//SDPResponseEvent evtResp = new SDPResponseEvent(Event.SDP_SERVICE_URL_CTRL, urlServ, this.toString()+(indexService));
					SDPResponseEvent evtResp = new SDPResponseEvent(Event.SDP_SERVICE_DESCR_URL_NOPATH, urlServ_noPath, this.toString()+(indexService));
					super.dispatchEvents(evtResp);
					
					//Disc_ServiceURLPath d_sURLPath = new Disc_ServiceURLPath("currentDeviceType", "currentServiceType", urlServ_Path);
					//evtResp = new SDPResponseEvent(Event.SDP_INTERFACE_CTRL_URL_PATH,  d_sURLPath, this.toString()+(indexService));
					evtResp = new SDPResponseEvent(Event.SDP_SERVICE_DESCR_URL_PATH, urlServ_Path , this.toString()+(indexService));
					super.dispatchEvents(evtResp);
					
					indexService++;

					//super.dispatchEvents(new SDPEvent(Event.SDP_SERVICE_URL_CTRL,msg.getUrlList()));
					firstIndex = indexComma+1;
					indexComma = urlList.indexOf(",", firstIndex);
				}
				String urlServ = urlList.substring(firstIndex, urlList.length());
				String urlServ_noPath = null;
				String urlServ_Path = null;

				String[] url_NoPath_Path = getUrl_NoPath_Path_Strings(urlServ);
				
				fprintf(stdout,"SlpParser.srvReply: "+firstIndex+" "+indexComma+" "+urlServ);
				
				urlServ_noPath = url_NoPath_Path[0];
				urlServ_Path = url_NoPath_Path[1];
				
				//SDPResponseEvent evtResp = new SDPResponseEvent(Event.SDP_SERVICE_URL_CTRL, urlServ, this.toString()+(indexService));
				SDPResponseEvent evtResp = new SDPResponseEvent(Event.SDP_SERVICE_DESCR_URL_NOPATH, urlServ_noPath, this.toString()+(indexService));
				super.dispatchEvents(evtResp);
				
				//Disc_ServiceURLPath d_sURLPath = new Disc_ServiceURLPath("currentDeviceType", "currentServiceType", urlServ_Path);
				//evtResp = new SDPResponseEvent(Event.SDP_INTERFACE_CTRL_URL_PATH,  d_sURLPath, this.toString()+(indexService));
				evtResp = new SDPResponseEvent(Event.SDP_SERVICE_DESCR_URL_PATH, urlServ_Path , this.toString()+(indexService));
				super.dispatchEvents(evtResp);				
				
				indexService++;

			*/
			}
				break;
				
			case SrvReg		: 	//CLASS REGISTRATION
				fprintf(stdout,"SrvReg");
				
				break;
			case SrvAck		: 	//CLASS REGISTRATION
				fprintf(stdout,"SrvAck");
				
				break;
			case SrvDeReg	: 	//CLASS REGISTRATION
				fprintf(stdout,"SrvDeReg");
				break;
				
			case SrvTypeRply: 	//CLASS RESPONSE
				fprintf(stdout,"SrvTypeRply");
				break;
				
			case SrvTypeRqst: 	//CLASS REQUEST
				fprintf(stdout,"SrvTypeRqst");
				break;
			
			case DAAdvert:		//CLASS DISCVOERY
				fprintf(stdout,"DAAdvert");
				break;
			
			case SAAdvert: 		//CLASS DISCOVERY
				fprintf(stdout,"SAAdvert");
				break;
		}
		/*
		super.dispatchEvents(new  SDPEvent(Event.SDP_SOURCE_ADDR,
				msg.getRemoteAddress().getHostAddress()+":"+msg.getRemotePort()));
		super.dispatchEvents(
				new  SDPEvent(Event.SDP_STOP));
		*/
		parser_publish_event(event_create_string(SDP_SOURCE_ADDR, slpmsg_get_src_addr(slpmsg), evt_stream_id, (void*)evt_src), parser);
		parser_publish_event(event_create_int(SDP_SOURCE_PORT, slpmsg_get_src_port(slpmsg), evt_stream_id, (void*)evt_src), parser);
		parser_publish_event(event_create(SDP_STOP, evt_stream_id, (void*)evt_src), parser);
		
		
	}
	
	

	int parseSAAdvert(char** msg, SLPMSG_PTR slpmsg, EVENTSRC_PTR evt_src /*, pthread_t thread_event_src*/) {
		//fprintf(stdout,"SAAdvert");
	}		//Common Value for the header

	
	/**
	 *
	 *+----------------------------+---------------------------+
	 *|       Error Code           |    URL entry count        |
	 *+----------------------------+---------------------------+
	 *|   <URl entry 1>           ...     <URL entry N>        \
	 *+----------------------------+---------------------------+
	 * 
	 * @param dis
	 */
	int parseSrvRply(char** msg, SLPMSG_PTR slpmsg, EVENTSRC_PTR evt_src /*, pthread_t thread_event_src*/)
	{
		/**
		 * A service Reply contains zero or more URL entries.
		 * A service reply must be sent if the request is multicast
		 */
		fprintf(stdout,"SrvRply");
		
		//Parse the error Code 
		//slp.setErrorCode(parseInt(parseBytes(dis,2)));
		j_short error_code;		
		parsejShort_charPtr(msg, &error_code);
		
		// parse url entry count
		j_short url_count;		
		parsejShort_charPtr(msg, &url_count);		
		
		// parse URL entries
		slpmsg_set_n_url_entries(slpmsg, url_count);
		int i;
		for (i=0; i<url_count; i++)
		{
			// reserved
			j_byte reserved;
			parsejByte_charPtr(msg, &reserved);
			
			// lifetime
			j_short lifetime;		
			parsejShort_charPtr(msg, &lifetime);
			
			// url length
			j_short url_length;		
			parsejShort_charPtr(msg, &url_length);
			
			// url
			int len_url = url_length;
			char url[len_url+1];
			parseBytes_charPtr(msg, url, &len_url);
			url[len_url] = '\0';
			
			// url auth length
			j_byte auth_length;
			parsejByte_charPtr(msg, &auth_length);
			
			// url auth
			int len_auth = auth_length;
			char auth[len_auth+1];
			parseBytes_charPtr(msg, auth, &len_auth);
			
			fprintf(stdout,"\nSrvRply. URL entry = %s",url);
			
			slpmsg_set_url_entry(slpmsg, i, url);
		}

		
		
		//Parse the list of URL
		//slp.setUrlList(parseURL(dis));
	}
	
	int parseDAAdv(char** msg, SLPMSG_PTR slpmsg, EVENTSRC_PTR evt_src /*, pthread_t thread_event_src*/) {
		fprintf(stdout,"DAAdv");
		
	}

	/**
	 * Service Request
	 *+----------------------------+---------------------------+
	 *| length of <PRList>         |   <PRList> string         \
	 *+----------------------------+---------------------------+
	 *| length of <service-type>   | <service-type> string     \
	 *+----------------------------+---------------------------+
	 *| length of <scope-list>     | <scope-list> string       \
	 *+----------------------------+---------------------------+
	 *| length of predicate string | service request predicate \
	 *+----------------------------+---------------------------+
	 *| length of <SLP SPI> string |   <SLP SPI> string        \
	 *+----------------------------+---------------------------+
	 * @param dis
	 */
	int parseSrvRqst(char** msg, SLPMSG_PTR slpmsg, EVENTSRC_PTR evt_src /*, pthread_t thread_event_src*/)
	{
		//int len;
		
		//len=parseInt(parseBytes(dis,2));
		//slp.setPRList(new String(parseBytes(dis,len)));
		j_short len;
		int len_int;
		
		parsejShort_charPtr(msg, &len);
		len_int = len;
		char PRList[len_int+1];
		parseBytes_charPtr(msg, PRList, &len_int);
		PRList[len_int] = '\0';
		slpmsg_set_pr_list(slpmsg, PRList);

		//len=parseInt(parseBytes(dis,2));
		//slp.setServiceType(new String(parseBytes(dis,len)));
		parsejShort_charPtr(msg, &len);
		len_int = len;
		char service_type[len_int+1];
		parseBytes_charPtr(msg, service_type, &len_int);
		service_type[len_int] = '\0';
		fprintf(stdout, "service_type = %s\n",service_type);
		slpmsg_set_service_type(slpmsg, service_type);
		
		/**
		 * List of configured scope names.
		 * SA and DA which have been configured with any 
		 * of the scopes in this list will respond.
		 * Error if unicast request with an unsupported scope
		 */
		//len=parseInt(parseBytes(dis,2));
		//slp.setScopeList(new String(parseBytes(dis,len)));
		parsejShort_charPtr(msg, &len);
		len_int = len;
		char scope_list[len_int+1];
		parseBytes_charPtr(msg, scope_list, &len_int);
		scope_list[len_int] = '\0';
		fprintf(stdout, "scope_list = %s\n",scope_list);
		slpmsg_set_scope_list(slpmsg, scope_list);
		
		//len=parseInt(parseBytes(dis,2));
		//slp.setPredicate(new String(parseBytes(dis,len)));
		parsejShort_charPtr(msg, &len);
		len_int = len;
		char predicate[len_int+1];
		parseBytes_charPtr(msg, predicate, &len_int);
		predicate[len_int] = '\0';
		fprintf(stdout, "predicate = %s\n",predicate);
		slpmsg_set_predicate(slpmsg, predicate);
		
		//len=parseInt(parseBytes(dis,2));
		//slp.setSlpSpi(new String(parseBytes(dis,len)));
		parsejShort_charPtr(msg, &len);
		len_int = len;
		char slp_spi[len_int+1];
		parseBytes_charPtr(msg, slp_spi, &len_int);
		slp_spi[len_int] = '\0';
		fprintf(stdout, "slp_spi = %s\n",slp_spi);
	}

	
	

void slp_parse_msg(PARSER_PTR parser, MSG_PTR message, EVENTSRC_PTR evt_src /*, pthread_t thread_event_src*/)
{
	char* msg = message->data;
	int len = message->length;

	fprintf(stdout, "slp parse msg: ");
	int i;
	for (i=0; i<len; i++)
		fprintf(stdout,"%c",msg[i]);
	fprintf(stdout, "\n");
	//parser_publish_event(evt, node->listener.parser);
	
	SLPMSG_PTR slpmsg = slpmsg_create();
	
		//parse The header
		
		//Instantiate a Slp Message representation
		//slp= new SlpMsg();
		
		//try {
		//Parse the version => index=0 => 1 byte
		//Version to get in an EVENT
		//slp.setVersion(parseInt(parseBytes(dis,1)));
		j_byte version;
		parsejByte_charPtr(&msg, &version);
		fprintf(stdout, "version = %d\n",version);
		slpmsg_set_version(slpmsg, version);
		
		//Parse the functionID => index=1 => 1byte
		//Get to an EVENT : REQ, RES or NOTIFY
		//slp.setFunctionId(parseInt(parseBytes(dis,1)));
		j_byte function_id;
		parsejByte_charPtr(&msg, &function_id);
		fprintf(stdout, "function_id = %d\n",function_id);
		slpmsg_set_function_id(slpmsg, function_id);
		
		//Parse the total length of the message => index=2 => 3 bytes
		//slp.setLength(parseInt(parseBytes(dis,3)));
		int length_nbytes = 3;
		j_byte length[length_nbytes];
		parseBytes_charPtr(&msg, length, &length_nbytes);
		
		//Parse the flags => index=5 =>2 bytes 
		//Multicast ?
		//slp.setFlags(parseInt(parseBytes(dis,2)));	
		j_short flags;
		parsejShort_charPtr(&msg, &flags);
		fprintf(stdout, "flags = %08x\n",flags);
		
		//Parse the Offset => index=7 => 3 bytes
		//slp.setExtOffset(parseInt(parseBytes(dis,3)));
		int extoffset_nbytes = 3;
		j_byte extoffset[extoffset_nbytes];
		parseBytes_charPtr(&msg, extoffset, &extoffset_nbytes);
		
		
		//ParseXID => index=10 => 2 bytes
		//Id of the message
		//slp.setXid(parseInt(parseBytes(dis,2))); 
		j_short xid;
		parsejShort_charPtr(&msg, &xid);
		fprintf(stdout, "xid = %d\n",xid);
		char xid_s[10];
		sprintf(xid_s, "%d", xid);
		slpmsg_set_xid(slpmsg, xid_s);
		fprintf(stdout, "xid = %s / %s\n",xid_s, slpmsg_get_xid(slpmsg));
		
		//Parse length of the language Tag => index=12 => 2
		//int len=parseInt(parseBytes(dis,2));
		j_short lang_tag_nbytes;
		parsejShort_charPtr(&msg, &lang_tag_nbytes);
		fprintf(stdout, "lang_tag_nbytes = %d\n",lang_tag_nbytes);
		
		//Parse the langage tag => index=14 => length
		//slp.setLangTag(new String(parseBytes(dis,len)));
		int lang_tag_nbytes_int = lang_tag_nbytes;
		char lang_tag[lang_tag_nbytes_int+1];
		parseBytes_charPtr(&msg, lang_tag, &lang_tag_nbytes_int);
		lang_tag[lang_tag_nbytes_int] = '\0';
		fprintf(stdout, "lang_tag = %s \n",lang_tag);
		slpmsg_set_lang_tag(slpmsg, lang_tag);
		
		
		fprintf(stdout, "version = %d\n",version);
		fprintf(stdout, "function_id = %d\n",function_id);
		fprintf(stdout, "flags = %08x\n",flags);
		fprintf(stdout, "xid = %d\n",xid);
		fprintf(stdout, "lang_tag_nbytes = %d\n",lang_tag_nbytes_int);
		fprintf(stdout, "lang_tag = %s \n",lang_tag);
		
		slpmsg_set_src_addr(slpmsg, message->src_address);
		slpmsg_set_src_port(slpmsg, message->src_port);
		
		switch(function_id){
			case 1: //SrvRqst
				parseSrvRqst(&msg, slpmsg, evt_src);
				break;
			case 2: //SrvRply
				parseSrvRply(&msg, slpmsg, evt_src);		
				break;
			case 8: //DAAvert
				parseDAAdv(&msg, slpmsg, evt_src);
				break;
			case 11: //SAAdvert
				parseSAAdvert(&msg, slpmsg, evt_src);
				break;
		}

		slp_processEvents(parser, slpmsg, evt_src);
		
	
}

void *slp_threaded_msg_parsing(void* ptr)
{
	fprintf(stdout, "slp_threaded_msg_parsing. 1\n");
	PARSINGTHREADDATA_PTR data = (PARSINGTHREADDATA_PTR)ptr;

	MSG_PTR msg = (MSG_PTR)data->msg;
	PARSER_PTR parser = (PARSER_PTR)data->parser;
	
	// in case of the parsing of a reply message:
	//  - The events that are generated by this parser must not carry the identifier of this parser? thread  as their event src, but
	//    the thread identifier of the parser that received the request message and generated the related events. This identifier is stored in the
	//    unit eventqueue_table and the corresponding entry can be found using the dest port of the msg to be parsed (that corresponds to the 
	//	  port set in the table by "unit.c / set_socket_and_parser and set_socket_and_composer"
	fprintf(stdout, "slp_threaded_msg_parsing. 2 port=%d\n",msg->dest_port);
	EVENTQUEUE_TABLE_ENTRY_PTR entry_tmp = eventqueue_table_get_entry_by_current_socket_reply_port(parser->unit->event_table, msg->dest_port);
	fprintf(stdout, "slp_threaded_msg_parsing. 3 port=%d\n",msg->dest_port);
	if (entry_tmp == NULL && msg->dest_port == 427)
	{
		/*
		 * In this case, the message is a discovery message received from an SLP client
		 */
		fprintf(stdout, "slp_threaded_msg_parsing. entry not found for socket_reply_port=%d\n", msg->dest_port);
		
		pthread_t thread_event_src = pthread_self();	
		fprintf(stdout, "\nSLP PTHREAD parser = %p\n", thread_event_src);
		
		EVENTSRC_PTR evt_src = event_create_src((void*)thread_event_src, data->parser->unit);
		
		slp_parse_msg(data->parser, data->msg, evt_src /*thread_event_src*/);
	} 
	else if (entry_tmp != NULL)
	{
		/*
		 * In this case, the message is a reply to a discovery message received from an SLP service
		 */
		fprintf(stdout, "slp_threaded_msg_parsing. 4 port=%d\n",msg->dest_port);
	
		EVENTQUEUE_TABLE_ENTRY_PTR entry = eventqueue_table_copy_entry(parser->unit->event_table, entry_tmp);
	
		fprintf(stdout, "slp_threaded_msg_parsing. parser=%p  parser->unit=%p msg=%p\n", parser, parser->unit,msg);
		
		// the thread that parses this slp reply msg is used as an identifier for sub_stream_id
		pthread_t thread_event_src = pthread_self();
		fprintf(stdout, "\nSLP PTHREAD parser = %p\n", thread_event_src);
		entry->sub_stream_id = (int)thread_event_src;
					
		fprintf(stdout, "\nSLP PTHREAD parser entry->sub_stream_id = %p\n", entry->sub_stream_id);
		
		// the stream_id for the event is sub_stream_id to distinguish between the different event flows for reply messages 
		EVENTSRC_PTR evt_src = event_create_src((void*)entry->sub_stream_id, parser->unit);
		
		// add sub_stream_id to engine for handling the flow of events carrying sub_stream_id as stream_id
		setCurrentState("UPNP_WAIT_SLP_RESPONSE", entry->sub_stream_id, parser->unit->engine);
		//char* engine_current_state = getCurrentState(entry->sub_stream_id, parser->unit->engine);
		//setCurrentState(engine_current_state, entry->sub_stream_id, parser->unit->engine);
		
		slp_parse_msg(parser, msg, evt_src);
		
		//free(evt_src);
		
	}
	else
		fprintf(stdout, "\nSLP PTHREAD parser : ENTRY NOT FOUND for slp reply to port %d\n",msg->dest_port);
	
	//msg_free(msg);
	//free(parser); NO!!! SEGFAULT if freed
	//free(ptr);
}

PARSER_PTR slp_parser_create(UNIT_PTR u)
{
	fprintf(stdout, "Creating SLP parser\n");
		
	PARSER_PTR p = parser_create(u);
	p->func_msg_received = parser_msg_received;
	
	//p->func_parse = slp_parse_msg;
	p->func_parse = slp_threaded_msg_parsing;
	
	p->func_publish_event = parser_publish_event;
	p->evt_listeners = NULL;
	
	p->factory = slp_parser_create;
	
	return p;	
}

