#include "parser/SoapParser.h"
#include "parser/WSDLParser.h"

#include "parser/parser.h"
#include "unit/unit.h"
#include "monitor/tools.h"


void ParseBodyString(char *Body,struct TAG_DETAILS **,struct TAG_DETAILS **);
void ParseHeaderString(char *Body,struct TAG_DETAILS **,struct TAG_DETAILS **);
void ParseFunctionString(char *Body,struct TAG_DETAILS **,struct TAG_DETAILS **);
void ParseParametersString(char *Body,struct TAG_DETAILS **,struct TAG_DETAILS **);

char *_FunctionName = NULL;
char *_post_value = NULL;
int _soap_message_src_socket_id = -1;

TAG_DETAILS *SetTagDetails(int iStart, int iEnd, char *tagStr)
{
	struct TAG_DETAILS *pTag = malloc(sizeof(TAG_DETAILS));
	((TAG_DETAILS*)pTag)->iStart = iStart;
	((TAG_DETAILS*)pTag)->iEnd = iEnd;
	((TAG_DETAILS*)pTag)->tagStr = tagStr;
	((TAG_DETAILS*)pTag)->next = NULL;
	return (TAG_DETAILS*)pTag;
}
/*
char* ExtractNameFromQualifiedName(char *qualifiedName)
{
	char *token = NULL,seps[]=":";
	char *name;
	int index = 0;
		
	token = (char*)strtok( qualifiedName, seps );
	
	while( token != NULL )
	{
		if(index == 1)
		{
			name = token;
		}
		index++;
		token = (char*)strtok( NULL, seps );		
	}	
	return name;
}
*/

char* ExtractAttributeByTag1(char *AttrStr,char *AttrTag)
{
	char *Attribute = NULL,*token=NULL,seps[] = " \t\n" , equ[] = "=",*AttributeVal = NULL;
	
	token = (char*)strtok( AttrStr, seps );
	while( token != NULL )
	{
		if(strstr(token,AttrTag) != NULL)
		{
			Attribute = token;
			break;
		}
		token = (char*)strtok( NULL, seps );		
	}	
	token = (char*)strtok(Attribute,equ);
	
	while(token != NULL)
	{
		if(strstr(token,AttrTag) == NULL)
		{
			AttributeVal = token;
			break;
		}		
		token = (char*)strtok( NULL, equ );	
	}
	printf("ExtractAttributeByTag : IntermediateString : %s\n",AttributeVal);
	
	unsigned int index = 0,bStartFound = FALSE,bEndFound = FALSE,iStartIndex = 0,iEndIndex = 0;

	for(index = 0 ; index < (unsigned int)strlen(AttributeVal) ; index ++)
	{
		if(AttributeVal[index] == '"')
		{
			if(bStartFound == FALSE && bEndFound == FALSE)
			{
				iStartIndex = index+1;
				bStartFound = TRUE;
				continue;
			}
			if(bStartFound == TRUE)
			{
				iEndIndex = index;
				break;
			}
		}
	}
	char *tempStr = (char*)malloc(sizeof(char)*(iEndIndex-iStartIndex));
	for(index = 0;index <(iEndIndex-iStartIndex) ; index++)
		tempStr[index] = AttributeVal[index+iStartIndex];
	tempStr[index] = '\0';
	
	return tempStr;
}

void PrintTag(TAG_DETAILS *pTag)
{
	printf("------------Start = %d-------------\n",((TAG_DETAILS*)pTag)->iStart);
	printf("------------End   = %d-------------\n",((TAG_DETAILS*)pTag)->iEnd);
	printf("%s\n",((TAG_DETAILS*)pTag)->tagStr);
}



void ReadFile();
void ParseWSDiscovery(char *data,int len);

char *ExtractElementName(char *ElementStr)
{
	char *token=NULL,seps[]=" \t\n";
	char *tempStr = NULL;
	
	printf("ExtractElementName : ElementStr is %s (%d)\n",ElementStr, strlen(ElementStr));
	
	token = (char*)strtok( ElementStr, seps );
	int index =0; 
	while( token != NULL )
	{
		printf("ExtractElementName : Next token is %s (%d)\n",token,strlen(token));
		if(index == 0)
		{
			tempStr = (char*)strndup(token,strlen(token));
		}			
		index++;
		token = (char*)strtok( NULL, seps );
	}	
	return tempStr;
}

char *ExtractElementName1(char *ElementStr)
{
	char *token=NULL,seps[]=" \t\n";
	char *tempStr = NULL;
	
	token = (char*)strtok( ElementStr, seps );
	int index =0; 
	while( token != NULL )
	{
		printf("ExtractElementName1 : Next token is %s\n",token);
		if(index == 0)
		{
			tempStr = token;
		}			
		index++;
		token = (char*)strtok( NULL, seps );
	}	
	char *elementName = (char*)malloc(sizeof(char)*(strlen(tempStr)-1));
	for(index = 0 ; index < (strlen(tempStr)-1) ; index++)
		elementName[index] = tempStr[index+1];
	return elementName;
}


struct TAG_DETAILS *FindTagByElementName(struct TAG_DETAILS *pHead,char *Name)
{
	
	struct TAG_DETAILS *pTemp = (struct TAG_DETAILS*)pHead,*pMatch = NULL;
	while(pTemp != NULL)
	{
		if(strstr(((TAG_DETAILS*)pTemp)->tagStr,Name) != NULL )
		{
			pMatch = pTemp;
			break;
		}
		pTemp = ((TAG_DETAILS*)pTemp)->next;
	}		
	return pMatch;
}


void soap_request_processEvents(PARSER_PTR parser, EVENTSRC_PTR evt_src, MSG_PTR message,struct TAG_DETAILS *pStartTagsListHead,struct TAG_DETAILS *pEndTagsListHead)
{	
	fprintf(stdout, "\nsoap_request_processEvents message->src_port=%d\n",message->src_port);
	int evt_stream_id = (int)(evt_src->src_thread_parser);
		
	parser_publish_event(event_create(SDP_START,evt_stream_id,(void*)evt_src), parser);	
	parser_publish_event(event_create(SCP_SOAP,evt_stream_id, (void*)evt_src), parser);
	parser_publish_event(event_create(SCP_REQUEST,evt_stream_id, (void*)evt_src), parser);

	if (_soap_message_src_socket_id != -1)
		parser_publish_event(event_create_int(SCP_SOCKET_ID, _soap_message_src_socket_id, evt_stream_id, (void*)evt_src), parser);
	
	parser_publish_event(event_create_string(SDP_SOURCE_ADDR, message->src_address/*wsdmsg_get_src_addr(wsdmsg)*/,evt_stream_id, (void*)evt_src), parser);
	parser_publish_event(event_create_int(SDP_SOURCE_PORT, message->src_port /*wsdmsg_get_src_port(wsdmsg)*/,evt_stream_id, (void*)evt_src), parser);
	
	parser_publish_event(event_create_string(SCP_SERVICE_NAME, _post_value /*"/washer_rmislp.WasherImpl/control"*/, evt_stream_id, (void*)evt_src), parser);
	parser_publish_event(event_create_string(SCP_METHOD_NAME, _FunctionName, evt_stream_id, (void*)evt_src), parser);
	
	
	struct TAG_DETAILS *pTemp = (struct TAG_DETAILS*)pStartTagsListHead;
	while(pTemp != NULL)
	{
		printf("Next Element Name is %s Value is %s Type is %s\n",((TAG_DETAILS*)pTemp)->name,((TAG_DETAILS*)pTemp)->value,((TAG_DETAILS*)pTemp)->datatype);
		
		ARGUMENTDEFPTR arg = argumentdef_new();
		argumentdef_set_name(arg, ((TAG_DETAILS*)pTemp)->name);
		argumentdef_set_dir(arg, ARG_IN);
		argumentdef_set_datatype(arg, ((TAG_DETAILS*)pTemp)->datatype);
		argumentdef_set_value(arg, ((TAG_DETAILS*)pTemp)->value);
		pTemp = ((TAG_DETAILS*)pTemp)->next;

		
		parser_publish_event(event_create_void_pointer(SCP_ARGUMENT_IN, arg, evt_stream_id, (void*)evt_src), parser);
	}
	
	parser_publish_event(event_create(SDP_STOP,evt_stream_id, (void*)evt_src), parser);		
}	

void soap_response_processEvents(PARSER_PTR parser, EVENTSRC_PTR evt_src, MSG_PTR message,struct TAG_DETAILS *pStartTagsListHead,struct TAG_DETAILS *pEndTagsListHead)
{	
	fprintf(stdout, "\nsoap_response_processEvents \n");
	int evt_stream_id = (int)(evt_src->src_thread_parser);
		
	parser_publish_event(event_create(SDP_START,evt_stream_id,(void*)evt_src), parser);	
	parser_publish_event(event_create(SCP_SOAP,evt_stream_id, (void*)evt_src), parser);
	parser_publish_event(event_create(SCP_RESPONSE,evt_stream_id, (void*)evt_src), parser);

	
	//parser_publish_event(event_create_string(SDP_SOURCE_ADDR, message->src_address/*wsdmsg_get_src_addr(wsdmsg)*/,evt_stream_id, (void*)evt_src), parser);
	//parser_publish_event(event_create_int(SDP_SOURCE_PORT, message->src_port /*wsdmsg_get_src_port(wsdmsg)*/,evt_stream_id, (void*)evt_src), parser);
	
	//parser_publish_event(event_create_string(SCP_SERVICE_NAME, "/washer_rmislp.WasherImpl/control", evt_stream_id, (void*)evt_src), parser);
	parser_publish_event(event_create_string(SCP_METHOD_NAME, _FunctionName, evt_stream_id, (void*)evt_src), parser);
	
	
	struct TAG_DETAILS *pTemp = (struct TAG_DETAILS*)pStartTagsListHead;
	while(pTemp != NULL)
	{
		printf("Next Element Name is %s Value is %s Type is %s\n",((TAG_DETAILS*)pTemp)->name,((TAG_DETAILS*)pTemp)->value,((TAG_DETAILS*)pTemp)->datatype);
		
		ARGUMENTDEFPTR arg = argumentdef_new();
		//argumentdef_set_name(arg, "isTrueResult");
		argumentdef_set_name(arg, ((TAG_DETAILS*)pTemp)->name);
		argumentdef_set_dir(arg, ARG_OUT);
		argumentdef_set_datatype(arg, ((TAG_DETAILS*)pTemp)->datatype);
		if (((TAG_DETAILS*)pTemp)->value != NULL)
		{
			if (((!strcmp(((TAG_DETAILS*)pTemp)->value, "true") || !strcmp(((TAG_DETAILS*)pTemp)->value, "TRUE"))))
				argumentdef_set_value(arg, "1");
			else if (((!strcmp(((TAG_DETAILS*)pTemp)->value, "false") || !strcmp(((TAG_DETAILS*)pTemp)->value, "FALSE"))))
				argumentdef_set_value(arg, "0");
			else
				//argumentdef_set_value(arg, "1");
				argumentdef_set_value(arg, ((TAG_DETAILS*)pTemp)->value);
		}
		else
			//argumentdef_set_value(arg, "1");
			argumentdef_set_value(arg, ((TAG_DETAILS*)pTemp)->value);
		pTemp = ((TAG_DETAILS*)pTemp)->next;

		
		parser_publish_event(event_create_void_pointer(SCP_ARGUMENT_OUT, arg, evt_stream_id, (void*)evt_src), parser);
	}
	
	parser_publish_event(event_create(SDP_STOP,evt_stream_id, (void*)evt_src), parser);		
}	



void soap_parse_msg(PARSER_PTR parser, MSG_PTR message , EVENTSRC_PTR evt_src,struct TAG_DETAILS **pStartTagsListHead,struct TAG_DETAILS **pEndTagsListHead)
{
	fprintf(stdout, "\nSOAP soap_parse_msg \n");
	
	char* data = message->data;
	int numread = message->length;	
/*
	ParseWSDiscovery(msg,len);

void ParseWSDiscovery(char *data,int numread)
{
	fprintf(stdout, "\nParseWSDiscovery \n");
*/	
	int index=0;
	char space = ' ';
	int bStartTagFound = 0;
	int bPreprocessorFound = 0;
	int bEndTagFound = 0;

	
	char* post_value = ExtractHTTPDirective(data, "POST");
	_post_value = post_value;
	
	if (message->src_socket_id != -1)
		_soap_message_src_socket_id = message->src_socket_id;
	
	fprintf(stdout, "\nSOAP soap_parse_msg. post_value=%s\n",post_value);
	
	while(index < numread)
	{			
		
		fprintf(stdout, "%c",data[index] );
		
		if((bStartTagFound == 0) && data[index] == TAG_START)
		{				
			bStartTagFound = 1;
		}	
		if((bPreprocessorFound == 0) && data[index] == QUESTIONMARK)
		{
			bPreprocessorFound = 1;
		}
		if((bEndTagFound == 0) && data[index] == TAG_END)
		{
			bEndTagFound = 1;			
		}
		index++;

		if(bEndTagFound == 1 && bPreprocessorFound == 1)
		{
			break;
		}			
	}

	// Here we have read the preprocessor directive
	bStartTagFound = 0;
	bEndTagFound = 0;

	int envMarkStart = 0,envMarkEnd = 0;
	while(index < numread)
	{
		if((bStartTagFound == 0) && data[index] == TAG_START)
		{
			bStartTagFound = 1;
			envMarkStart = index;
			printf("Env start tag found");
		}
		index++;
		if((bEndTagFound == 0) && data[index] == TAG_END)
		{
			bEndTagFound = 1;
			envMarkEnd = index+1;
			printf("Env End tag found");
			break;
		}				
	}
	printf("Start Index %d End Index %d",envMarkStart,envMarkEnd);
	int charCount = envMarkEnd - envMarkStart;
	char *envelopeString = (char*)malloc((sizeof(char)*charCount));
	int i = 0;
	for(i=0;i<charCount;i++)
		envelopeString[i] = data[i+envMarkStart];	
	envelopeString[i] = '\0';

	printf("Envelope String is \n%s",envelopeString);
	// Here we have read the Envelope
	bStartTagFound = 0;
	bEndTagFound = 0;		

	int tagstartIndex = 0,tagEndIndex = 0;
	char *TAG = NULL;

	index++;

	// Now for the case of Body
	bStartTagFound = 0;
	bEndTagFound = 0;		

	int bodyMarkStart = 0,bodyMarkEnd = 0;
	tagstartIndex = 0,tagEndIndex = 0;
	TAG = NULL;

	//index++;
	int x;
	for( x = index ; x < numread ; x++)
	{			
		printf("%c ",data[x]);		
	}
	printf("\n");
	
	while(index < numread)
	{
		if((bStartTagFound == 0) && data[index] == TAG_START)
		{
			bStartTagFound = 1;
			tagstartIndex = index;
		}
		if((bEndTagFound == 0) && data[index] == TAG_END)
		{
			bEndTagFound = 1;
			tagEndIndex = index+1;
		}
		if(bStartTagFound == 1 && bEndTagFound == 1)
		{
			
			
			charCount = tagEndIndex - tagstartIndex;
			
			printf("StartIndex = %d EndIndex = %d charCount = %d\n",tagstartIndex,tagEndIndex,charCount);
			
			if(charCount < 0 )
			{
				printf("Error the string length cannot be negative ______________________ \n");
				
			} 
			else
			{
				
				TAG = (char*)/*malloc*/realloc(TAG, sizeof(char)*(charCount+1));
				
				for( i = 0 ; i < charCount ; i++ )
				{
					TAG[i]=data[i+tagstartIndex];
				}
				
				for( i = 0 ; i < charCount +1 ; i++ )
				{
					printf("%c ",TAG[i]);
				}
				printf("\n");
				TAG[i]='\0';
	
				if(strstr(TAG,STR_BODY) != NULL)
				{
					if(strstr(TAG,MARKUP_END_TAG) == NULL)
					{
						bodyMarkStart = tagstartIndex;
					}
					else
					{
						bodyMarkEnd = tagEndIndex;
						break;
					}
				}
			}
			bStartTagFound = 0;
			bEndTagFound = 0;
			tagstartIndex = 0;
			tagEndIndex = 0;
		}
		index++;
	}
	int bodySize = bodyMarkEnd - bodyMarkStart;
	char *bodyString =  (char*)malloc(sizeof(char)*(bodySize));

	for( i=0;i<bodySize;i++)
		bodyString[i] = data[i+bodyMarkStart];
	bodyString[i] = '\0';

	ParseBodyString(bodyString,pStartTagsListHead,pEndTagsListHead);
}
void ParseHeaderString(char *Header,struct TAG_DETAILS **pStartTagsListHead,struct TAG_DETAILS **pEndTagsListHead)
{
	printf("\n\n\nHeader String \n%s",Header);
	unsigned int index = 0;
	printf("\n Parsing the header\n");
	
	int bStartTagFound = 0,bEndTagFound = 0;
	unsigned int iStartTagIndex=0,iEndTagIndex=0;
	unsigned int iTagSize = 0;
	unsigned int iToStartIndex=0,iToEndIndex=0;
	unsigned int iMessageIDStartIndex=0,iMessageIDEndIndex=0;
	unsigned int iActionStartIndex=0,iActionEndIndex=0;
	unsigned int iRelatesToStartIndex=0,iRelatesToEndIndex=0;
	unsigned int iRelatesToAttributesStartIndex=0,iRelatesToAttributesEndIndex=0;
	unsigned int iAppSequenceStartIndex=0,iAppSequenceEndIndex=0;

	char *TAG = NULL;
	char *TO = NULL,*MESSAGEID = NULL,*ACTION = NULL,*RELATESTO=NULL,*RELATESTOATTRIBUTES=NULL;
	char *APPSEQUENCE = NULL;

	while(index < strlen(Header))
	{
		if((bStartTagFound == 0) && Header[index] == TAG_START)
		{
			iStartTagIndex = index;
			bStartTagFound = 1;					
		}
		if((bEndTagFound == 0) && Header[index] == TAG_END)
		{
			iEndTagIndex = index+1;
			iTagSize = iEndTagIndex - iStartTagIndex;
			bEndTagFound = 1;
		}
		index++;
		if(bStartTagFound == 1 && bEndTagFound == 1)
		{
			TAG = (char*)malloc(sizeof(char)*(iTagSize));
			unsigned int i=0;
			for(i = 0 ; i < iTagSize ; i++)
				TAG[i] = Header[i+iStartTagIndex];
			TAG[i]='\0';
			printf("\n Next TAG is %s",TAG);
			bStartTagFound = 0;
			bEndTagFound = 0;
		}
	}
}
void ParseBodyString(char *Body,struct TAG_DETAILS **pStartTagsListHead,struct TAG_DETAILS **pEndTagsListHead)
{	
	unsigned int index = 0;
	int bStartTagFound = 0,bEndTagFound = 0;
	unsigned int iStartTagIndex = 0,iEndTagIndex = 0,iTagSize=0;
	char *TAG = NULL,*BodyExtract = NULL;
	unsigned int iBodyStartIndex = 0 , iBodyEndIndex = 0;

	while(index < strlen(Body))
	{
		if((bStartTagFound == 0) && Body[index] == TAG_START)
		{
			bStartTagFound = 1;
			iStartTagIndex = index;
		}
		if((bEndTagFound == 0) && Body[index] == TAG_END)
		{
			bEndTagFound = 1;
			iEndTagIndex = index+1;
		}
		index++;
		if((bStartTagFound == 1) && (bEndTagFound == 1))
		{
			bStartTagFound = 0;
			bEndTagFound = 0;
			
			iTagSize = iEndTagIndex - iStartTagIndex;
			TAG = (char*)malloc(sizeof(char)*iTagSize);
			unsigned int i= 0;
			for(i=0;i<iTagSize;i++)
				TAG[i] = Body[i+iStartTagIndex];
			TAG[i] = '\0';
			//printf("\nNext tag is %s",TAG);	

			if((strstr(TAG,STR_BODY) != NULL) && (strstr(TAG,MARKUP_END_TAG) == NULL))
			{
				iBodyStartIndex = iEndTagIndex;
			}
			if((strstr(TAG,STR_BODY) != NULL) && (strstr(TAG,MARKUP_END_TAG) != NULL))
			{
				iBodyEndIndex = iStartTagIndex;
				BodyExtract = (char*)malloc(sizeof(char)*(iBodyEndIndex-iBodyStartIndex));
				
				for( i = 0 ; i < (iBodyEndIndex-iBodyStartIndex) ; i++)
					BodyExtract[i] = Body[i+iBodyStartIndex];
					
				printf("\nBody Extract is %s",BodyExtract);	
				ParseFunctionString(BodyExtract,pStartTagsListHead,pEndTagsListHead);
			}						
		}
	}
}




void ParseFunctionString(char *Function,struct TAG_DETAILS **pStartTagsListHead,struct TAG_DETAILS **pEndTagsListHead)
{
	
    printf("Function String is  %s\n",Function);
    unsigned int index = 0;
    int bStartTagFound = 0,bEndTagFound = 0;
    unsigned int iStartTagIndex = 0,iEndTagIndex = 0,iTagSize=0;
    unsigned int iStartTagStart=0,iStartTagEnd=0,iEndTagStart=0,iEndTagEnd=0;    
    
    unsigned int iFuncStartIndex = 0, iFuncEndIndex = 0;
    
    char *TAG = NULL , *ElementName = NULL,*FunctionExtract = NULL;
    unsigned bFunctionSet = 0;

    struct TAG_DETAILS *pNew = NULL;
    
    while(index < strlen(Function))
    {
        if((bStartTagFound == 0) && Function[index] == TAG_START)
        {
            bStartTagFound = 1;
            iStartTagIndex = index;
        }
        if((bEndTagFound == 0) && Function[index] == TAG_END)
        {
            bEndTagFound = 1;
            iEndTagIndex = index+1;
        }
        index++;
        if((bStartTagFound == 1) && (bEndTagFound == 1))
        {
            bStartTagFound = 0;
            bEndTagFound = 0;
            
            iTagSize = iEndTagIndex - iStartTagIndex;
            TAG = (char*)malloc(sizeof(char)*iTagSize);
            unsigned int i= 0;
            for(i=0;i<iTagSize;i++)
                TAG[i] = Function[i+iStartTagIndex];
            TAG[i] = '\0';
            printf("Next tag is %s\n",TAG);                        
            
            if(strstr(TAG,MARKUP_END_TAG) == NULL && strstr(TAG,MARKUP_END_TAG_OTHER) == NULL)
            {
                if(bFunctionSet == 0)
                {
                    iFuncStartIndex = iEndTagIndex;                
                    ElementName = ExtractElementName1(TAG);    
                    printf("ElementName is %s\n",ElementName);            
                    bFunctionSet = 1;
                   
					if(strstr(ElementName,":") == NULL)
					{
						_FunctionName = ElementName;						
					}
					else
					{
						_FunctionName = (char*)ExtractNameFromQualifiedName(ElementName);
					}
					printf("_FunctionName is %s\n",_FunctionName); 
                } 
            }
            if(strstr(TAG,MARKUP_END_TAG) != NULL || strstr(TAG,MARKUP_END_TAG_OTHER) != NULL)
            {
                printf("End Tag Testing , FunctionName is %s and Tag is %s\n",_FunctionName,TAG);                    
            
                if(strstr(TAG,_FunctionName) != NULL)
                {
                    iFuncEndIndex = iStartTagIndex;
                    FunctionExtract = (char*)malloc(sizeof(char)*(iFuncEndIndex-iFuncStartIndex));
                    
                    for( i = 0 ; i < (iFuncEndIndex-iFuncStartIndex) ; i++)
                        FunctionExtract[i] = Function[i+iFuncStartIndex];
                    FunctionExtract[i] = '\0';                
                    printf("Function Extract is %s\n",FunctionExtract);                    
                    ParseParametersString(FunctionExtract,pStartTagsListHead,pEndTagsListHead);
                }
            }            
        }
    }    
}
void ParseParametersString(char *Parameters,struct TAG_DETAILS **pStartTagsListHead,struct TAG_DETAILS **pEndTagsListHead)
{
   unsigned int index = 0;
   int bStartTagFound = 0,bEndTagFound = 0;
   unsigned int iStartTagIndex = 0,iEndTagIndex = 0,iTagSize=0;
   unsigned int iStartTagStart=0,iStartTagEnd=0,iEndTagStart=0,iEndTagEnd=0;

   char *TAG = NULL , *StartTag = NULL;

   printf("Parameters list is \n%s\n",Parameters);
   struct TAG_DETAILS *pNewStart = NULL,*pNewEnd = NULL;

   while(index < strlen(Parameters))
   {
       if((bStartTagFound == 0) && Parameters[index] == TAG_START)
       {
           bStartTagFound = 1;
           iStartTagIndex = index;
       }
       if((bEndTagFound == 0) && Parameters[index] == TAG_END)
       {
           bEndTagFound = 1;
           iEndTagIndex = index+1;
       }
       index++;
       if((bStartTagFound == 1) && (bEndTagFound == 1))
       {
           bStartTagFound = 0;
           bEndTagFound = 0;

           iTagSize = iEndTagIndex - iStartTagIndex;
           TAG = (char*)malloc(sizeof(char)*iTagSize);
           unsigned int i= 0;
           for(i=0;i<iTagSize;i++)
               TAG[i] = Parameters[i+iStartTagIndex];
           TAG[i] = '\0';
           printf("Next tag is %s\n",TAG);

           if(strstr(TAG,MARKUP_END_TAG) == NULL && strstr(TAG,MARKUP_END_TAG_OTHER) == NULL)
           {
               pNewStart = (struct TAG_DETAILS*)SetTagDetails(iStartTagIndex,iEndTagIndex,TAG);

               if(*pStartTagsListHead == NULL)
               {
                   *pStartTagsListHead = pNewStart;
               }
               else
               {
                   struct TAG_DETAILS *pTempStart = (struct TAG_DETAILS*)*pStartTagsListHead;
                   while(((TAG_DETAILS*)pTempStart)->next != NULL)
                   {
                       pTempStart = ((TAG_DETAILS*)pTempStart)->next;
                   }
                   ((TAG_DETAILS*)pTempStart)->next = (struct TAG_DETAILS*)pNewStart;
               }
           }
           if(strstr(TAG,MARKUP_END_TAG) != NULL || strstr(TAG,MARKUP_END_TAG_OTHER) != NULL)
           {
               pNewEnd = (struct TAG_DETAILS*)SetTagDetails(iStartTagIndex,iEndTagIndex,TAG);

               if(*pEndTagsListHead == NULL)
               {
                   *pEndTagsListHead = pNewEnd;
               }
               else
               {
                   struct TAG_DETAILS *pTempEnd = (struct TAG_DETAILS*)*pEndTagsListHead;
                   while(((TAG_DETAILS*)pTempEnd)->next != NULL)
                   {
                       pTempEnd = ((TAG_DETAILS*)pTempEnd)->next;
                   }
                   ((TAG_DETAILS*)pTempEnd)->next = (struct TAG_DETAILS*)pNewEnd;
               }
           }
       }
   }

   struct TAG_DETAILS *pTemp1 = (struct TAG_DETAILS*)*pStartTagsListHead;
   while(pTemp1 != NULL)
   {
             printf("Debugging List , StartTagList Next TAG is %s",((TAG_DETAILS*)pTemp1)->tagStr);
             pTemp1 = ((TAG_DETAILS*)pTemp1)->next;    
   }

   struct TAG_DETAILS *pTemp2 = (struct TAG_DETAILS*)*pEndTagsListHead;
   while(pTemp2 != NULL)
   {
      printf("Debugging List , EndTagList Next TAG is %s",((TAG_DETAILS*)pTemp2)->tagStr);
      pTemp2 = ((TAG_DETAILS*)pTemp2)->next;    
   }
         
   struct TAG_DETAILS *pTemp = (struct TAG_DETAILS*)*pStartTagsListHead,*pEndTag = NULL;
   char *ElementName = NULL , *Value = NULL, *ElementType = NULL;
   int i = 0 ,iStart = 0 , iEnd = 0 , iSize = 0 , ibFound = 0;
  
   
   while(pTemp != NULL)
   {

       char *tagExtract = (char*)malloc(sizeof(char)*(strlen(((TAG_DETAILS*)pTemp)->tagStr)-2));
       for( i=0 ; i < (strlen(((TAG_DETAILS*)pTemp)->tagStr)-2) ; i++ )
           tagExtract[i] = ((TAG_DETAILS*)pTemp)->tagStr[i+1];
           tagExtract[i] = '\0';
       ((TAG_DETAILS*)pTemp)->tagStr = tagExtract;

       printf("Next Extracted Tag String is %s(%d)\n",tagExtract,strlen(tagExtract));
       printf("Next Tag is \n");
       PrintTag((TAG_DETAILS*)pTemp);
       printf("((TAG_DETAILS*)pTemp)->tagStr = %s (%d)\n", ((TAG_DETAILS*)pTemp)->tagStr, strlen(((TAG_DETAILS*)pTemp)->tagStr));
       ElementName = ExtractElementName((char*)strndup(((TAG_DETAILS*)pTemp)->tagStr, strlen(((TAG_DETAILS*)pTemp)->tagStr)));
       if(strstr(strdup(((TAG_DETAILS*)pTemp)->tagStr),STR_TYPE) != NULL)
       {
           ElementType = ExtractAttributeByTag(strdup(((TAG_DETAILS*)pTemp)->tagStr),STR_TYPE);
       }

       printf("Element Name is %s\n",ElementName);

       pEndTag = (struct TAG_DETAILS*)*pEndTagsListHead;
       while(pEndTag != NULL)    	   
       {
    	   //Element Name is isTrueResult and string in EndTag is </isTrueResult>  	   
    	   
    	   printf("String in EndTag is -%s(%d)- and Element Name is -%s(%d)-\n",((TAG_DETAILS*)pEndTag)->tagStr,strlen(((TAG_DETAILS*)pEndTag)->tagStr),
    			   ElementName, strlen(ElementName));
    	   
    	   
    	   
           if( strstr( ((TAG_DETAILS*)pEndTag)->tagStr , ElementName ) != NULL )           
           {
               ibFound = 1;
               break;
           }
           
           pEndTag = ((TAG_DETAILS*)pEndTag)->next;
       }

       if(ibFound == 1)
       {
           iStart = ((TAG_DETAILS*)pTemp)->iEnd;
           iEnd = ((TAG_DETAILS*)pEndTag)->iStart;
           iSize = iEnd - iStart;

           Value = (char*)malloc(sizeof(char)*iSize);
           for(i = 0 ; i < iSize ; i++)
               Value[i] = Parameters[i+iStart];
           Value[i] = '\0';

           printf("Element Value is %s\n",Value);

           ((TAG_DETAILS*)pTemp)->name = ElementName;
           ((TAG_DETAILS*)pTemp)->value = Value;
           ((TAG_DETAILS*)pTemp)->datatype = ElementType;

               printf("Matching Tag String is %s\n",((TAG_DETAILS*)pEndTag)->tagStr);
       }
       else
       {
           printf("$$$$$$$$$$$$$$$$$$$$$$$$$$$$  Matching Tag not found  $$$$$$$$$$$$$$$$$\n");
       }
       pTemp = ((TAG_DETAILS*)pTemp)->next;
   }

   pTemp = (struct TAG_DETAILS*)*pStartTagsListHead;
   while(pTemp != NULL)
   {
       printf("Next Element Name is %s Value is %s Type is %s\n",((TAG_DETAILS*)pTemp)->name,((TAG_DETAILS*)pTemp)->value,((TAG_DETAILS*)pTemp)->datatype);

       pTemp = ((TAG_DETAILS*)pTemp)->next;
   }

}

/*
void soap_parse_msg(PARSER_PTR parser, MSG_PTR message , EVENTSRC_PTR evt_src)
{
	fprintf(stdout, "\nSOAP soap_parse_msg \n");
	
	char* msg = message->data;
	int len = message->length;	

	ParseWSDiscovery(msg,len);
	soap_processEvents(parser, evt_src, message);
}
*/

void *soap_threaded_msg_parsing(void* ptr)
{
	
   struct TAG_DETAILS *pStartTagsListHead = NULL,*pEndTagsListHead = NULL;
	
	fprintf(stdout, "soap_threaded_msg_parsing. 1\n");
	PARSINGTHREADDATA_PTR data = (PARSINGTHREADDATA_PTR)ptr;

	MSG_PTR msg = (MSG_PTR)data->msg;
	PARSER_PTR parser = (PARSER_PTR)data->parser;
	
	// in case of the parsing of a reply message:
	//  - The events that are generated by this parser must not carry the identifier of this parser? thread  as their event src, but
	//    the thread identifier of the parser that received the request message and generated the related events. This identifier is stored in the
	//    unit eventqueue_table and the corresponding entry can be found using the dest port of the msg to be parsed (that corresponds to the 
	//	  port set in the table by "unit.c / set_socket_and_parser and set_socket_and_composer"
	fprintf(stdout, "soap_threaded_msg_parsing. 2 port=%d\n",msg->dest_port);
	fprintf(stdout, "soap_threaded_msg_parsing. 2 parser->unit=%p\n",parser->unit);
	fprintf(stdout, "soap_threaded_msg_parsing. 2 parser->unit->event_table=%p\n",parser->unit->event_table);
	EVENTQUEUE_TABLE_ENTRY_PTR entry_tmp = eventqueue_table_get_entry_by_current_socket_reply_port(parser->unit->event_table, msg->dest_port);
	fprintf(stdout, "soap_threaded_msg_parsing. 3 port=%d\n",msg->dest_port);
	
	if (entry_tmp == NULL)
	{
		/*
		 * In this case, the message is a request message received from a SOAP client
		 */
		pthread_t thread_event_src = pthread_self();
		fprintf(stdout, "\nSOAP PTHREAD parser = %p\n", thread_event_src);
		EVENTSRC_PTR evt_src = event_create_src((void*)thread_event_src, data->parser->unit);
		soap_parse_msg(data->parser, data->msg , evt_src, &pStartTagsListHead, &pEndTagsListHead);
		
		soap_request_processEvents(data->parser, evt_src, data->msg,pStartTagsListHead,pEndTagsListHead);
	}
	else 
	{
		/*
		 * In this case, the message is a response message received from a SOAP service
		 */
		fprintf(stdout, "soap_threaded_msg_parsing. 4 port=%d\n",msg->dest_port);
	
		//EVENTQUEUE_TABLE_ENTRY_PTR entry = eventqueue_table_copy_entry(parser->unit->event_table, entry_tmp);
	
		fprintf(stdout, "soap_threaded_msg_parsing. parser=%p  parser->unit=%p msg=%p\n", parser, parser->unit,msg);
		
		// the thread that parses this soap reply msg is used as an identifier for sub_stream_id
		pthread_t thread_event_src = pthread_self();
		fprintf(stdout, "\nSOAP PTHREAD parser = %p\n", thread_event_src);
		entry_tmp->sub_stream_id = (int)thread_event_src;
						
		fprintf(stdout, "\nSOAP PTHREAD parser entry->sub_stream_id = %p\n", entry_tmp->sub_stream_id);
		
		// the stream_id for the event is stream_id and not sub_Stream_id as for discovery parsers
		// because the parser will receive only one reply fro; service and do not need to distinguish between 
		// different event flows for different reply messages from different services 
		EVENTSRC_PTR evt_src = event_create_src((void*)entry_tmp->/*sub_*/stream_id, parser->unit);
		
		// add sub_stream_id to engine for handling the flow of events carrying sub_stream_id as stream_id
		//setCurrentState("UPNP_WAIT_SLP_RESPONSE", entry->sub_stream_id, parser->unit->engine);
		//char* engine_current_state = getCurrentState(entry->sub_stream_id, parser->unit->engine);
		//setCurrentState(engine_current_state, entry->sub_stream_id, parser->unit->engine);
		
		eventqueue_table_print(parser->unit->event_table);
		
		soap_parse_msg(data->parser, data->msg , evt_src, &pStartTagsListHead, &pEndTagsListHead);
		//free(evt_src);	
		soap_response_processEvents(data->parser, evt_src, data->msg,pStartTagsListHead,pEndTagsListHead);
	}
}


PARSER_PTR soap_parser_create(UNIT_PTR u)
{
	fprintf(stdout, "Creating SOAP parser\n");
		
	PARSER_PTR p = parser_create(u);

	p->func_msg_received = parser_msg_received;	
	p->func_parse =  soap_threaded_msg_parsing;	
	p->func_publish_event = parser_publish_event;
	p->evt_listeners = NULL;
	p->factory = soap_parser_create;
	
	return p;	
}
/*
void main()
{
	ReadFile();
}

void ReadFile()
{
	FILE *stream;
	char list[2000];
	char *data = NULL;
	int  numread;

	if( (stream = fopen(FILE_PATH, "r+t" )) != NULL )
	{
		numread = (int)fread( list, sizeof(char), 1500, stream );

		data = (char*)malloc(sizeof(char)*numread);
		int index =0;
		for (index = 0 ; index <= numread ; index++)
			data[index] = list[index];

		//printf( "Number of items read = %d\n", numread );
		//printf( "Contents of buffer = %s\n", data );
		ParseWSDiscovery(data,numread);

		fclose( stream );
	}
	else
		printf( "File could not be opened\n" );
	//getch();
}*/
