#include "parser/parser.h"
#include "unit/unit.h"

#include <stdio.h>
#include <pthread.h>

#include "protocol/slp.h"
#include "protocol/slpmsg.h"
#include "io/io.h"



void *upnp_threaded_msg_parsing(void* ptr)
{
	PARSINGTHREADDATA_PTR data = (PARSINGTHREADDATA_PTR)ptr;
	
	pthread_t thread_event_src = pthread_self();
	
	fprintf(stdout, "\nUPnP PTHREAD parser = %p\n", thread_event_src);
	
	//slp_parse_msg(data->parser, data->msg->data, data->msg->length, thread_event_src);
}

PARSER_PTR upnp_parser_create(UNIT_PTR u)
{
	fprintf(stdout, "Creating UPnP parser\n");
		
	PARSER_PTR p = parser_create(u);
	p->func_msg_received = parser_msg_received;
	
	//p->func_parse = slp_parse_msg;
	p->func_parse = upnp_threaded_msg_parsing;
	
	p->func_publish_event = parser_publish_event;
	p->evt_listeners = NULL;
	
	p->factory = upnp_parser_create;
	
	return p;	
}

