 #include "parser/parser.h"
#include "unit/unit.h"

#include <stdio.h>
#include <pthread.h>
#include <string.h>
#include "protocol/wsd.h"
#include "protocol/wsdmsg.h"
#include "io/io.h"

char *IP = NULL , *PORT = NULL , *URL = NULL;			

void ParseURL(char *url)
{
	//printf("\nThe URL to parse is %s\n",url);
	
	if(strstr(url,"http://") != NULL)
	{
		char *url_extract = (char*)malloc(sizeof(char)*(strlen(url)-strlen("http://")));
		int index = 0;
		for(index = 0 ; index < (strlen(url)-strlen("http://")) ; index++)
		{
			url_extract[index] = url[index+strlen("http://")];
		}
		//printf("\nExtracted url is %s\n",url_extract);
		for(index = 0; index < strlen(url_extract) ; index++)
		{
			if(url_extract[index] == '/')
				break;			
		}
		
		int start_index = 0;
		char *address = (char*)malloc(sizeof(char)*index);
		
		for(start_index = 0;start_index < index ; start_index++)
			address[start_index] = url_extract[start_index];
		
		//printf("\nExtracted Address is %s\n",address);

		char *token = NULL , seps[] = ":";	
		int counter = 0;
		
		token = strtok( address, seps );
		
		while( token != NULL )
		{
			if(counter == 0 )
				IP = token;
			else
				PORT = token;
			counter++;
			token = strtok( NULL, seps );
		}
				
		printf("\nIP is %s PORT is %s\n",IP,PORT);
		
		char *final_url = (char*)malloc(sizeof(char)*(strlen(url_extract)-index));
		
		int index2 = 0;
		for(index2 = 0 ; index2 < (strlen(url_extract)-index) ; index2++)
			final_url[index2] = url_extract[index2+index];
		
			printf("\nExtracted Final URL is %s\n",final_url);
			URL = final_url;
	}	
	else
	{
		printf("\nMalformed URL received\n");
	}	
}


void wsd_processEvents(PARSER_PTR parser, WSDMSG_PTR wsdmsg, EVENTSRC_PTR evt_src)
{	
	int evt_stream_id = (int)(evt_src->src_thread_parser);
		
	parser_publish_event(event_create(SDP_START,evt_stream_id,(void*)evt_src), parser);	
	parser_publish_event(event_create(SDP_WSD,evt_stream_id, (void*)evt_src), parser);
	
	switch(wsdmsg_get_message_type(wsdmsg)) 
	{
		case WSD_HELLO_MSG : //CLASS REGISTRATION		
			fprintf(stdout,"wsd_processEvents : WSD_HELLO_MSG\n");					
			break;			
		case WSD_BYE_MSG : // CLASS REGISTRATION
			fprintf(stdout,"wsd_processEvents : WSD_BYE_MSG\n");
			break;			
		case WSD_PROBE_MSG : 	//CLASS DISCOVERY
		{
			fprintf(stdout,"wsd_processEvents : WSD_PROBE_MSG\n");
			parser_publish_event(event_create(SDP_SERVICE_REQUEST,evt_stream_id, (void*)evt_src),parser);			
			parser_publish_event(event_create_string(SDP_REQ_SCOPE, wsdmsg_get_scopes(wsdmsg),evt_stream_id, (void*)evt_src), parser);
			char* t = strchr(wsdmsg_get_types(wsdmsg), ':');
			if (t != NULL)
			{
				fprintf(stdout,"wsd_processEvents : WSD_PROBE_MSG t1 = %s\n",t);
				t = t + sizeof(char);
				fprintf(stdout,"wsd_processEvents : WSD_PROBE_MSG t2 = %s\n",t);
			}
			else
			{
				t = wsdmsg_get_types(wsdmsg);
				fprintf(stdout,"wsd_processEvents : WSD_PROBE_MSG t3 = %s\n",t);
			}	
			parser_publish_event(event_create_string(SDP_REQ_SERVICE_TYPE, t/*wsdmsg_get_types(wsdmsg)*/,evt_stream_id, (void*)evt_src), parser);
			parser_publish_event(event_create_string(SDP_REQ_ID, wsdmsg_get_message_id(wsdmsg),evt_stream_id, (void*)evt_src), parser);
		}
			break;
		case WSD_PROBE_MATCH_MSG : 	//CLASS RESPONSE
		{
			char *tmp_xaddr = wsdmsg_get_xaddrs(wsdmsg);
			if(tmp_xaddr == NULL)
			{
				tmp_xaddr = "http://192.168.2.10:4821/MyService/service.asmx";				
			}
			char* xaddr = strtok(tmp_xaddr, " ");
			fprintf(stdout,"wsd_processEvents : WSD_PROBE_MATCH_MSG\n");			
			fprintf(stdout,"wsd_processEvents : WSD_PROBE_MATCH_MSG XADDR is %s\n",xaddr);			
			ParseURL(xaddr);						
			char *nourl = (char*)malloc(sizeof(char)*(strlen(HTTP_STR)+strlen(IP)+strlen(":")+strlen(PORT)));									
			strcpy(nourl,HTTP_STR);			
			strcat(nourl,IP);			
			strcat(nourl,":");
			strcat(nourl,PORT);				
			fprintf(stdout,"wsd_processEvents : WSD_PROBE_MATCH_MSG IP is %s PORT is %s URL is %s\n",IP,PORT,URL);			
			fprintf(stdout,"wsd_processEvents : WSD_PROBE_MATCH_MSG nourl %s \n",nourl);			
			parser_publish_event(event_create(SDP_SERVICE_RESPONSE,evt_stream_id, (void*)evt_src),parser);			
			parser_publish_event(event_create_string(SDP_SERVICE_DESCR_URL_NOPATH, nourl,evt_stream_id, (void*)evt_src), parser);	
			parser_publish_event(event_create_string(SDP_SERVICE_DESCR_URL_PATH,URL ,evt_stream_id, (void*)evt_src), parser);
		}
			break;
		case WSD_RESOLVE_MSG : 	//CLASS DISCOVERY
			fprintf(stdout,"wsd_processEvents : WSD_RESOLVE_MSG\n");			
			break;			
		case WSD_RESOLVE_MATCH_MSG : 	//CLASS RESPONSE
			fprintf(stdout,"wsd_processEvents : WSD_RESOLVE_MATCH_MSG\n");
			break;
		default:
			break;			
	}		
	parser_publish_event(event_create_string(SDP_SOURCE_ADDR, wsdmsg_get_src_addr(wsdmsg),evt_stream_id, (void*)evt_src), parser);
	parser_publish_event(event_create_int(SDP_SOURCE_PORT, wsdmsg_get_src_port(wsdmsg),evt_stream_id, (void*)evt_src), parser);
	parser_publish_event(event_create(SDP_STOP,evt_stream_id, (void*)evt_src), parser);		
}	


void wsd_ProcessAppSequence(WSDMSG_PTR wsdmsg,char *AppSequence)
{
	char *InstanceID=NULL,*MessageNumber=NULL,*token=NULL,seps[]=" \t\n",equ[]="=",*InstanceIDVal=NULL,*MessageNumberVal=NULL;
	char *innerToken=NULL;

	token = strtok( AppSequence, seps );
	while( token != NULL )
	{
		if(strstr(token,STR_INSTANCEID) != NULL)
		{
			InstanceID = token;
		}
		else if(strstr(token,STR_MESSAGENUMBER) != NULL)
		{
			MessageNumber = token;
		}
		token = strtok( NULL, seps );
	}
	innerToken = strtok(InstanceID,equ);			
	while(innerToken != NULL)
	{
		if(strstr(innerToken,STR_INSTANCEID) == NULL)
		{
			InstanceIDVal = innerToken;
			break;
		}
		innerToken = strtok( NULL, equ );	
	}
	wsdmsg_set_instance_id(wsdmsg,InstanceIDVal);

	innerToken = strtok(MessageNumber,equ);			
	while(innerToken != NULL)
	{
		if(strstr(innerToken,STR_MESSAGENUMBER) == NULL)
		{
			MessageNumberVal = innerToken;
			break;
		}
		innerToken = strtok( NULL, equ );	
	}
	wsdmsg_set_message_number(wsdmsg,atoi(MessageNumberVal));
}
void wsd_ParseHeaderString(char *Header,WSDMSG_PTR wsdmsg)
{	
	unsigned int index = 0;
	
	int bStartTagFound = 0,bEndTagFound = 0;
	unsigned int iStartTagIndex=0,iEndTagIndex=0;
	unsigned int iTagSize = 0;
	unsigned int iToStartIndex=0,iToEndIndex=0;
	unsigned int iMessageIDStartIndex=0,iMessageIDEndIndex=0;
	unsigned int iActionStartIndex=0,iActionEndIndex=0;
	unsigned int iRelatesToStartIndex=0,iRelatesToEndIndex=0;
	unsigned int iRelatesToAttributesStartIndex=0,iRelatesToAttributesEndIndex=0;
	unsigned int iAppSequenceStartIndex=0,iAppSequenceEndIndex=0;

	char *TAG = NULL;
	char *TO = NULL,*MESSAGEID = NULL,*ACTION = NULL,*RELATESTO=NULL,*RELATESTOATTRIBUTES=NULL;
	char *APPSEQUENCE = NULL;

	while(index < strlen(Header))
	{
		if((bStartTagFound == 0) && Header[index] == TAG_START)
		{
			iStartTagIndex = index;
			bStartTagFound = 1;					
		}
		if((bEndTagFound == 0) && Header[index] == TAG_END)
		{
			iEndTagIndex = index+1;
			iTagSize = iEndTagIndex - iStartTagIndex;
			bEndTagFound = 1;
		}
		index++;
		if(bStartTagFound == 1 && bEndTagFound == 1)
		{
			TAG = (char*)malloc(sizeof(char)*(iTagSize));
			unsigned int i=0;
			for(i = 0 ; i < iTagSize ; i++)
				TAG[i] = Header[i+iStartTagIndex];
			TAG[i]='\0';

			if((strstr(TAG,STR_TO) != NULL) && (strstr(TAG,MARKUP_END_TAG) == NULL) && (strstr(TAG,STR_RELATESTO) == NULL))
			{
				iToStartIndex = iEndTagIndex;	
			}
			if((strstr(TAG,STR_TO) != NULL) && (strstr(TAG,MARKUP_END_TAG) != NULL) && strstr(TAG,STR_RELATESTO) == NULL)
			{
				iToEndIndex = iStartTagIndex;
				TO = (char*)malloc(sizeof(char)*(iToEndIndex-iToStartIndex));
				for(i=0;i<(iToEndIndex-iToStartIndex);i++)
					TO[i] = Header[i+iToStartIndex];
				TO[i] = '\0';
				wsdmsg_set_to(wsdmsg,TO);				
			}
			if((strstr(TAG,STR_MESSAGEID) != NULL) && (strstr(TAG,MARKUP_END_TAG) == NULL))
			{
				iMessageIDStartIndex = iEndTagIndex;	
			}
			if((strstr(TAG,STR_MESSAGEID) != NULL) && (strstr(TAG,MARKUP_END_TAG) != NULL))
			{
				iMessageIDEndIndex = iStartTagIndex;	
				MESSAGEID = (char*)malloc(sizeof(char)*(iMessageIDEndIndex-iMessageIDStartIndex));
				for(i=0;i<(iMessageIDEndIndex-iMessageIDStartIndex);i++)
					MESSAGEID[i] = Header[i+iMessageIDStartIndex];
				MESSAGEID[i] = '\0';
				wsdmsg_set_message_id(wsdmsg,MESSAGEID);				
			}
			if(strstr(TAG,STR_ACTION) != NULL && strstr(TAG,MARKUP_END_TAG) == NULL)
			{
				iActionStartIndex = iEndTagIndex;	
			}
			if(strstr(TAG,STR_ACTION) != NULL && strstr(TAG,MARKUP_END_TAG) != NULL)
			{
				iActionEndIndex = iStartTagIndex;	
				ACTION = (char*)malloc(sizeof(char)*(iActionEndIndex-iActionStartIndex));
				for(i=0;i<(iActionEndIndex-iActionStartIndex);i++)
					ACTION[i] = Header[i+iActionStartIndex];
				ACTION[i] = '\0';
				wsdmsg_set_action(wsdmsg,ACTION);
			}
			if(strstr(TAG,STR_RELATESTO) != NULL && strstr(TAG,MARKUP_END_TAG) == NULL)
			{
				iRelatesToStartIndex = iEndTagIndex;
				iRelatesToAttributesStartIndex = iStartTagIndex;
				iRelatesToAttributesEndIndex = iEndTagIndex;
				iTagSize = iRelatesToAttributesEndIndex - iRelatesToAttributesStartIndex;
				RELATESTOATTRIBUTES = (char*)malloc(sizeof(char)*iTagSize);
				for(i=0;i<iTagSize;i++)
					RELATESTOATTRIBUTES[i]=Header[i+iRelatesToAttributesStartIndex];
				RELATESTOATTRIBUTES[i] = '\0';
				//ProcessRelatesToAttributes(RELATESTOATTRIBUTES);
			}
			if(strstr(TAG,STR_RELATESTO) != NULL && strstr(TAG,MARKUP_END_TAG) != NULL)
			{
				iRelatesToEndIndex = iStartTagIndex;	
				RELATESTO = (char*)malloc(sizeof(char)*(iRelatesToEndIndex-iRelatesToStartIndex));
				for(i=0;i<(iRelatesToEndIndex-iRelatesToStartIndex);i++)
					RELATESTO[i] = Header[i+iRelatesToStartIndex];
				RELATESTO[i] = '\0';
				wsdmsg_set_relates_to(wsdmsg,RELATESTO);
			}
			if(strstr(TAG,STR_APPSEQUENCE) != NULL)
			{
				iAppSequenceStartIndex = iStartTagIndex+1;
				iAppSequenceEndIndex = iEndTagIndex-1;
				APPSEQUENCE = (char*)malloc(sizeof(char)*(iAppSequenceEndIndex-iAppSequenceStartIndex));
				for(i=0;i<(iAppSequenceEndIndex-iAppSequenceStartIndex);i++)
					APPSEQUENCE[i] = Header[i+iAppSequenceStartIndex];
				APPSEQUENCE[i] = '\0';
				wsd_ProcessAppSequence(wsdmsg,APPSEQUENCE);
			}

			bStartTagFound = 0;
			bEndTagFound = 0;
			
			//
		}
	}
}
void wsd_ProcessEndPointRef(char *EndPointRef,WSDMSG_PTR wsdmsg)
{
	int bStartTagFound = 0,bEndTagFound = 0;
	unsigned int iStartTagIndex=0,iEndTagIndex=0;
	unsigned int iAddressStartIndex=0,iAddressEndIndex=0;
	char *ADDRESS=NULL,*TAG=NULL;
	unsigned int index=0,iTagSize=0,iAddressSize=0,i=0;

	while(index < strlen(EndPointRef))
	{
		if((bStartTagFound == 0) && EndPointRef[index] == TAG_START)
		{
			iStartTagIndex = index;
			bStartTagFound = 1;
		}
		if((bEndTagFound == 0) && EndPointRef[index] == TAG_END)
		{
			iEndTagIndex = index+1;
			bEndTagFound = 1;
		}
		index++;
		if((bStartTagFound == 1) && (bEndTagFound == 1))
		{
			bStartTagFound = 0;
			bEndTagFound = 0;
			iTagSize = iEndTagIndex - iStartTagIndex;
			TAG = (char*)malloc(sizeof(char)*iTagSize);
			for(i=0;i<iTagSize;i++)
				TAG[i] = EndPointRef[i+iStartTagIndex];
			TAG[i] = '\0';

			if(strstr(TAG,STR_ADDRESS) != NULL && strstr(TAG,MARKUP_END_TAG) == NULL)
			{
				iAddressStartIndex = iEndTagIndex;
			}
			else if(strstr(TAG,STR_ADDRESS) != NULL && strstr(TAG,MARKUP_END_TAG) != NULL)
			{
				iAddressEndIndex = iStartTagIndex;
				iAddressSize = iAddressEndIndex - iAddressStartIndex;
				ADDRESS = (char*)malloc(sizeof(char)*iAddressSize);
				for(i=0;i<iAddressSize;i++)
					ADDRESS[i] = EndPointRef[i+iAddressStartIndex];
				ADDRESS[i] = '\0';
				wsdmsg_set_address(wsdmsg,ADDRESS);
			}
		}
	}
}
void wsd_ProcessScopesAttributes(WSDMSG_PTR wsdmsg,char *ScopesAttributes)
{
	char *MatchBy=NULL,*token,seps[]=" \t\n",equ[]="=",*MatchByVal=NULL;

	token = strtok( ScopesAttributes, seps );
	while( token != NULL )
	{
		if(strstr(token,STR_MATCHBY) != NULL)
		{
			MatchBy = token;
			break;
		}
		token = strtok( NULL, seps );
	}
	token = strtok(MatchBy,equ);
	while(token != NULL)
	{
		if(strstr(token,STR_MATCHBY) == NULL)
		{
			MatchByVal = token;
			break;
		}
		token = strtok( NULL, equ );	
	}
	wsdmsg_set_matchby(wsdmsg,MatchByVal);
	//printf("\nMatchByValue ------%s",MatchByVal);
}
void wsd_ProcessHello(char *Hello,WSDMSG_PTR wsdmsg)
{
	int bStartTagFound = 0,bEndTagFound = 0;
	unsigned int iStartTagIndex=0,iEndTagIndex=0;
	unsigned int iTypesStartIndex=0,iTypesEndIndex=0;
	unsigned int iScopesStartTagStartIndex=0,iScopesStartTagEndIndex=0;
	unsigned int iScopesStartIndex=0,iScopesEndIndex=0;
	unsigned int iXAddrsStartIndex=0,iXAddrsEndIndex=0;
	unsigned int iEndPointRefStartIndex=0,iEndPointRefEndIndex=0;
	unsigned int iMetaDataVerStartIndex=0,iMetaDataVerEndIndex=0;
	
	char *TAG=NULL,*TYPES=NULL,*SCOPES=NULL,*SCOPESSTARTTAG=NULL,*XADDRS=NULL,*ENDPOINTREF=NULL,*METADATAVER=NULL;
	unsigned int index=0,iTagSize=0,iTypesSize=0,iScopesSize=0,iScopesStartTagSize=0,i=0;
	unsigned int iXAddrSize=0,iEndPointRefSize=0,iMetaDataVerSize=0;

	while(index < strlen(Hello))
	{
		if((bStartTagFound == 0) && Hello[index] == TAG_START)
		{
			iStartTagIndex = index;
			bStartTagFound = 1;
		}
		if((bEndTagFound == 0) && Hello[index] == TAG_END)
		{
			iEndTagIndex = index+1;
			bEndTagFound = 1;
		}
		index++;
		if((bStartTagFound == 1) && (bEndTagFound == 1))
		{
			bStartTagFound = 0;
			bEndTagFound = 0;
			iTagSize = iEndTagIndex - iStartTagIndex;
			TAG = (char*)malloc(sizeof(char)*iTagSize);
			for(i=0;i<iTagSize;i++)
				TAG[i] = Hello[i+iStartTagIndex];
			TAG[i] = '\0';

			if(strstr(TAG,STR_ENDPOINTREFERENCE) != NULL)
			{
				if(strstr(TAG,MARKUP_END_TAG) == NULL)
				{
					iEndPointRefStartIndex = iEndTagIndex;
				}
				else
				{
					iEndPointRefEndIndex = iStartTagIndex;
					iEndPointRefSize = iEndPointRefEndIndex - iEndPointRefStartIndex;
					ENDPOINTREF = (char*)malloc(sizeof(char)*iEndPointRefSize);
					for(i=0;i<iEndPointRefSize;i++)
						ENDPOINTREF[i] = Hello[i+iEndPointRefStartIndex];
					ENDPOINTREF[i]='\0';
					wsd_ProcessEndPointRef(ENDPOINTREF,wsdmsg);					
				}
			}
			if(strstr(TAG,STR_METADATAVERSION) != NULL)
			{
				if(strstr(TAG,MARKUP_END_TAG) == NULL)
				{
					iMetaDataVerStartIndex = iEndTagIndex;
				}
				else
				{
					iMetaDataVerEndIndex = iStartTagIndex;
					iMetaDataVerSize = iMetaDataVerEndIndex - iMetaDataVerStartIndex;
					METADATAVER = (char*)malloc(sizeof(char)*iMetaDataVerSize);
					for(i=0;i<iMetaDataVerSize;i++)
						METADATAVER[i] = Hello[i+iMetaDataVerStartIndex];
					METADATAVER[i]='\0';
					wsdmsg_set_meta_data_version(wsdmsg,METADATAVER);					
				}
			}
			if(strstr(TAG,STR_TYPES) != NULL)
			{
				if(strstr(TAG,MARKUP_END_TAG) == NULL)
				{
					iTypesStartIndex = iEndTagIndex;
				}
				else
				{
					iTypesEndIndex = iStartTagIndex;
					iTypesSize = iTypesEndIndex - iTypesStartIndex;
					TYPES = (char*)malloc(sizeof(char)*iTypesSize);
					for(i=0;i<iTypesSize;i++)
						TYPES[i] = Hello[i+iTypesStartIndex];
					TYPES[i]='\0';
					wsdmsg_set_types(wsdmsg,TYPES);					
				}
			}
			if(strstr(TAG,STR_XADDRS) != NULL)
			{
				if(strstr(TAG,MARKUP_END_TAG) == NULL)
				{
					iXAddrsStartIndex = iEndTagIndex;
				}
				else
				{
					iXAddrsEndIndex = iStartTagIndex;
					iXAddrSize = iXAddrsEndIndex - iXAddrsStartIndex;
					XADDRS = (char*)malloc(sizeof(char)*iXAddrSize);
					for(i=0;i<iXAddrSize;i++)
						XADDRS[i] = Hello[i+iXAddrsStartIndex];
					XADDRS[i]='\0';
					wsdmsg_set_xaddrs(wsdmsg,XADDRS);
				}
			}
			if(strstr(TAG,STR_SCOPES) != NULL)
			{
				if(strstr(TAG,MARKUP_END_TAG) == NULL)
				{
					iScopesStartIndex = iEndTagIndex;
					iScopesStartTagStartIndex = iStartTagIndex+1;
					iScopesStartTagEndIndex = iEndTagIndex-1;
					iScopesStartTagSize = iScopesStartTagEndIndex - iScopesStartTagStartIndex;
					SCOPESSTARTTAG = (char*)malloc(sizeof(char)*iScopesStartTagSize);
					for(i=0;i<iScopesStartTagSize;i++)
						SCOPESSTARTTAG[i] = Hello[i+iScopesStartTagStartIndex];
					SCOPESSTARTTAG[i] = '\0';
					wsd_ProcessScopesAttributes(wsdmsg,SCOPESSTARTTAG);
				}
				else
				{
					iScopesEndIndex = iStartTagIndex;
					iScopesSize = iScopesEndIndex - iScopesStartIndex;
					SCOPES = (char*)malloc(sizeof(char)*iScopesSize);
					for(i=0;i<iScopesSize;i++)
						SCOPES[i] = Hello[i+iScopesStartIndex];
					SCOPES[i] = '\0';
					wsdmsg_set_scopes(wsdmsg,SCOPES);				
				}
			}
		}
	}

}

void wsd_ProcessBye(char *Bye,WSDMSG_PTR wsdmsg)
{
	int bStartTagFound = 0,bEndTagFound = 0;
	unsigned int iStartTagIndex=0,iEndTagIndex=0;
	unsigned int iEndPointRefStartIndex=0,iEndPointRefEndIndex=0;
	
	char *TAG=NULL,*ENDPOINTREF=NULL;
	unsigned int index=0,iTagSize=0,i=0;
	unsigned int iEndPointRefSize=0;

	while(index < strlen(Bye))
	{
		if((bStartTagFound == 0) && Bye[index] == TAG_START)
		{
			iStartTagIndex = index;
			bStartTagFound = 1;
		}
		if((bEndTagFound == 0) && Bye[index] == TAG_END)
		{
			iEndTagIndex = index+1;
			bEndTagFound = 1;
		}
		index++;
		if((bStartTagFound == 1) && (bEndTagFound == 1))
		{
			bStartTagFound = 0;
			bEndTagFound = 0;
			iTagSize = iEndTagIndex - iStartTagIndex;
			TAG = (char*)malloc(sizeof(char)*iTagSize);
			for(i=0;i<iTagSize;i++)
				TAG[i] = Bye[i+iStartTagIndex];
			TAG[i] = '\0';

			if(strstr(TAG,STR_ENDPOINTREFERENCE) != NULL)
			{
				if(strstr(TAG,MARKUP_END_TAG) == NULL)
				{
					iEndPointRefStartIndex = iEndTagIndex;
				}
				else
				{
					iEndPointRefEndIndex = iStartTagIndex;
					iEndPointRefSize = iEndPointRefEndIndex - iEndPointRefStartIndex;
					ENDPOINTREF = (char*)malloc(sizeof(char)*iEndPointRefSize);
					for(i=0;i<iEndPointRefSize;i++)
						ENDPOINTREF[i] = Bye[i+iEndPointRefStartIndex];
					ENDPOINTREF[i]='\0';
					wsd_ProcessEndPointRef(ENDPOINTREF,wsdmsg);
				}
			}
		}
	}
}

void wsd_ProcessProbe(char *Probe,WSDMSG_PTR wsdmsg)
{
	int bStartTagFound = 0,bEndTagFound = 0;
	unsigned int iStartTagIndex=0,iEndTagIndex=0;
	unsigned int iTypesStartIndex=0,iTypesEndIndex=0;
	unsigned int iScopesStartTagStartIndex=0,iScopesStartTagEndIndex=0;
	unsigned int iScopesStartIndex=0,iScopesEndIndex=0;
	unsigned int iXAddrsStartIndex=0,iXAddrsEndIndex=0;	
	char *TAG=NULL,*TYPES=NULL,*SCOPES=NULL,*SCOPESSTARTTAG=NULL,*XADDRS=NULL;
	unsigned int index=0,iTagSize=0,iTypesSize=0,iScopesSize=0,iScopesStartTagSize=0,i=0,iXAddrSize=0;

	while(index < strlen(Probe))
	{
		if((bStartTagFound == 0) && Probe[index] == TAG_START)
		{
			iStartTagIndex = index;
			bStartTagFound = 1;
		}
		if((bEndTagFound == 0) && Probe[index] == TAG_END)
		{
			iEndTagIndex = index+1;
			bEndTagFound = 1;
		}
		index++;
		if((bStartTagFound == 1) && (bEndTagFound == 1))
		{
			bStartTagFound = 0;
			bEndTagFound = 0;
			iTagSize = iEndTagIndex - iStartTagIndex;
			TAG = (char*)malloc(sizeof(char)*iTagSize);
			for(i=0;i<iTagSize;i++)
				TAG[i] = Probe[i+iStartTagIndex];
			TAG[i] = '\0';

			if(strstr(TAG,STR_TYPES) != NULL)
			{
				if(strstr(TAG,MARKUP_END_TAG) == NULL)
				{
					iTypesStartIndex = iEndTagIndex;
				}
				else
				{
					iTypesEndIndex = iStartTagIndex;
					iTypesSize = iTypesEndIndex - iTypesStartIndex;
					TYPES = (char*)malloc(sizeof(char)*iTypesSize);
					for(i=0;i<iTypesSize;i++)
						TYPES[i] = Probe[i+iTypesStartIndex];
					TYPES[i]='\0';
					wsdmsg_set_types(wsdmsg,TYPES);
				}
			}
			if(strstr(TAG,STR_SCOPES) != NULL)
			{
				if(strstr(TAG,MARKUP_END_TAG) == NULL)
				{
					iScopesStartIndex = iEndTagIndex;
					iScopesStartTagStartIndex = iStartTagIndex+1;
					iScopesStartTagEndIndex = iEndTagIndex-1;
					iScopesStartTagSize = iScopesStartTagEndIndex - iScopesStartTagStartIndex;
					SCOPESSTARTTAG = (char*)malloc(sizeof(char)*iScopesStartTagSize);
					for(i=0;i<iScopesStartTagSize;i++)
						SCOPESSTARTTAG[i] = Probe[i+iScopesStartTagStartIndex];
					SCOPESSTARTTAG[i] = '\0';
					wsd_ProcessScopesAttributes(wsdmsg,SCOPESSTARTTAG);
				}
				else
				{
					iScopesEndIndex = iStartTagIndex;
					iScopesSize = iScopesEndIndex - iScopesStartIndex;
					SCOPES = (char*)malloc(sizeof(char)*iScopesSize);
					for(i=0;i<iScopesSize;i++)
						SCOPES[i] = Probe[i+iScopesStartIndex];
					SCOPES[i] = '\0';
					wsdmsg_set_scopes(wsdmsg,SCOPES);		
				}
			}
			if(strstr(TAG,STR_XADDRS) != NULL)
			{
				if(strstr(TAG,MARKUP_END_TAG) == NULL)
				{
					iXAddrsStartIndex = iEndTagIndex;
				}
				else
				{
					iXAddrsEndIndex = iStartTagIndex;
					iXAddrSize = iXAddrsEndIndex - iXAddrsStartIndex;
					XADDRS = (char*)malloc(sizeof(char)*iXAddrSize);
					for(i=0;i<iXAddrSize;i++)
						XADDRS[i] = Probe[i+iXAddrsStartIndex];
					XADDRS[i]='\0';
					// TODO : Test Code
					wsdmsg_set_xaddrs(wsdmsg,XADDRS);
				}
			}			
		}
	}
	
}
void wsd_ProcessProbeMatches(char *ProbeMatches,WSDMSG_PTR wsdmsg)
{
	int bStartTagFound = 0,bEndTagFound = 0;
	unsigned int iStartTagIndex=0,iEndTagIndex=0;
	unsigned int iProbeMatchStartIndex=0,iProbeMatchEndIndex=0;
	char *TAG=NULL,*PROBEMATCH=NULL;
	unsigned int index=0,iTagSize=0,iProbeMatchSize=0,i=0;

	while(index < strlen(ProbeMatches))
	{
		if((bStartTagFound == 0) && ProbeMatches[index] == TAG_START)
		{
			iStartTagIndex = index;
			bStartTagFound = 1;
		}
		if((bEndTagFound == 0) && ProbeMatches[index] == TAG_END)
		{
			iEndTagIndex = index+1;
			bEndTagFound = 1;
		}
		index++;
		if((bStartTagFound == 1) && (bEndTagFound == 1))
		{
			bStartTagFound = 0;
			bEndTagFound = 0;
			iTagSize = iEndTagIndex - iStartTagIndex;
			TAG = (char*)malloc(sizeof(char)*iTagSize);
			for(i=0;i<iTagSize;i++)
				TAG[i] = ProbeMatches[i+iStartTagIndex];
			TAG[i] = '\0';
	
			//fprintf(stdout, "Next Probe Match Tag is %s\n",TAG);	
			
			if(strstr(TAG,STR_PROBEMATCH) != NULL)
			{
				if(strstr(TAG,MARKUP_END_TAG) == NULL)
				{
					iProbeMatchStartIndex = iEndTagIndex;
				}
				else
				{
					iProbeMatchEndIndex = iStartTagIndex;
					iProbeMatchSize = iProbeMatchEndIndex - iProbeMatchStartIndex;
					PROBEMATCH = (char*)malloc(sizeof(char)*iProbeMatchSize);
					for(i=0;i<iProbeMatchSize;i++)
						PROBEMATCH[i] = ProbeMatches[i+iProbeMatchStartIndex];
					PROBEMATCH[i]='\0';
					//fprintf(stdout, "Next Probe Match is %s\n",PROBEMATCH);						
					wsd_ProcessProbe(PROBEMATCH,wsdmsg);
				}
			}
					
		}
	}	
}

void wsd_ParseBodyString(char *Body,WSDMSG_PTR wsdmsg)
{	
	unsigned int index = 0;
	int bStartTagFound = 0,bEndTagFound = 0;
	unsigned int iStartTagIndex = 0,iEndTagIndex = 0,iTagSize=0;
	char *TAG = NULL;
	unsigned int iHelloStartIndex = 0,iHelloEndIndex = 0;
	unsigned int iByeStartIndex = 0,iByeEndIndex = 0;
	unsigned int iProbeStartIndex = 0,iProbeEndIndex = 0;
	unsigned int iProbeMatchStartIndex = 0,iProbeMatchEndIndex = 0;
	unsigned int iResolveStartIndex = 0,iResolveEndIndex = 0;
	unsigned int iResolveMatchStartIndex = 0,iResolveMatchEndIndex = 0;
	char *HELLO=NULL,*BYE=NULL,*PROBE=NULL,*PROBEMATCH=NULL,*RESOLVE=NULL,*RESOLVEMATCH=NULL;
	unsigned int iSize=0;

	while(index < strlen(Body))
	{
		if((bStartTagFound == 0) && Body[index] == TAG_START)
		{
			bStartTagFound = 1;
			iStartTagIndex = index;
		}
		if((bEndTagFound == 0) && Body[index] == TAG_END)
		{
			bEndTagFound = 1;
			iEndTagIndex = index+1;
		}
		index++;
		if((bStartTagFound == 1) && (bEndTagFound == 1))
		{
			bStartTagFound = 0;
			bEndTagFound = 0;
			
			iTagSize = iEndTagIndex - iStartTagIndex;
			TAG = (char*)malloc(sizeof(char)*iTagSize);
			unsigned int i= 0;
			for(i=0;i<iTagSize;i++)
				TAG[i] = Body[i+iStartTagIndex];
			TAG[i] = '\0';	
			
			//fprintf(stdout,"\nProcessBodyString----Next Tag is %s",TAG);
			if(strstr(TAG,ACTION_HELLO) != NULL)
			{
				if(strstr(TAG,MARKUP_END_TAG) == NULL)
				{
					iHelloStartIndex = iEndTagIndex;
				}
				else
				{
					iHelloEndIndex = iStartTagIndex;
					iSize = (iHelloEndIndex-iHelloStartIndex);
					HELLO = (char*)malloc(sizeof(char)*iSize);
					unsigned int i = 0;
					for(i=0;i<iSize;i++)
						HELLO[i] = Body[i+iHelloStartIndex];
					HELLO[i] = '\0';
					wsd_ProcessHello(HELLO,wsdmsg);
				}
			}
			if(strstr(TAG,ACTION_BYE) != NULL)
			{
				if(strstr(TAG,MARKUP_END_TAG) == NULL)
				{
					iByeStartIndex = iStartTagIndex;
				}
				else
				{
					iByeEndIndex = iEndTagIndex;
					iSize = (iByeEndIndex-iByeStartIndex);
					BYE = (char*)malloc(sizeof(char)*iSize);
					unsigned int i=0;
					for(i=0;i<iSize;i++)
						BYE[i] = Body[i+iByeStartIndex];
					BYE[i] = '\0';
					wsd_ProcessBye(BYE,wsdmsg);
				}
			}
			if(strstr(TAG,ACTION_PROBE) != NULL && strstr(TAG,ACTION_PROBEMATCH) == NULL)
			{
			
				if(strstr(TAG,MARKUP_END_TAG) == NULL)
				{
					iProbeStartIndex = iStartTagIndex;
				}
				else
				{
					iProbeEndIndex = iEndTagIndex;
					iSize = (iProbeEndIndex-iProbeStartIndex);
					PROBE = (char*)malloc(sizeof(char)*iSize);
					unsigned int i = 0;
					for(i=0;i<iSize;i++)
						PROBE[i] = Body[i+iProbeStartIndex];
					PROBE[i] = '\0';
					wsd_ProcessProbe(PROBE,wsdmsg);
				}
			}            
			if(strstr(TAG,ACTION_PROBEMATCH) != NULL)
			{
				if(strstr(TAG,MARKUP_END_TAG) == NULL)
				{
					iProbeMatchStartIndex = iEndTagIndex;					
				}
				else
				{
					iProbeMatchEndIndex = iStartTagIndex;
					iSize = (iProbeMatchEndIndex-iProbeMatchStartIndex);
					PROBEMATCH = (char*)malloc(sizeof(char)*iSize);
					unsigned int i = 0;
					for(i=0;i<iSize;i++)
						PROBEMATCH[i] = Body[i+iProbeMatchStartIndex];
					PROBEMATCH[i] = '\0';
					wsd_ProcessProbeMatches(PROBEMATCH,wsdmsg);
				}
			}
			if(strstr(TAG,ACTION_RESOLVEMATCH) != NULL)
			{
				if(strstr(TAG,MARKUP_END_TAG) == NULL)
				{
					iResolveMatchStartIndex = iEndTagIndex;					
				}
				else
				{
					iResolveMatchEndIndex = iStartTagIndex;
					iSize = (iResolveMatchEndIndex-iResolveMatchStartIndex);
					RESOLVEMATCH = (char*)malloc(sizeof(char)*iSize);
					unsigned int i = 0;
					for(i=0;i<iSize;i++)
						RESOLVEMATCH[i] = Body[i+iResolveMatchStartIndex];
					RESOLVEMATCH[i] = '\0';
					//ProcessResolveMatches(RESOLVEMATCH);
				}
			}            
			if(strstr(TAG,ACTION_RESOLVE) != NULL && strstr(TAG,ACTION_RESOLVEMATCH) == NULL && strstr(TAG,STR_RESOLVEMATCH) == NULL)
			{
				if(strstr(TAG,MARKUP_END_TAG) == NULL)
				{
					iResolveStartIndex = iEndTagIndex;					
				}
				else
				{
					iResolveEndIndex = iStartTagIndex;
					iSize = (iResolveEndIndex-iResolveStartIndex);
					RESOLVE = (char*)malloc(sizeof(char)*iSize);
					unsigned int i = 0;
					for(i=0;i<iSize;i++)
						RESOLVE[i] = Body[i+iResolveStartIndex];
					RESOLVE[i] = '\0';
					// Code is similar to probe parsing
					wsd_ProcessProbe(RESOLVE,wsdmsg);
					//ProcessResolve(RESOLVE);
				}
			}           
		}
	}
}
void wsd_parse_msg(PARSER_PTR parser, MSG_PTR message , EVENTSRC_PTR evt_src)
{
		
	fprintf(stdout, "wsd_parse_msg\n");
	char* msg = message->data;
	int len = message->length;	
	int index=0;
	int bStartTagFound = 0;
	int bPreprocessorFound = 0;
	int bEndTagFound = 0;
		
	WSDMSG_PTR wsdmsg = wsdmsg_create();	

	// Starting from the preprocessor tag
	while(index < len)
	{			
		if((bStartTagFound == 0) && msg[index] == TAG_START)
		{				
			bStartTagFound = 1;
		}	
		if((bPreprocessorFound == 0) && msg[index] == QUESTIONMARK)
		{
			bPreprocessorFound = 1;
		}
		if((bEndTagFound == 0) && msg[index] == TAG_END)
		{
			bEndTagFound = 1;			
		}
		index++;

		if(bEndTagFound == 1 && bPreprocessorFound == 1)
		{
			break;
		}			
	}

	// Here we have read the preprocessor directive
	bStartTagFound = 0;
	bEndTagFound = 0;

	// Going along with the envelope start tag
	int envMarkStart = 0, envMarkEnd = 0;
	while(index < len)
	{
		if((bStartTagFound == 0) && msg[index] == TAG_START)
		{
			bStartTagFound = 1;
			envMarkStart = index;
			//printf("Env start tag found");
		}
		index++;
		if((bEndTagFound == 0) && msg[index] == TAG_END)
		{
			bEndTagFound = 1;
			envMarkEnd = index+1;
			//printf("Env End tag found");
			break;
		}				
	}
	//printf("Start Index %d End Index %d",envMarkStart,envMarkEnd);
	int charCount = envMarkEnd - envMarkStart;
	char *envelopeString = (char*)malloc((sizeof(char)*charCount));
	int i = 0;
	for(i=0;i<charCount;i++)
		envelopeString[i] = msg[i+envMarkStart];	
	envelopeString[i] = '\0';

	//fprintf(stdout,"\nEnvelope String is \n%s",envelopeString);
	// Here we have read the Envelope
	
	// Going along with the header	
	bStartTagFound = 0;
	bEndTagFound = 0;		

	int headerMarkStart = index+2;
	int hearderMarkEnd = 0;
	int tagstartIndex = 0,tagEndIndex = 0;
	char *TAG = NULL;

	index++;
	while(index < len)
	{
		if((bStartTagFound == 0) && msg[index] == TAG_START)
		{
			bStartTagFound = 1;
			tagstartIndex = index;
		}
		if((bEndTagFound == 0) && msg[index] == TAG_END)
		{
			bEndTagFound = 1;
			tagEndIndex = index+1;
		}
		if(bStartTagFound == 1 && bEndTagFound == 1)
		{
			charCount = tagEndIndex - tagstartIndex;
			TAG = (char*)malloc(sizeof(char)*charCount);
			for( i = 0 ; i < charCount ; i++ )
				TAG[i]=msg[i+tagstartIndex];
			TAG[i]='\0';

			if(strstr(TAG,STR_HEADER) != NULL)
			{
				if(strstr(TAG,MARKUP_END_TAG) == NULL)
				{
					//printf("\nHeader Start Tag %s",TAG);
					headerMarkStart = tagstartIndex;
				}
				else
				{
					//printf("\nHeader End Tag %s",TAG);
					hearderMarkEnd = tagEndIndex;
					break;
				}
			}
			bStartTagFound = 0;
			bEndTagFound = 0;
			tagstartIndex = 0;
			tagEndIndex = 0;
			TAG = NULL;
		}
		index++;
	}
	int headerSize = hearderMarkEnd - headerMarkStart;
	char *headerString =  (char*)malloc(sizeof(char)*(headerSize));

	for( i=0;i<headerSize;i++)
		headerString[i] = msg[i+headerMarkStart];
	headerString[i] = '\0';	
	
	//fprintf(stdout,"\nHeader String is \n%s",headerString);
	
	wsd_ParseHeaderString(headerString,wsdmsg);// Here we have found ad parsed the header String

	// Now for the case of Body
	bStartTagFound = 0;
	bEndTagFound = 0;		

	int bodyMarkStart = 0,bodyMarkEnd = 0;
	tagstartIndex = 0,tagEndIndex = 0;
	TAG = NULL;

	index++;
	while(index < len)
	{
		if((bStartTagFound == 0) && msg[index] == TAG_START)
		{
			bStartTagFound = 1;
			tagstartIndex = index;
		}
		if((bEndTagFound == 0) && msg[index] == TAG_END)
		{
			bEndTagFound = 1;
			tagEndIndex = index+1;
		}
		if(bStartTagFound == 1 && bEndTagFound == 1)
		{
			charCount = tagEndIndex - tagstartIndex;
			TAG = (char*)malloc(sizeof(char)*charCount);
			for( i = 0 ; i < charCount ; i++ )
				TAG[i]=msg[i+tagstartIndex];
			TAG[i]='\0';

			if(strstr(TAG,STR_BODY) != NULL)
			{
				if(strstr(TAG,MARKUP_END_TAG) == NULL)
				{
					bodyMarkStart = tagstartIndex;
				}
				else
				{
					bodyMarkEnd = tagEndIndex;
					break;
				}
			}
			bStartTagFound = 0;
			bEndTagFound = 0;
			tagstartIndex = 0;
			tagEndIndex = 0;
		}
		index++;
	}
	int bodySize = bodyMarkEnd - bodyMarkStart;
	char *bodyString =  (char*)malloc(sizeof(char)*(bodySize));
	//fprintf(stdout,"\nBody String start %d end %d size %d  %s\n",bodyMarkStart,bodyMarkEnd,bodySize,bodyString);

	for( i=0;i<bodySize;i++)
		bodyString[i] = msg[i+bodyMarkStart];
	bodyString[i] = '\0';

	//fprintf(stdout,"\nBody String is \n%s",bodyString);
	wsd_ParseBodyString(bodyString,wsdmsg);
	
	wsdmsg_set_src_addr(wsdmsg, message->src_address);
	wsdmsg_set_src_port(wsdmsg, message->src_port);
	
	wsd_PrintWSDMSG(wsdmsg);		
	wsd_processEvents(parser, wsdmsg, evt_src);	
}
void *wsd_threaded_msg_parsing(void* ptr)
{
/*
	PARSINGTHREADDATA_PTR data = (PARSINGTHREADDATA_PTR)ptr;
	pthread_t thread_event_src = pthread_self();
	fprintf(stdout, "\nWSD PTHREAD parser = %p\n", thread_event_src);
	EVENTSRC_PTR evt_src = event_create_src((void*)thread_event_src, data->parser->unit);
	wsd_parse_msg(data->parser, data->msg , evt_src);
*/	
	
	
	PARSINGTHREADDATA_PTR data = (PARSINGTHREADDATA_PTR)ptr;
	MSG_PTR msg = (MSG_PTR)data->msg;
	PARSER_PTR parser = (PARSER_PTR)data->parser;
	
	// in case of the parsing of a reply message:
	//  - The events that are generated by this parser must not carry the identifier of this parser? thread  as their event src, but
	//    the thread identifier of the parser that received the request message and generated the related events. This identifier is stored in the
	//    unit eventqueue_table and the corresponding entry can be found using the dest port of the msg to be parsed (that corresponds to the 
	//	  port set in the table by "unit.c / set_socket_and_parser and set_socket_and_composer"
	EVENTQUEUE_TABLE_ENTRY_PTR entry_tmp = eventqueue_table_get_entry_by_current_socket_reply_port(parser->unit->event_table, msg->dest_port);
	
	if (entry_tmp == NULL && msg->dest_port == 3702)
	{
		/*
		 * In this case, the message is a discovery message received from a UPnP client
		 */
		fprintf(stdout, "wsd_threaded_msg_parsing. entry not found for socket_reply_port=%d\n", msg->dest_port);
		pthread_t thread_event_src = pthread_self();	
		fprintf(stdout, "\nWSD PTHREAD parser = %p\n", thread_event_src);
		
		EVENTSRC_PTR evt_src = event_create_src((void*)thread_event_src, data->parser->unit);
		
		wsd_parse_msg(parser, msg , evt_src);
		//return;
	} 
	else if (entry_tmp != NULL)
	{
		/*
		 * In this case, the message is a reply to a discovery message received from a UPnP service
		 */
			
		EVENTQUEUE_TABLE_ENTRY_PTR entry = /*entry_tmp; */ eventqueue_table_copy_entry(parser->unit->event_table, entry_tmp);
	
		fprintf(stdout, "wsd_threaded_msg_parsing. parser=%p  parser->unit=%p msg=%p\n", parser, parser->unit,msg);
				
		//fprintf(stdout, "ssdp_threaded_msg_parsing. SOCKET port is %d. thread id is %p\n",msg->dest_port, entry->stream_id);
		
		// the thread that parses this ssdp reply msg is used as an identifier for sub_stream_id
		pthread_t thread_event_src = pthread_self();
		fprintf(stdout, "\nWSD PTHREAD parser = %p\n", thread_event_src);
		entry->sub_stream_id = (int)thread_event_src;
		fprintf(stdout, "\nWSD PTHREAD parser entry->sub_stream_id = %p\n", entry->sub_stream_id);
		
		// the stream_id for the event is sub_stream_id to distinguish between the different event flows for reply messages 
		EVENTSRC_PTR evt_src = event_create_src((void*)entry->sub_stream_id, parser->unit);
		
		// add sub_stream_id to engine for handling the flow of events carrying sub_stream_id as stream_id
		//setCurrentState("UPNP_SLP_WAIT_UPNP_DEVICE_RESPONSE", entry->sub_stream_id, parser->unit->engine);
		setCurrentState("WSD_REQUEST_WAIT_WSD_DEVICE_RESPONSE"/*"UPNP_SLP_SSDP_REPLY"*/, entry->sub_stream_id, parser->unit->engine);
		
		
		//char* engine_current_state = getCurrentState(entry->sub_stream_id, parser->unit->engine);
		//setCurrentState(engine_current_state, entry->sub_stream_id, parser->unit->engine);
		
		wsd_parse_msg(parser, msg , evt_src);
		
		//free(evt_src);
	}
	else
		fprintf(stdout, "\nWSD PTHREAD parser : ENTRY NOT FOUND for ssdp reply to port %d\n",msg->dest_port);
	
	
	
	
	
	
	
			
	
}
PARSER_PTR wsd_parser_create(UNIT_PTR u)
{
	fprintf(stdout, "Creating WSD parser\n");
		
	PARSER_PTR p = parser_create(u);
	p->func_msg_received = parser_msg_received;	
	
	p->func_parse = wsd_threaded_msg_parsing;
	
	p->func_publish_event = parser_publish_event;
	p->evt_listeners = NULL;
	p->factory = wsd_parser_create;
	
	
	return p;	
}

