#include <stdio.h>
#include "protocol/slpmsg.h"


SLPMSG_PTR slpmsg_create()
{
	SLPMSG_PTR msg = malloc(sizeof(SLPMSG));

	msg->msg_version = 0;
	msg->function_id = 0;
	msg->length = 0;
	msg->xid = NULL;
	msg->lang_tag = NULL;
	msg->scope_list = NULL;
	msg->pr_list = NULL;
	msg->service_type = NULL;
	msg->predicate = NULL;
	msg->url_list = NULL;
	msg->remote_port = 0;
	
	return msg;
}



int slpmsg_set_version(SLPMSG_PTR msg, int msg_version)
{
	msg->msg_version = msg_version;
}

int slpmsg_get_version(SLPMSG_PTR msg)
{
	return msg->msg_version;
}

int slpmsg_set_function_id(SLPMSG_PTR msg, int function_id)
{
	msg->function_id = function_id;
}

int slpmsg_get_function_id(SLPMSG_PTR msg)
{
	return msg->function_id;
}

int slpmsg_set_length(SLPMSG_PTR msg, int length)
{
	msg->length = length;
}

int slpmsg_get_length(SLPMSG_PTR msg)
{
	return msg->length;
}

int slpmsg_set_xid(SLPMSG_PTR msg, char* xid)
{
	msg->xid = strdup(xid);
}

char* slpmsg_get_xid(SLPMSG_PTR msg)
{
	return msg->xid;
}

int slpmsg_set_error_code(SLPMSG_PTR msg, int error_code)
{
	msg->error_code = error_code;
}

int slpmsg_get_error_code(SLPMSG_PTR msg)
{
	return msg->error_code;
}
		 
int slpmsg_set_lang_tag(SLPMSG_PTR msg, char* lang_tag)
{
	if (lang_tag == NULL)
		msg->lang_tag = NULL;
	else
	{		
		msg->lang_tag = strdup(lang_tag);
	}
}

char* slpmsg_get_lang_tag(SLPMSG_PTR msg)
{
	return msg->lang_tag;
} 

int slpmsg_set_scope_list(SLPMSG_PTR msg, char* scope_list)
{
	if (scope_list == NULL)
		msg->scope_list = NULL;
	else
	{
		msg->scope_list = strdup(scope_list);
	}
}

char* slpmsg_get_scope_list(SLPMSG_PTR msg)
{
	return msg->scope_list;
} 

int slpmsg_set_pr_list(SLPMSG_PTR msg, char* pr_list)
{
	if (pr_list == NULL)
		msg->pr_list = NULL;
	else
	{
		msg->pr_list = strdup(pr_list);
	}
}

char* slpmsg_get_pr_list(SLPMSG_PTR msg)
{
	return msg->pr_list;
} 

int slpmsg_set_service_type(SLPMSG_PTR msg, char* service_type)
{
	if (service_type == NULL)
		msg->service_type = NULL;
	else
	{
		msg->service_type = strdup(service_type);
	}
}

char* slpmsg_get_service_type(SLPMSG_PTR msg)
{
	return msg->service_type;
} 

		 
int slpmsg_set_predicate(SLPMSG_PTR msg, char* predicate)
{
	if (predicate == NULL)
		msg->predicate = NULL;
	else
	{
		msg->predicate = strdup(predicate);
	}
}

char* slpmsg_get_predicate(SLPMSG_PTR msg)
{
	return msg->predicate;
} 

int slpmsg_set_url_list(SLPMSG_PTR msg, char* url_list)
{
	if (url_list == NULL)
		msg->url_list = NULL;
	else
	{
		msg->url_list = strdup(url_list);
	}
}

char* slpmsg_get_url_list(SLPMSG_PTR msg)
{
	return msg->url_list;
} 	
	

int slpmsg_set_src_addr(SLPMSG_PTR msg, char* src_addr)
{
	if (src_addr == NULL)
		msg->src_addr = NULL;
	else
	{
		msg->src_addr = strdup(src_addr);
	}
}

char* slpmsg_get_src_addr(SLPMSG_PTR msg)
{
	return msg->src_addr;
}

int slpmsg_set_src_port(SLPMSG_PTR msg, int src_port)
{
	msg->src_port = src_port;
}

int slpmsg_get_src_port(SLPMSG_PTR msg)
{
	return msg->src_port;
}

int slpmsg_set_dest_addr(SLPMSG_PTR msg, char* dest_addr)
{
	if (dest_addr == NULL)
		msg->dest_addr = NULL;
	else
	{
		msg->dest_addr = strdup(dest_addr);
	}
}

char* slpmsg_get_dest_addr(SLPMSG_PTR msg)
{
	return msg->dest_addr;
}

int slpmsg_set_dest_port(SLPMSG_PTR msg, int dest_port)
{
	msg->dest_port = dest_port;
}

int slpmsg_get_dest_port(SLPMSG_PTR msg)
{
	return msg->dest_port;
}

int slpmsg_set_n_url_entries(SLPMSG_PTR msg, int n_url_entries)
{
	msg->n_url_entries = n_url_entries;
	msg->url_entries = malloc(n_url_entries*sizeof(char*));
	int i;
	for (i=0; i<msg->n_url_entries; i++)
		msg->url_entries[i] = NULL;
}

int slpmsg_get_n_url_entries(SLPMSG_PTR msg)
{
	return msg->n_url_entries;
}

int slpmsg_set_url_entry(SLPMSG_PTR msg, int index_url_entry, char* url_entry)
{
	if (url_entry != NULL)
	{
		msg->url_entries[index_url_entry] = strdup(url_entry);
	}
	else
		msg->url_entries[index_url_entry] = NULL;
}

char* slpmsg_get_url_entry(SLPMSG_PTR msg, int index_url_entry)
{
	return msg->url_entries[index_url_entry];
}		 




