#include <stdio.h>
#include "protocol/wsdmsg.h"
#include "protocol/wsd.h"

WSDMSG_PTR wsdmsg_create()
{
	WSDMSG_PTR msg = (WSDMSG_PTR)malloc(sizeof(WSDMSG));

	msg->action = NULL;
	msg->message_id = NULL;
	msg->to = NULL;
	msg->relates_to = NULL;
	msg->instance_id = NULL;
	msg->message_number = 0;
	
	msg->types = NULL;
	msg->matchby = NULL;
	msg->scopes = NULL;
	msg->address = NULL;
	msg->xaddrs = NULL;
	msg->meta_data_version = NULL;		
	
	msg->src_addr = NULL;
	msg->src_port = 0;
	msg->dest_addr = NULL;
	msg->dest_port = 0;
	
	return msg;
}


void wsd_PrintMessageType(WSDMSG_PTR wsdmsg)
{
	switch(wsdmsg->message_type)
	{
		case WSD_HELLO_MSG : fprintf(stdout,"\nHello Message-------");
		break;
		case WSD_BYE_MSG : fprintf(stdout,"\nBye Message-------");	 
		break;
		case WSD_PROBE_MSG : fprintf(stdout,"\nProbe Message-------");		
		break;
		case WSD_PROBE_MATCH_MSG : fprintf(stdout,"\nProbe Match Message-------");	
		break;
		case WSD_RESOLVE_MSG : 	fprintf(stdout,"\nResolve Message-------");
		break;
		case WSD_RESOLVE_MATCH_MSG : fprintf(stdout,"\nResolve Match Message-------");	
		break;
		default:
		break;

	}
}
void wsd_PrintWSDMSG(WSDMSG_PTR wsdmsg)
{
	fprintf(stdout,"\n-----------------");
	fprintf(stdout,"\n----WSDMESSAGE---");
	fprintf(stdout,"\n-----------------");
	
	wsd_PrintMessageType(wsdmsg);
	if(wsdmsg->action != NULL)
		fprintf(stdout,"\nACTION-------%s",wsdmsg->action);
		
	if(wsdmsg->message_id != NULL)
	 	fprintf(stdout,"\nMESSAGEID-------%s",wsdmsg->message_id);

	if(wsdmsg->to != NULL)
	 	fprintf(stdout,"\nTO-------%s",wsdmsg->to);
				
	if(wsdmsg->relates_to != NULL)
	 	fprintf(stdout,"\nRELATESTO-------%s",wsdmsg->relates_to);
		
	if(wsdmsg->instance_id != NULL)
	 	fprintf(stdout,"\nINSTANCEID-------%s",wsdmsg->instance_id);
	
 	fprintf(stdout,"\nMESSAGENUMBER-------%d",wsdmsg->message_number);
		
	if(wsdmsg->types != NULL)
	 	fprintf(stdout,"\nTYPES-------%s",wsdmsg->types);
	
	if(wsdmsg->matchby != NULL)
	 	fprintf(stdout,"\nMATCHBY-------%s",wsdmsg->matchby);

	if(wsdmsg->scopes != NULL)
	 	fprintf(stdout,"\nSCOPES-------%s",wsdmsg->scopes);
				
	if(wsdmsg->address != NULL)
	 	fprintf(stdout,"\nADDRESS-------%s",wsdmsg->address);	
	
	if(wsdmsg->xaddrs != NULL)
	 	fprintf(stdout,"\nXADDRS-------%s",wsdmsg->xaddrs);
		
 	fprintf(stdout,"\nMETADATAVERSION-------%s",wsdmsg->meta_data_version);
	
}
int wsdmsg_set_message_type(WSDMSG_PTR msg, int message_type)
{
	fprintf(stdout,"\n wsdmsg_set_message_type ------- %d",message_type);
	
	msg->message_type = message_type;	
}
int wsdmsg_set_action(WSDMSG_PTR msg, char* action)
{
	fprintf(stdout,"\n wsdmsg_set_action ------- %s",action);
	
	msg->action = action;	
	
	if(strstr(action,ACTION_HELLO) != NULL)		
		wsdmsg_set_message_type(msg,WSD_HELLO_MSG);				
	if(strstr(action,ACTION_BYE) != NULL)		
		wsdmsg_set_message_type(msg,WSD_BYE_MSG);	
	if(strstr(action,ACTION_PROBE) != NULL)	
		wsdmsg_set_message_type(msg,WSD_PROBE_MSG);	
	if(strstr(action,ACTION_PROBEMATCH) != NULL)	
		wsdmsg_set_message_type(msg,WSD_PROBE_MATCH_MSG);	
	if(strstr(action,ACTION_RESOLVE) != NULL)	
		wsdmsg_set_message_type(msg,WSD_RESOLVE_MSG);	
	if(strstr(action,ACTION_RESOLVEMATCH) != NULL)	
		wsdmsg_set_message_type(msg,WSD_RESOLVE_MATCH_MSG);
	/*
	if(!strcmp(action,ACTION_HELLO))		
		wsdmsg_set_message_type(msg,WSD_HELLO_MSG);				
	if(!strcmp(action,ACTION_BYE))		
		wsdmsg_set_message_type(msg,WSD_BYE_MSG);	
	if(!strcmp(action,ACTION_PROBE))	
		wsdmsg_set_message_type(msg,WSD_PROBE_MSG);	
	if(!strcmp(action,ACTION_PROBEMATCH))	
		wsdmsg_set_message_type(msg,WSD_PROBE_MATCH_MSG);	
	if(!strcmp(action,ACTION_RESOLVE))	
		wsdmsg_set_message_type(msg,WSD_RESOLVE_MSG);	
	if(!strcmp(action,ACTION_RESOLVEMATCH))	
		wsdmsg_set_message_type(msg,WSD_RESOLVE_MATCH_MSG);
		*/
	
	
}
int wsdmsg_set_message_id(WSDMSG_PTR msg, char* message_id)
{
	msg->message_id = message_id;
}
int wsdmsg_set_to(WSDMSG_PTR msg,char* to)
{
	msg->to = to;
}
int wsdmsg_set_relates_to(WSDMSG_PTR msg, char* relates_to)
{
	msg->relates_to = relates_to;
}
int wsdmsg_set_instance_id(WSDMSG_PTR msg, char* instance_id)
{
	msg->instance_id = instance_id;
}
int wsdmsg_set_message_number(WSDMSG_PTR msg, int message_number)
{
	msg->message_number = message_number;
}
int wsdmsg_set_types(WSDMSG_PTR msg, char* types)
{
	msg->types = types;
}
int wsdmsg_set_matchby(WSDMSG_PTR msg, char* matchby)
{
	msg->matchby = matchby;
}
int wsdmsg_set_scopes(WSDMSG_PTR msg, char* scopes)
{
	msg->scopes = scopes;
}
int wsdmsg_set_address(WSDMSG_PTR msg, char* address)
{
	msg->address = address;
}
int wsdmsg_set_xaddrs(WSDMSG_PTR msg, char* xaddrs)
{
	msg->xaddrs = xaddrs;
}
int wsdmsg_set_meta_data_version(WSDMSG_PTR msg, char* meta_data_version)
{
	//msg->meta_data_version = mata_data_version;
}
int wsdmsg_set_src_addr(WSDMSG_PTR msg, char* src_addr)
{
	msg->src_addr = src_addr;
}
int wsdmsg_set_src_port(WSDMSG_PTR msg, int src_port)
{
	msg->src_port = src_port;
}
int wsdmsg_set_dest_addr(WSDMSG_PTR msg, char* dest_addr)
{
	msg->dest_addr = dest_addr;
}
int wsdmsg_set_dest_port(WSDMSG_PTR msg, int dest_port)
{
	msg->dest_port = dest_port;
}
int wsdmsg_set_url(WSDMSG_PTR msg, char *url)
{
	msg->url = url;
}
int wsdmsg_set_no_url(WSDMSG_PTR msg, char *no_url)
{
	msg->no_url = no_url;
}

int wsdmsg_get_message_type(WSDMSG_PTR msg)
{
	return msg->message_type;
}
char* wsdmsg_get_action(WSDMSG_PTR msg)
{
	return msg->action;
}
char* wsdmsg_get_url(WSDMSG_PTR msg)
{
	return msg->url;
}
char* wsdmsg_get_no_url(WSDMSG_PTR msg)
{
	return msg->no_url;
}

char* wsdmsg_get_message_id(WSDMSG_PTR msg)
{
	return msg->message_id;
}
char* wsdmsg_get_to(WSDMSG_PTR msg)
{
	return msg->to;
}
char* wsdmsg_get_relates_to(WSDMSG_PTR msg)
{
	return msg->relates_to;
}
char* wsdmsg_get_instance_id(WSDMSG_PTR msg)
{
	return msg->instance_id;
}
int wsdmsg_get_message_number(WSDMSG_PTR msg)
{
	return msg->message_number;
}
char* wsdmsg_get_types(WSDMSG_PTR msg)
{
	return msg->types;
}
char* wsdmsg_get_matchby(WSDMSG_PTR msg)
{
	return msg->matchby;
}
char* wsdmsg_get_scopes(WSDMSG_PTR msg)
{
	return msg->scopes;
}
char* wsdmsg_get_address(WSDMSG_PTR msg)
{
	return msg->address;
}
char* wsdmsg_get_xaddrs(WSDMSG_PTR msg)
{
	return msg->xaddrs;
}
char* wsdmsg_get_meta_data_version(WSDMSG_PTR msg)
{
	return msg->meta_data_version;
}
char* wsdmsg_get_src_addr(WSDMSG_PTR msg)
{
	return msg->src_addr;
}
int wsdmsg_get_src_port(WSDMSG_PTR msg)
{
	return msg->src_port;
}
char* wsdmsg_get_dest_addr(WSDMSG_PTR msg)
{
	return msg->dest_addr;
}
int wsdmsg_get_dest_port(WSDMSG_PTR msg)
{
	return msg->dest_port;
}
