#include "unit/unit.h"
#include <stdio.h>

#include "socket/socket.h"
#include "event/eventqueue_table.h"
#include "event/event.h"
#include "parser/parser.h"

void switch_to_parser(char* name)
{
	fprintf(stdout,"switch to parser: %s\n",name);
	
}

void switch_to_composer(char* name)
{
	fprintf(stdout,"switch to composer: %s\n",name);
	
}

void switch_to_socket(char* name)
{
	fprintf(stdout,"switch to socket: %s\n",name);
	
}

ACTION_PTR slp_extra_actions()
{
	ACTION_PTR a1 = action_create_function1("switch_to_parser", switch_to_parser );
	ACTION_PTR a2 = action_create_function1("switch_to_socket", switch_to_socket );
	ACTION_PTR a3 = action_create_function1("switch_to_composer", switch_to_composer );
	a1->next_action = a2;
	a2->next_action = a3;
	return a1;
}


void slpunit_event_received(EVENT_PTR evt, LISTENER_PTR node)
{
	fprintf(stdout, "SLP");
	unit_event_received(evt, node);
}


UNIT_PTR slpunit_create(char* sm_filename)
{
	
	
	ACTION_PTR extra_actions = slp_extra_actions();
	UNIT_PTR u = unit_create(sm_filename, extra_actions);
	fprintf(stdout, "Creating SLP unit %p\n", u);
	
	PARSER_PTR p = slp_parser_create(u);
	char key[255];
	strcpy(key, "SLP");
	unit_addparser(u, key, p);	
	unit_add_msglistener_parser(u, p);
 	u->current_parser = p;
	parser_add_evtlistener_unit(p, u);
	
	COMPOSER_PTR c = slpcomposer_create(u);
	char key1[255];
	strcpy(key1, "SLP");
	unit_addcomposer(u, key1, c);
	
//	unit_add_evtlistener_composer(u, c);
// 	u->current_composer = c;
/*	
	//SOCKET_PTR s = udpmcsocket_create(u);
	//socket_add_msglistener_unit(s, u);
	//unit_add_msglistener_socket(u, s);
	
	//composer_add_msglistener_socket(c, s);
	
	// how can I configure the socket?
	//char mc_addr_str[255];
	//strcpy(mc_addr_str, "239.255.255.253");
	//unsigned short mc_port = 427;
*/
 	
	SOCKET_PTR s = udpmcsocket_create(u);
	char key2[255];
	strcpy(key2, "UDPMC");
	unit_addsocket(u, key2, s);	

	SOCKET_PTR s2 = udp_socket_create(u);
	char key3[255];
	strcpy(key3, "UDP");
	unit_addsocket(u, key3, s2);	
	
	
	
	/*
	 *	to be moved in monitor and find a generic solution
	 *	for unit creation with factory and set as listeners
	 *	on unit of the other and the other way round 
	 */

	 UNIT_PTR upnp_unit = upnpunit_create2("upnpunit.sm");
	 unit_add_evtlistener_unit(u, upnp_unit);
	 unit_add_evtlistener_unit(upnp_unit, u);
	 
	 UNIT_PTR wsd_unit = wsdunit_create2("wsdunit.sm");
	 unit_add_evtlistener_unit(u, wsd_unit);
	 unit_add_evtlistener_unit(wsd_unit, u);
	
	 UNIT_PTR rmiproxy_unit = rmiproxy_unit_create2("rmiproxy_unit.sm");
	 unit_add_evtlistener_unit_proxy(u, rmiproxy_unit );
	 unit_add_evtlistener_unit(rmiproxy_unit , u);
	 
	 
	 /*
	 UNIT_PTR wsd_unit = wsdunit_create("wsdunit.sm");
	 unit_add_evtlistener_unit(u, wsd_unit);
	 */
	 
	 u->func_event_received = slpunit_event_received; 
	 
	return u;	
}


UNIT_PTR slpunit_create2(char* sm_filename)
{
	
	
	//ACTION_PTR extra_actions = slp_extra_actions();
	UNIT_PTR u = unit_create(sm_filename, NULL);
	fprintf(stdout, "Creating SLP unit %p\n", u);
	
	PARSER_PTR p = slp_parser_create(u);
	char key[255];
	strcpy(key, "SLP");
	unit_addparser(u, key, p);	

	
	COMPOSER_PTR c = slpcomposer_create(u);
	char key1[255];
	strcpy(key1, "SLP");
	unit_addcomposer(u, key1, c);
	
//	unit_add_evtlistener_composer(u, c);
// 	u->current_composer = c;
/*	
	//SOCKET_PTR s = udpmcsocket_create(u);
	//socket_add_msglistener_unit(s, u);
	//unit_add_msglistener_socket(u, s);
	
	//composer_add_msglistener_socket(c, s);
	
	// how can I configure the socket?
	//char mc_addr_str[255];
	//strcpy(mc_addr_str, "239.255.255.253");
	//unsigned short mc_port = 427;
*/
 	
	SOCKET_PTR s = udpmcsocket_create(u);
	char key2[255];
	strcpy(key2, "UDPMC");
	unit_addsocket(u, key2, s);	

	SOCKET_PTR s2 = udp_socket_create(u);
	char key3[255];
	strcpy(key3, "UDP");
	unit_addsocket(u, key3, s2);	

	
	
	COMPOSER_PTR c2 = jrmp_composer_create(u);
	char key4[255];
	strcpy(key4, "JRMP");
	unit_addcomposer(u, key4, c2);

	 
	 u->func_event_received = slpunit_event_received; 
	 
	return u;	
}

