 
#include "socket/socket.h"
#include "event/eventqueue_table.h"
#include "event/event.h"
#include <stdio.h>


UNIT_PTR wsdunit_create(char* sm_filename)
{
	fprintf(stdout, "Creating WSD unit\n");
	
	UNIT_PTR u = unit_create(sm_filename, NULL);	
	
	PARSER_PTR p = wsd_parser_create(u);
	char key[255];
	strcpy(key, "WSD");
	unit_addparser(u, key, p);
	unit_add_msglistener_parser(u, p);
 	u->current_parser = p;
	parser_add_evtlistener_unit(p, u);
	
	COMPOSER_PTR c = wsdcomposer_create(u);
	char key1[255];
	strcpy(key1, "WSD");
	unit_addcomposer(u, key1, c);
	
	unit_add_evtlistener_composer(u, c);
 	u->current_composer = c;

	COMPOSER_PTR c1 = wsdlcomposer_create(u);
	char key4[255];
	strcpy(key4, "WSDL");
	unit_addcomposer(u, key4, c1);	
	unit_add_evtlistener_composer(u, c1);
 	u->current_composer = c1;
	
	PARSER_PTR p2 = wsdl_parser_create(u);
	char key5[255];
	strcpy(key5, "WSDL");
	unit_addparser(u, key5, p2);
	unit_add_msglistener_parser(u, p2);
 	u->current_parser = p2;
	parser_add_evtlistener_unit(p2, u);	
		
	SOCKET_PTR s = udpmcsocket_create(u);
	socket_add_msglistener_unit(s, u);
	unit_add_msglistener_socket(u, s);
	
	SOCKET_PTR s1 = udpmcsocket_create(u);
	char key2[255];
	strcpy(key2, "UDPMC");
	unit_addsocket(u, key2, s1);	

	SOCKET_PTR s2 = udp_socket_create(u);
	char key3[255];
	strcpy(key3, "UDP");
	unit_addsocket(u, key3, s2);

	SOCKET_PTR s3 = http_socket_create(u);
	char key6[255];
	strcpy(key6, "HTTP");
	unit_addsocket(u, key6, s3);
			
	
	
	 UNIT_PTR upnp_unit = upnpunit_create2("upnpunit.sm");
	 unit_add_evtlistener_unit(u, upnp_unit);
	 unit_add_evtlistener_unit(upnp_unit, u);
	 
	 UNIT_PTR slp_unit = slpunit_create2("slpunit.sm");
	 unit_add_evtlistener_unit(u, slp_unit);
	 unit_add_evtlistener_unit(slp_unit, u);
	
	 UNIT_PTR wsdproxy_unit = wsdproxy_unit_create2("wsdproxy_unit.sm");
	 unit_add_evtlistener_unit_proxy(u, wsdproxy_unit );
	 unit_add_evtlistener_unit(wsdproxy_unit , u);
	 
	
	return u;	
}

UNIT_PTR wsdunit_create2(char* sm_filename)
{
	fprintf(stdout, "Creating WSD unit\n");
	
	UNIT_PTR u = unit_create(sm_filename, NULL);	
	
	PARSER_PTR p = wsd_parser_create(u);
	char key[255];
	strcpy(key, "WSD");
	unit_addparser(u, key, p);
	unit_add_msglistener_parser(u, p);
 	u->current_parser = p;
	parser_add_evtlistener_unit(p, u);
	
	COMPOSER_PTR c = wsdcomposer_create(u);
	char key1[255];
	strcpy(key1, "WSD");
	unit_addcomposer(u, key1, c);
	
	unit_add_evtlistener_composer(u, c);
 	u->current_composer = c;

	COMPOSER_PTR c1 = wsdlcomposer_create(u);
	char key4[255];
	strcpy(key4, "WSDL");
	unit_addcomposer(u, key4, c1);	
	unit_add_evtlistener_composer(u, c1);
 	u->current_composer = c1;
	
	PARSER_PTR p2 = wsdl_parser_create(u);
	char key5[255];
	strcpy(key5, "WSDL");
	unit_addparser(u, key5, p2);
	unit_add_msglistener_parser(u, p2);
 	u->current_parser = p2;
	parser_add_evtlistener_unit(p2, u);	
		
	SOCKET_PTR s = udpmcsocket_create(u);
	socket_add_msglistener_unit(s, u);
	unit_add_msglistener_socket(u, s);
	
	SOCKET_PTR s1 = udpmcsocket_create(u);
	char key2[255];
	strcpy(key2, "UDPMC");
	unit_addsocket(u, key2, s1);	

	SOCKET_PTR s2 = udp_socket_create(u);
	char key3[255];
	strcpy(key3, "UDP");
	unit_addsocket(u, key3, s2);

	SOCKET_PTR s3 = http_socket_create(u);
	char key6[255];
	strcpy(key6, "HTTP");
	unit_addsocket(u, key6, s3);
			
	return u;	
}

/*


{WSD_WAIT_CREATE_RESPONSE}
{}
{
	[ SDP_STOP ]
	[ nil ]
	[ print_str("WSDUNIT: stay in state WSD_WAIT_CREATE_RESPONSE")]

	[]
	[nil]
	[print_str("WSDUNIT: evt received <> STOP. stay in state WSD_WAIT_CREATE_RESPONSE")
	unit_dispatch_evt_to_listeners(EVT)]
}
*/

