#include <stdio.h>
#include <stdlib.h>
#include <vm/constantpoolinfo.h>
#include <kazlib/list.h>
#include <io/io.h>
#include <assert.h>

POOL_PTR new_pool(){
	POOL_PTR pool;
	pool=malloc(sizeof(POOL));
	pool->tab=NULL;
	pool->size=1;
	pool->listConstString= list_create(LISTCOUNT_T_MAX);
	pool->listConstClass= list_create(LISTCOUNT_T_MAX );
	pool->listConstRef= list_create(LISTCOUNT_T_MAX );
	pool->listConstType= list_create(LISTCOUNT_T_MAX );			
	pool->listConstNameType= list_create(LISTCOUNT_T_MAX );		
	pool->listConstUtf8= list_create(LISTCOUNT_T_MAX );			
	pool->listConstPrimitive= list_create(LISTCOUNT_T_MAX );	
return pool;	
}
/**
*	OK
*/
int pool_compare_utf8_entry(const void* node1,const void* node2)
{
	POOL_ENTRY_PTR 	entry;
	UTF8_INFO_PTR 	info;
	UTF8_PTR utf8_1;
	UTF8_PTR utf8_2;
	entry=(POOL_ENTRY_PTR)node1;		
	info=(UTF8_INFO_PTR)entry->info.utf8;
	utf8_1=info->utf8;
	entry=(POOL_ENTRY_PTR)node2;		
	info=(UTF8_INFO_PTR)entry->info.utf8;
	utf8_2=info->utf8;
	if(utf8_2->size==utf8_1->size)
		return memcmp(utf8_1->utf8,utf8_2->utf8,utf8_1->size);
	return -1;
}

int pool_compare_class_entry(const void* node1,const void* node2)
{
	POOL_ENTRY_PTR 	entry;
	CLASS_INFO_PTR 	info;
	uint16 i1,i2;
	entry=(POOL_ENTRY_PTR)node1;		
	info=(CLASS_INFO_PTR)entry->info.cl;
	i1=*info->name_index;
	entry=(POOL_ENTRY_PTR)node2;		
	info=(CLASS_INFO_PTR)entry->info.cl;
	i2=*info->name_index;	
	if(i1==i2)
		return 0;
	return -1;
}

int pool_compare_name_type_entry(const void* node1, const void* node2)
{
	POOL_ENTRY_PTR 	entry;
	NAME_TYPE_INFO_PTR info;
	uint16 i1,i2,i3,i4;
	entry=(POOL_ENTRY_PTR)node1;		
	info=(NAME_TYPE_INFO_PTR)entry->info.cl;
	i1=*info->name_index;
	i2=*info->descriptor_index;
	entry=(POOL_ENTRY_PTR)node2;		
	info=(NAME_TYPE_INFO_PTR)entry->info.cl;
	i3=*info->name_index;
	i4=*info->descriptor_index;
	if((i1==i3)&&(i2==i4))
		return 0;
	return -1;
}

int pool_compare_ref_entry(const void* node1,const void* node2)
{
	POOL_ENTRY_PTR 	entry;
	REF_INFO_PTR info;
	uint16 i1,i2,i3,i4;
	entry=(POOL_ENTRY_PTR)node1;		
	info=(REF_INFO_PTR)entry->info.ref;
	i1=*info->class_index;
	i2=*info->name_and_type_index;
	entry=(POOL_ENTRY_PTR)node2;		
	info=(REF_INFO_PTR)entry->info.ref;
	i3=*info->class_index;
	i4=*info->name_and_type_index;
	if((i1==i3)&&(i2==i4))
		return 0;
	return -1;
}

int pool_compare_long_entry(const void* node1,const void* node2)
{
	POOL_ENTRY_PTR 	entry;
	LONG_INFO_PTR info;
	j_long l1,l2;
	entry=(POOL_ENTRY_PTR)node1;		
	info=(LONG_INFO_PTR)entry->info.l;
	l1=info->long_bytes;
	entry=(POOL_ENTRY_PTR)node2;		
	info=(LONG_INFO_PTR)entry->info.l;
	l2=info->long_bytes;
	if((l1==l2))
		return 0;
	return -1;
}

int pool_compare_string_entry(const void* node1,const void* node2)
{
	POOL_ENTRY_PTR 	entry;
	STRING_INFO_PTR info;
	uint16 i1,i2;
	entry=(POOL_ENTRY_PTR)node1;		
	info=(STRING_INFO_PTR)entry->info.string;
	i1=*info->string_index;
	entry=(POOL_ENTRY_PTR)node2;		
	info=(STRING_INFO_PTR)entry->info.string;
	i2=*info->string_index;
	if((i1==i2))
		return 0;
	return -1;
}

POOL_ENTRY_PTR pool_search_for_utf8_entry(POOL_PTR pool,POOL_ENTRY_PTR utf8_entry)
{
	lnode_t* result=\
		list_find(pool->listConstUtf8,utf8_entry,pool_compare_utf8_entry);
	if(result!=NULL)
		return (POOL_ENTRY_PTR)lnode_get(result);
	return NULL;
}

/*
int pool_search_for_utf8_2(POOL_PTR pool,const char* pattern)
{
	lnode_t* result;
	POOL_ENTRY_PTR entry;
	list_t* list;
	lnode_t* node;
	list=pool->listConstUtf8;
	entry= new_constant_utf8_info(pattern);
	result=list_find(list,entry,pool_compare_utf8_entry);
	free(entry->info.utf8);
	free(entry);
	if(result!=NULL)
		return 0;
	return -1;
}*/

/**
* 	OK
*/
POOL_ENTRY_PTR pool_search_for_utf8_3(POOL_PTR pool,const char* pattern)
{
	lnode_t* result;
	POOL_ENTRY_PTR entry;
	list_t* list;
	lnode_t* node;
	list=pool->listConstUtf8;
	entry= new_constant_utf8_info(pattern);
	result=list_find(list,entry,pool_compare_utf8_entry);
	free(entry->info.utf8);
	free(entry);

	if(result!=NULL)
	{
		return (POOL_ENTRY_PTR)lnode_get(result);
	}
	return NULL;
}
/*
POOL_ENTRY_PTR pool_search_for_ref(POOL_PTR pool,const char* nameClass\
									,const char* name, const char* type)
{

}*/

/*
POOL_ENTRY_PTR pool_search_for_class_name( POOL_PTR pool,const char* nameClass)
{
	uint16 index;
	POOL_ENTRY_PTR entry;
	entry=pool_search_for_utf8_3(pool,nameClass);
	if(entry==NULL)
			return NULL;
	assert(entry->index!=0);
	index=entry->index;
	entry=pool_search_for_class_index(pool,index);
	if(entry!=NULL)
	{
		assert(entry->index!=0);
		return entry;
	}
	return NULL;
}
/*
POOL_ENTRY_PTR pool_search_for_class_index(POOL_PTR pool,uint16 index)
{
	lnode_t* result;
	POOL_ENTRY_PTR entry;
	list_t* list;
	list=pool->listConstClass;
	if(list_count(list)==0) 
		return NULL;
	entry= new_constant_class_info(&index);
	result=list_find(list,entry,pool_compare_class_entry);
	free(entry->info.cl);
	free(entry);
	if(result!=NULL)
		return (POOL_ENTRY_PTR)lnode_get(result);
	return NULL;
}*/

POOL_ENTRY_PTR pool_search_for_class_entry(POOL_PTR pool,POOL_ENTRY_PTR class)
{
	lnode_t*result=\
		list_find(pool->listConstClass,class,pool_compare_class_entry);
	if(result!=NULL)
		return (POOL_ENTRY_PTR)lnode_get(result);
	return NULL;
}

POOL_ENTRY_PTR pool_search_for_name_and_type_entry(POOL_PTR pool,POOL_ENTRY_PTR entry)
{
	lnode_t*result=\
		list_find(pool->listConstNameType,entry,pool_compare_name_type_entry);
	if(result!=NULL)
		return (POOL_ENTRY_PTR)lnode_get(result);
	return NULL;
}

POOL_ENTRY_PTR pool_search_for_ref_entry(POOL_PTR pool,POOL_ENTRY_PTR entry)
{
	lnode_t*result=\
		list_find(pool->listConstRef,entry,pool_compare_ref_entry);
	if(result!=NULL)
		return (POOL_ENTRY_PTR)lnode_get(result);
	return NULL;
}

POOL_ENTRY_PTR pool_search_entry(POOL_PTR pool,POOL_ENTRY_PTR entry)
{
	int (*func)(const void *, const void *);
	TAG t=entry->tag;
	list_t* l;
	switch(t)
	{
		case CONSTANT_InterfaceMethodref:
		case CONSTANT_Fieldref:
		case CONSTANT_Methodref:
			func=pool_compare_ref_entry;
			l=pool->listConstRef;
			break;	
		case CONSTANT_NameAndType:
			func=pool_compare_name_type_entry;
			l=pool->listConstNameType;
			break;
		case CONSTANT_Class:
			func=pool_compare_class_entry;
			l=pool->listConstClass;
			break;
		case CONSTANT_Utf8:
			func=pool_compare_utf8_entry;
			l=pool->listConstUtf8;
			break;
		case CONSTANT_Long:
			func=pool_compare_long_entry;
			l=pool->listConstPrimitive;
			break;
		case CONSTANT_String:
			func=pool_compare_string_entry;
			l=pool->listConstString;
			break;
		default :
		{
			printf("ERRRRRRRRRRRORRRRR + %i\n",t);	
		}
	}
	lnode_t*result=list_find(l,entry,func);
	if(result!=NULL)
		return (POOL_ENTRY_PTR)lnode_get(result);
	return NULL;
}




/**
*   Primitive function: must be called only by add_rec_X_entry  
*	Adds a pool entry to the right list of the pool and updates the pool
*	It is used to create a pool while building a JCLASS structure from scratch	
*/
int add_pool_entry(POOL_PTR pool,TAG tag,POOL_ENTRY_PTR entry)
{
	pool->size++;
	list_t*		list;
	lnode_t*	node;
	switch(tag)
	{
		case CONSTANT_Utf8:
		{
			list = pool->listConstUtf8;
			break;	
		}
		case CONSTANT_Class:
		{
			list = pool->listConstClass;
			break;		
		}
		case CONSTANT_String:
		{
			list = pool->listConstString;
			break;		
		}
		case CONSTANT_NameAndType:
		{
			list = pool->listConstNameType;
			break;		
		}
		case CONSTANT_Fieldref:
		case CONSTANT_Methodref:
		case CONSTANT_InterfaceMethodref:
		{
			list = pool->listConstRef;
			break;		
		}
		case CONSTANT_Long:
		{
			list = pool->listConstPrimitive;
			break;			
		}
		default:
		 return -1;
	}		
	node=lnode_create(entry);
	list_append(list,node);
	pool_sort_constant_pool(pool);
	return 0;
}

void write_empty(int fd, POOL_ENTRY_PTR entry)
{
	//Do nothing for empty entry	
}


void write_entry(int fd,POOL_ENTRY_PTR entry)
{
	writejByte(fd,entry->tag);
	switch(entry->tag)
	{
		case CONSTANT_Utf8:
		{
			writejUtf8(fd,entry->info.utf8->utf8);
			break;			
		}
		case CONSTANT_Class:
		{
			writejShort(fd,*entry->info.cl->name_index);	
			break;
		}
		case CONSTANT_Double:
		{
			fprintf(stdout,"write(Double) NOT IMPLEMENTED YET\n");
			break;
		}
		case CONSTANT_Integer:
		{
			fprintf(stdout,"write(Integer) NOT IMPLEMENTED YET\n");
			break;
		}
		case CONSTANT_Fieldref:
		case CONSTANT_InterfaceMethodref:
		case CONSTANT_Methodref:
		{
			writejShort(fd,*entry->info.ref->class_index);
			writejShort(fd,*entry->info.ref->name_and_type_index);			
			break;
		}
		case CONSTANT_NameAndType:
		{
			writejShort(fd,*entry->info.nameandtype->name_index);	
			writejShort(fd,*entry->info.nameandtype->descriptor_index);	
			break;
		}
		case CONSTANT_Long:
		{
			writejLong(fd,entry->info.l->long_bytes);
			break;
		}
		case CONSTANT_String:
		{
			writejShort(fd,*entry->info.string->string_index);	
			break;
		}
		default:
		{
			fprintf(stdout,"write(Tag:%i) NOT FOUND\n",entry->tag);
			break;			
		}
	}
}

void writeConstantPool(int fd,POOL_PTR pool)
{
	int i=0;
	writejShort(fd,pool->size);
	if(pool->size!=0){
		for(i=1;i<pool->size;i++)
		{
			pool->tab[i]->write(fd,pool->tab[i]);	
		}
	}else
	{
		writejShort(fd,0);	
	}
}

/**
*   Primitive function: must be called only by add_rec_X_entry and add_X_entry_with_fixed_index 
*	Allocates the space for an entry pool of type constant utf8 and initialize its values
*/
POOL_ENTRY_PTR new_constant_utf8_info(const char* str){
	
	UTF8_PTR utf8 =stringToUTF8(str);
	UTF8_INFO_PTR utf8_info=malloc(sizeof(UTF8_INFO));
	utf8_info->utf8=utf8;
	POOL_ENTRY_PTR entry=malloc(sizeof(POOL_ENTRY));
	entry->tag=CONSTANT_Utf8;
	entry->info.utf8=utf8_info;
	entry->index=0;
	entry->write=write_entry;
	return entry;
}

/**
*   Primitive function: must be called only by add_rec_X_entry and add_X_entry_with_fixed_index 
*	Allocates the space for an entry pool of type constant utf8 and initialize its values
*/
POOL_ENTRY_PTR new_constant_long_info(j_long l){
	LONG_INFO_PTR long_info=malloc(sizeof(LONG_INFO));
	long_info->long_bytes=l; //Check cast
	POOL_ENTRY_PTR entry=malloc(sizeof(POOL_ENTRY));
	entry->tag=CONSTANT_Long;
	entry->info.l=long_info;
	entry->index=0;
	entry->write=write_entry;
	return entry;
}

/**
*   Primitive function: must be called only by add_rec_X_entry and add_X_entry_with_fixed_index 
*	Allocates the space for an entry pool of type constant utf8 and initialize its values
*/
POOL_ENTRY_PTR new_constant_integer_info(j_int i){
	
	
}

/**
*   Primitive function: must be called only by add_rec_X_entry and add_X_entry_with_fixed_index 
*	Allocates the space for an entry pool of type constant utf8 and initialize its values
*/
POOL_ENTRY_PTR new_constant_string_info(uint16* index){
	POOL_ENTRY_PTR entry=malloc(sizeof(POOL_ENTRY));
	entry->tag=CONSTANT_String;
	STRING_INFO_PTR string_info=malloc(sizeof(STRING_INFO));
	entry->info.string=string_info;
	entry->index=0;
	entry->write=write_entry;
	string_info->string_index=index;
	return entry;
}

/**
*   Primitive function: must be called only by add_rec_X_entry and add_X_entry_with_fixed_index 
*	Allocates the space for an entry pool of type constant utf8 and initialize its values
*/
POOL_ENTRY_PTR new_constant_class_info(uint16* index){
	POOL_ENTRY_PTR entry=malloc(sizeof(POOL_ENTRY));
	entry->tag=CONSTANT_Class;
	CLASS_INFO_PTR class_info=malloc(sizeof(CLASS_INFO));
	entry->info.cl=class_info;
	entry->index=0;
	entry->write=write_entry;
	class_info->name_index = index;
	return entry;
}

/**
*   Primitive function: must be called only by add_rec_X_entry and add_X_entry_with_fixed_index 
*	Allocates the space for an entry pool of type constant utf8 and initialize its values
*/
POOL_ENTRY_PTR new_constant_name_type_info(uint16* i1,uint16* i2){
	POOL_ENTRY_PTR entry=malloc(sizeof(POOL_ENTRY));
	entry->tag=CONSTANT_NameAndType;
	NAME_TYPE_INFO_PTR nametype_info=malloc(sizeof(NAME_TYPE_INFO));
	entry->info.nameandtype=nametype_info;
	entry->index=0;
	entry->write=write_entry;
	nametype_info->name_index=i1;
	nametype_info->descriptor_index=i2;
	return entry;
}

/**
*   Primitive function: must be called only by add_rec_X_entry and add_X_entry_with_fixed_index 
*	Allocates the space for an entry pool of type constant utf8 and initialize its values
*/
POOL_ENTRY_PTR new_constant_ref_info(TAG t,uint16* class,uint16* nametype){
	POOL_ENTRY_PTR entry=malloc(sizeof(POOL_ENTRY));
	switch(t)
	{
		case CONSTANT_Fieldref:
			entry->tag=CONSTANT_Fieldref;
			break;
		case CONSTANT_InterfaceMethodref:
			entry->tag=CONSTANT_InterfaceMethodref;
			break;
		case CONSTANT_Methodref:
			entry->tag=CONSTANT_Methodref;
			break;
	}
	
	REF_INFO_PTR ref_info=malloc(sizeof(REFERENCE_INFO));
	entry->info.ref=ref_info;
	entry->index=0;
	entry->write=write_entry;
	ref_info->class_index=class;
	ref_info->name_and_type_index=nametype;
	return entry;
}


/**
*   Can be called by code extern to this file.
* 	it is used to add a X pool entry into the constant pool.
* 	it creates all the required entries to store the value in the pool
*	and updates the reference indexes in the pool.
*	It is used  to create a pool while building a JCLASS structure from scratch
*/
uint16* add_rec_string_entry(POOL_PTR pool,char* name)
{
	POOL_ENTRY_PTR entry1,entry2;
	entry1=new_constant_string_info(add_rec_utf8_entry(pool,name));
	entry2=pool_search_entry(pool,entry1);
	if(entry2==NULL)
	{	
		add_pool_entry(pool,CONSTANT_String,entry1);
		return &entry1->index;
	}
	free(entry1->info.string);
	free(entry1);
	return &entry2->index;
}

/**
*   Can be called by code extern to this file.
* 	it is used to add a X pool entry into the constant pool.
* 	it creates all the required entries to store the value in the pool
*	and updates the reference indexes in the pool.
*	It is used  to create a pool while building a JCLASS structure from scratch
*/
uint16* add_rec_long_entry(POOL_PTR pool,j_long l)
{
	POOL_ENTRY_PTR entry1,entry2;
	entry1=new_constant_long_info(l);
	entry2=pool_search_entry(pool,entry1);
	if(entry2==NULL)
	{	add_pool_entry(pool,CONSTANT_Long,entry1);
		return &entry1->index;
	}
	pool_free_pool_entry(entry1);
	return &entry2->index;
}

/**
*   Can be called by code extern to this file.
* 	it is used to add a X pool entry into the constant pool.
* 	it creates all the required entries to store the value in the pool
*	and updates the reference indexes in the pool.
*	It is used  to create a pool while building a JCLASS structure from scratch
*/
uint16* add_rec_class_entry(POOL_PTR pool,const char* classname)
{
	POOL_ENTRY_PTR class_1, class_2;
	class_1= new_constant_class_info(add_rec_utf8_entry(pool,classname));
	class_2= pool_search_for_class_entry(pool,class_1);
	if(class_2==NULL){
		add_pool_entry(pool,CONSTANT_Class,class_1);
		return &class_1->index;
	}	
	free(class_1->info.cl);
	free(class_1);
	return &class_2->index;
}

/**
*   Can be called by code extern to this file.
* 	it is used to add a X pool entry into the constant pool.
* 	it creates all the required entries to store the value in the pool
*	and updates the reference indexes in the pool.
*	It is used  to create a pool while building a JCLASS structure from scratch
*/
uint16* add_rec_utf8_entry(POOL_PTR pool,const char* str)
{
	POOL_ENTRY_PTR utf8_1,utf8_2;
	utf8_1= new_constant_utf8_info(str);
	utf8_2= pool_search_for_utf8_entry(pool,utf8_1);
	if(utf8_2==NULL)
	{	add_pool_entry(pool,CONSTANT_Utf8,utf8_1);
		return &utf8_1->index;
	}
	pool_free_pool_entry(utf8_1);
	return &utf8_2->index;
}

/**
*   Can be called by code extern to this file.
* 	it is used to add a X pool entry into the constant pool.
* 	it creates all the required entries to store the value in the pool
*	and updates the reference indexes in the pool.
*	It is used  to create a pool while building a JCLASS structure from scratch
*/
uint16* add_rec_ref_entry(POOL_PTR pool,TAG t,const char* classname,\
								const char* varName,const char* type)
{
	POOL_ENTRY_PTR ref1,ref2;
	ref1=new_constant_ref_info(t,\
				add_rec_class_entry(pool,classname),\
				add_rec_name_type_entry(pool,varName,type));
	ref2=pool_search_for_ref_entry(pool,ref1);
	if(ref2==NULL)
	{	add_pool_entry(pool,t,ref1);
		return &ref1->index;
	}
	free(ref1->info.ref);
	free(ref1);
	return &ref2->index;
}

/**
*   Can be called by code extern to this file.
* 	it is used to add a X pool entry into the constant pool.
* 	it creates all the required entries to store the value in the pool
*	and updates the reference indexes in the pool.
*	It is used  to create a pool while building a JCLASS structure from scratch
*/
uint16* add_rec_name_type_entry(POOL_PTR pool,const char* varName,const char* type)
{
	POOL_ENTRY_PTR nametype1, nametype2;
	nametype1=\
		new_constant_name_type_info(add_rec_utf8_entry(pool,varName),\
									add_rec_utf8_entry(pool,type));
	nametype2=pool_search_for_name_and_type_entry(pool,nametype1);
	if(nametype2==NULL){	
		add_pool_entry(pool,CONSTANT_NameAndType,nametype1);
		return &nametype1->index;	
	}
	free(nametype1->info.nameandtype);
	free(nametype1);
	return &nametype2->index;
}


void pool_free_pool_entry(POOL_ENTRY_PTR entry)
{
	switch(entry->tag)
	{
		case CONSTANT_Utf8:
		{
			UTF8_INFO_PTR info;	
			info=(UTF8_INFO_PTR)entry->info.utf8;
			free(info->utf8);
			free(info);
			free(entry);
			return;
		break;	
		}
		case CONSTANT_Class:			
		{
			CLASS_INFO_PTR info;
			info=(CLASS_INFO_PTR)entry->info.cl;
			free(info->name_index);
			free(info);
			free(entry);
			break;
		}case CONSTANT_String:
		{
			STRING_INFO_PTR info;
			info=(STRING_INFO_PTR)entry->info.cl;
			free(info->string_index);
			free(info);
			free(entry);
			break;
		}
		case CONSTANT_Fieldref:
		case CONSTANT_InterfaceMethodref:
		case CONSTANT_Methodref:
		{
			REF_INFO_PTR info;
			info=(REF_INFO_PTR)entry->info.ref;
			free(info->class_index);
			free(info->name_and_type_index);
			free(entry);
			break;
		}
		case CONSTANT_NameAndType:
		{
			NAME_TYPE_INFO_PTR info;
			info=(NAME_TYPE_INFO_PTR)entry->info.nameandtype;
			free(info->name_index);
			free(info->descriptor_index);
			free(entry);
			break;
		}
		case CONSTANT_Long:
		{
			LONG_INFO_PTR info;
			info=(LONG_INFO_PTR)entry->info.l;
			free(info);
			free(entry);			
		}
		case CONSTANT_Empty:
		{
			
		}			
		default:
		{	
			
			
		}
	}	
}
//Perhaps we can optimize it
void pool_list_incr(list_t *list,lnode_t *lnode,void *context)
{

	POOL_PTR pool=(POOL_PTR)context;
	POOL_ENTRY_PTR entry;	
	entry=(POOL_ENTRY_PTR)lnode_get(lnode);
	if(entry!=NULL)
	{	
		pool->tab[pool->size]=entry;
		entry->index=(pool->size)++;
			if(entry->tag==CONSTANT_Long)
			{	
				POOL_ENTRY_PTR entry=malloc(sizeof(POOL_ENTRY));
				entry->tag=CONSTANT_Empty;
				entry->write=write_empty;
				pool->tab[pool->size]=entry;
				pool->size++;
			}
	}
}

void pool_sort_constant_pool(POOL_PTR pool)
{

	int i=list_count(pool->listConstPrimitive); //Long
	pool->tab=realloc(pool->tab,sizeof(POOL_ENTRY_PTR)*(pool->size+i));
	assert(pool->tab!=NULL);
	pool->size=1;
	list_process(pool->listConstString,(void*)pool,pool_list_incr);
	list_process(pool->listConstClass,(void*)pool,pool_list_incr);
	list_process(pool->listConstRef,(void*)pool,pool_list_incr);
	list_process(pool->listConstPrimitive,(void*)pool,pool_list_incr);
	list_process(pool->listConstNameType,(void*)pool,pool_list_incr);
	list_process(pool->listConstUtf8,(void*)pool,pool_list_incr);
}

const char*	pool_get_utf8_string(POOL_PTR pool,uint16 index)
{
	POOL_ENTRY_PTR entry=pool->tab[index]; //=> ConstantUtf8
	UTF8_INFO_PTR u_info=(UTF8_INFO_PTR)entry->info.utf8;
	return utf8ToString(u_info->utf8);
}

/**
*/
void print_pool(POOL_PTR pool,TAG tag)
{
	list_t*		list;
	lnode_t*	node;
	POOL_ENTRY_PTR entry,entry2;
	int count=0;
	switch(tag)
	{
		case CONSTANT_Utf8:
		{
			UTF8_INFO_PTR info;
			list = pool->listConstUtf8;
			for (node = list_first(list); node != 0; node = list_next(list, node))
			{
				entry=(POOL_ENTRY_PTR)lnode_get(node);
				info=(UTF8_INFO_PTR)entry->info.utf8;
				fprintf(stdout,"UTF8INFO <%i>: %s\n",entry->index,utf8ToString(info->utf8));
			}
			break;	
		}
		case CONSTANT_Class:			
		{
			CLASS_INFO_PTR c_info;
			UTF8_INFO_PTR  u_info;
			list=pool->listConstClass;			
			for(node = list_first(list); node != 0; node = list_next(list, node))
			{
				entry=(POOL_ENTRY_PTR)lnode_get(node);
				c_info=(CLASS_INFO_PTR)entry->info.cl;
				entry2=pool->tab[*c_info->name_index]; //=> ConstantUtf8
				u_info=(UTF8_INFO_PTR)entry2->info.utf8;
				fprintf(stdout,"CLASS_INFO <%i>: \tn:%i %s\n",\
											entry->index,\
											*c_info->name_index,\
											utf8ToString(u_info->utf8));
			}
			break;
		}case CONSTANT_String:
		{
			STRING_INFO_PTR s_info;
			UTF8_INFO_PTR  u_info;
			list=pool->listConstString;	
			for(node = list_first(list); node != 0; node = list_next(list, node))
			{
				entry=(POOL_ENTRY_PTR)lnode_get(node);
				s_info=(STRING_INFO_PTR)entry->info.string;
				entry2=pool->tab[*s_info->string_index]; //=> ConstantUtf8
				u_info=(UTF8_INFO_PTR)entry2->info.utf8;
				fprintf(stdout,"STRING_INFO <%i>: \tn:%i %s\n",\
											entry->index,\
											*s_info->string_index,\
											utf8ToString(u_info->utf8));
			}
			break;
		}
		case CONSTANT_Fieldref:
		case CONSTANT_InterfaceMethodref:
		case CONSTANT_Methodref:
		{
			REF_INFO_PTR info;
			list=pool->listConstRef;			
			for(node = list_first(list); node != 0; node = list_next(list, node))
			{
				entry=(POOL_ENTRY_PTR)lnode_get(node);
				if(entry->tag!=tag) continue; 
				info=(REF_INFO_PTR)entry->info.ref;
				fprintf(stdout,"REF_INFO <%i>: \tclass_index:%i\tname_type_index:%i\n",\
						entry->index,\
						*info->class_index,\
						*info->name_and_type_index);
			}
			break;
		}
		case CONSTANT_NameAndType:
		{
			NAME_TYPE_INFO_PTR info;
			list=pool->listConstNameType;
			for(node = list_first(list); node != 0; node = list_next(list, node))
			{
				entry=(POOL_ENTRY_PTR)lnode_get(node);
				info=(NAME_TYPE_INFO_PTR)entry->info.nameandtype;
				fprintf(stdout,"NAME_TYPE_INFO <%i>: \t(%i)name:%s \t (%i)type:%s\n",\
						entry->index,\
						*info->name_index,\
						pool_get_utf8_string(pool,*info->name_index),\
						*info->descriptor_index,\
						pool_get_utf8_string(pool,*info->descriptor_index));
			}
			break;
		}
		case CONSTANT_Long:
		{
			LONG_INFO_PTR info;
			list=pool->listConstPrimitive;
			for(node = list_first(list); node != 0; node = list_next(list, node))
			{
				entry=(POOL_ENTRY_PTR)lnode_get(node);
				//WARNING INTEGER ??
				info=(LONG_INFO_PTR)entry->info.l;
				fprintf(stdout,"LONG_INFO <%i>: \tval:%lld\n",\
						entry->index,\
						info->long_bytes);

			}
			break;
		}
		case CONSTANT_Double:
		{
			printf("CONSTANT_DOUBLE: not implemented yet");	
		}
		default:
		{	
			printf("ERRR: not implemented yet\n");	
		}
	}
}

/*
*
*
*
*
*
*/
/**
*   Primitive function: must be called only by add_X_entry_with_fixed_index 
*	Adds a pool entry to the right list of the pool and updates the pool
*	It is used to create a pool while building a JCLASS structure from parsing a file 
*	and the structure of the pool and of its indexex are already fixed	
*/
int add_pool_entry_with_fixed_index(POOL_PTR pool,TAG tag,POOL_ENTRY_PTR entry)
{

	//fprintf(stdout,"\nPoolsize= %d , indexentry== %d\n",pool->size, entry->index);

	// the size of the pool depends on the index of the entry to be added
	// because the entry index is the highest index and I need to allocate
	// enough memory in the pool->tab to store the entry 
	pool->size = entry->index;

	list_t*		list;
	lnode_t*	node;
	switch(tag)
	{
		case CONSTANT_Utf8:
		{
			list = pool->listConstUtf8;
			break;	
		}
		case CONSTANT_Class:
		{
			list = pool->listConstClass;
			break;		
		}
		case CONSTANT_String:
		{
			list = pool->listConstString;
			break;		
		}
		case CONSTANT_NameAndType:
		{
			list = pool->listConstNameType;
			break;		
		}
		case CONSTANT_Fieldref:
		case CONSTANT_Methodref:
		case CONSTANT_InterfaceMethodref:
		{
			list = pool->listConstRef;
			break;		
		}
		case CONSTANT_Long:
		{
			list = pool->listConstPrimitive;
			break;			
		}
		default:
		 return -1;
	}		
	node=lnode_create(entry);
	list_append(list,node);
//	pool_sort_constant_pool(pool);


	// from pool_sort_constant_pool(POOL_PTR pool)
	pool->tab=realloc(pool->tab,sizeof(POOL_ENTRY_PTR)*(pool->size+1));
	assert(pool->tab!=NULL);

	int index = entry->index;
	pool->tab[index] = entry;

//fprintf(stdout,"\nAdding entry with index = %d and tag=%d\n",index,tag);

	return 0;
}


/**
*   Can be called by code extern to this file.
* 	it is used to add a X pool entry into the constant pool.
* 	it creates the required entry to store the value in the pool
*	and its index is fixed because it is obtained (along with all the definition
*	of the entry) from the parsing of a file
*/
int add_string_entry_with_fixed_index(POOL_PTR pool, j_short string_index_tmp, int* index)
{
	POOL_ENTRY_PTR entry;
	j_short* string_index = (j_short*)malloc(sizeof(j_short));
	memcpy(string_index, &string_index_tmp, sizeof(j_short));
	entry = new_constant_string_info(string_index);
	entry->index = *index;
	add_pool_entry_with_fixed_index(pool, CONSTANT_String, entry);
	fprintf(stdout,"parse (String) string_index=%d\n", *string_index);	
}

/**
*   Can be called by code extern to this file.
* 	it is used to add a X pool entry into the constant pool.
* 	it creates the required entry to store the value in the pool
*	and its index is fixed because it is obtained (along with all the definition
*	of the entry) from the parsing of a file
*/
int add_long_entry_with_fixed_index(POOL_PTR pool, j_long l_tmp, int* index)
{
	// Not correct yet: I must read two ints and rebuild the long value instead
	// of reading the 8 bytes into a long value

	POOL_ENTRY_PTR entry;
	
	j_long* long_bytes = (j_long*)malloc(sizeof(j_long));
	memcpy(long_bytes, &l_tmp, sizeof(j_long));
	entry = new_constant_long_info(*long_bytes);
	entry->index = *index;
	add_pool_entry_with_fixed_index(pool, CONSTANT_Long, entry);
	*index += 1;
	fprintf(stdout,"parse (long) long_bytes=%d\n", *long_bytes);
}

/**
*   Can be called by code extern to this file.
* 	it is used to add a X pool entry into the constant pool.
* 	it creates  the required entry to store the value in the pool
*	and its index is fixed because it is obtained (along with all the definition
*	of the entry) from the parsing of a file
*/
int add_class_entry_with_fixed_index(POOL_PTR pool, j_short name_index_tmp, int* index)
{
	POOL_ENTRY_PTR entry;
	
	j_short* name_index = (j_short*)malloc(sizeof(j_short));
	memcpy(name_index, &name_index_tmp, sizeof(j_short));
	entry = new_constant_class_info(name_index);
	entry->index = *index;
	add_pool_entry_with_fixed_index(pool, CONSTANT_Class, entry);
	fprintf(stdout,"parse (class) name_index=%02x\n", *name_index);
}

/**
*   Can be called by code extern to this file.
* 	it is used to add a X pool entry into the constant pool.
* 	it creates the required entry to store the value in the pool
*	and its index is fixed because it is obtained (along with all the definition
*	of the entry) from the parsing of a file
*/
int add_utf8_entry_with_fixed_index(POOL_PTR pool, const char* const_utf8, int* index)
{
	POOL_ENTRY_PTR entry;
	entry = new_constant_utf8_info(const_utf8);
	entry->index = *index;
	add_pool_entry_with_fixed_index(pool, CONSTANT_Utf8, entry);
	fprintf(stdout,"parse (const_utf8) const_utf8 = %s\n", const_utf8);
}

/**
*   Can be called by code extern to this file.
* 	it is used to add a X pool entry into the constant pool.
* 	it creates the required entry to store the value in the pool
*	and its index is fixed because it is obtained (along with all the definition
*	of the entry) from the parsing of a file
*/
int add_ref_entry_with_fixed_index(POOL_PTR pool, TAG tag, j_short class_index_tmp, j_short name_type_index_tmp, int* index)
{
	POOL_ENTRY_PTR entry;
	j_short* class_index = (j_short*)malloc(sizeof(j_short));
	memcpy(class_index, &class_index_tmp, sizeof(j_short));
	j_short* name_type_index = (j_short*)malloc(sizeof(j_short));
	memcpy(name_type_index, &name_type_index_tmp, sizeof(j_short));
	entry = new_constant_ref_info(tag, class_index, name_type_index);
	entry->index = *index;
	add_pool_entry_with_fixed_index(pool, tag, entry);
	fprintf(stdout,"parse (field_method) class_index=%02x, name_type_index=%02x\n", *class_index, *name_type_index);
}

/**
*   Can be called by code extern to this file.
* 	it is used to add a X pool entry into the constant pool.
* 	it creates the required entry to store the value in the pool
*	and its index is fixed because it is obtained (along with all the definition
*	of the entry) from the parsing of a file
*/
int add_name_type_entry_with_fixed_index(POOL_PTR pool, j_short name_index_tmp, j_short descriptor_index_tmp, int* index)
{
	POOL_ENTRY_PTR entry;
	j_short* name_index = (j_short*)malloc(sizeof(j_short));	
	memcpy(name_index, &name_index_tmp, sizeof(j_short));
	j_short* descriptor_index = (j_short*)malloc(sizeof(j_short));
	memcpy(descriptor_index, &descriptor_index_tmp, sizeof(j_short));
	entry = new_constant_name_type_info(name_index, descriptor_index);
	entry->index = *index;
	add_pool_entry_with_fixed_index(pool, CONSTANT_NameAndType, entry);
	fprintf(stdout,"parse (name_type) name_index=%02x, descriptor_index=%02x\n", *name_index, *descriptor_index);
}
