#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <assert.h>
#include <sys/types.h>
#include <sys/time.h>
#include <string.h> //for strerror
#include <fcntl.h>
//#include <kazlib/list.h>
#include <vm/jclass.h>
#include <vm/opcode.h>

#include <io/io.h>


JCLASS_PTR new_class0()
{
	POOL_ENTRY_PTR utf8;
	JCLASS_PTR jclass = malloc(sizeof(JCLASS));
	uint16* index;
	int err;
//	jclass->major=46;
//	jclass->minor=0;
//	jclass->modifier=ACC_FINAL|ACC_PUBLIC;
	jclass->pool= new_pool();
//	index = add_rec_class_entry(jclass->pool,classname);
//	jclass->indexClassName=index;
//	index = add_rec_class_entry(jclass->pool,superclassname);
//	jclass->indexSuperClassName=index;
	jclass->nbInterfaces=0;
	jclass->tabInterface=NULL;
	jclass->listFields= list_create(LISTCOUNT_T_MAX);
	jclass->listMethods= list_create(LISTCOUNT_T_MAX);
	jclass->listAttributes= list_create(LISTCOUNT_T_MAX);
	return jclass;
}


/**
*
*
*/
JCLASS_PTR new_class(const char* classname,const char* superclassname)
{
	POOL_ENTRY_PTR utf8;
	JCLASS_PTR jclass = malloc(sizeof(JCLASS));
	uint16* index;
	int err;
	jclass->major=46;
	jclass->minor=0;
	jclass->modifier=ACC_FINAL|ACC_PUBLIC;	
	jclass->pool= new_pool();
	index = add_rec_class_entry(jclass->pool,classname);
	jclass->indexClassName=index;
	index = add_rec_class_entry(jclass->pool,superclassname);
	jclass->indexSuperClassName=index;
	jclass->nbInterfaces=0;
	jclass->tabInterface=NULL;
	jclass->listFields= list_create(LISTCOUNT_T_MAX);
	jclass->listMethods= list_create(LISTCOUNT_T_MAX);
	jclass->listAttributes= list_create(LISTCOUNT_T_MAX);
	return jclass;
}

/**
*   Can be called by code extern to this file.
* 	it is used to add a reference to an interface in the definition of a JCLASS
 X pool entry into the constant pool.
* 	it creates all the required entry to store the value in the pool
*	and its index is fixed because it is obtained (along with all the definition
*	of the entry) from the parsing of a file
*/
FIELD_PTR class_add_field(JCLASS_PTR jclass,uint16 flag,const char* fieldName,\
							const char* signature)
{
	FIELD_PTR field;
	field=field_new(jclass->pool,flag,fieldName,signature);	
	list_append(jclass->listFields,lnode_create(field));	
	return field;
}


/**
*   Can be called by code extern to this file.
* 	it is used to add a reference to an interface in the definition of a JCLASS
 X pool entry into the constant pool.
* 	it creates all the required entry to store the value in the pool
*	and its index is fixed because it is obtained (along with all the definition
*	of the entry) from the parsing of a file
*/
void class_add_interface(JCLASS_PTR cls, const char* interfaceName)
{
	cls->nbInterfaces+=1;		
	cls->tabInterface=realloc(cls->tabInterface,sizeof(uint16*)*(cls->nbInterfaces));
	uint16* index = add_rec_class_entry(cls->pool,interfaceName);
	cls->tabInterface[cls->nbInterfaces-1]=index;
}


/**
*   Can be called by code extern to this file.
* 	it is used to add a reference to an interface in the definition of a JCLASS
 X pool entry into the constant pool.
* 	it creates all the required entry to store the value in the pool
*	and its index is fixed because it is obtained (along with all the definition
*	of the entry) from the parsing of a file
*/
FIELD_PTR class_add_method(JCLASS_PTR jclass,uint16 flag,const char* methodName,\
							const char* signature)
{
	FIELD_PTR field;
	field=field_new(jclass->pool,flag,methodName,signature);
	list_append(jclass->listMethods,lnode_create(field));	
	return field;
}

/**
*
*/
void class_print_pool(JCLASS_PTR jclass,TAG tag)
{
	if(jclass->pool!=0)
		print_pool(jclass->pool,tag);
}

/**
*
*/
void class_write(int fd,JCLASS_PTR jclass)
{
	int i;
	int nb;
	writejInt(fd,0xCAFEBABE); //Write header	
	writejShort(fd,jclass->minor);
	writejShort(fd,jclass->major);
	writeConstantPool(fd,jclass->pool); 
	writejShort(fd,jclass->modifier);
	writejShort(fd,*jclass->indexClassName);
	writejShort(fd,*jclass->indexSuperClassName); 
	writejShort(fd,jclass->nbInterfaces);
	for(i=0;i<jclass->nbInterfaces;i++)
	{	
		writejShort(fd,*jclass->tabInterface[i]);
	}
	class_write_fields(fd,0,jclass);
	class_write_fields(fd,1,jclass);	
	//WARNING MUST MANAGE ATTRIBUTES FOR CLASSES //
	writejShort(fd,0);
	/*writeAttributes()*/
}

void class_write_fields(int fd, uint8 b, JCLASS_PTR cls)
{
	lnode_t* node;
	list_t* list;
	FIELD_PTR field;
	if(b == 0) 
		list=cls->listFields;
	else
		list=cls->listMethods;
		
	if (b == 0)
		fprintf(stdout, "WRITE CLASS. NR fields = %d", list_count(list));
	else

		fprintf(stdout, "WRITE CLASS. NR methods = %d", list_count(list));
	
	writejShort(fd,(j_short)list_count(list));
	for(node = list_first(list); node != 0; node = list_next(list, node))
	{
		field=(FIELD_PTR)lnode_get(node);
		writejShort(fd,field->access_flags);
		writejShort(fd,*field->name_index);
		writejShort(fd,*field->descriptor_index);
		class_write_attributes(fd,field);
	}
}

void class_write_attributes(int fd, FIELD_PTR field)
{
	lnode_t* node;
	list_t* list;	
	ATTR_PTR attr;
	int z;
	list=field->listAttributes;
	writejShort(fd,list_count(list));
	for(node = list_first(list); node != 0; node = list_next(list, node))
	{
		attr=(ATTR_PTR)lnode_get(node);
		switch(attr->tag)
		{
			case CODE_ID:
			{
				writejShort(fd,*attr->name_index);
				ATTR_CODE_PTR attr_c=attr->info.code;
				int w=list_count(attr_c->listException);
				z=2+2+4+attr_c->current_pc+2+w*8+2;
				writejInt(fd,z); 
				writejShort(fd,attr_c->maxStack); //max_stack
				writejShort(fd,attr_c->maxLocal); //max_locals
				writejInt(fd,attr_c->current_pc);
				class_write_code(fd,attr);
				class_write_exception(fd,attr_c);
				writejShort(fd,0);
				break;				
			}
			case SYNTH_ID:
			{
				writejShort(fd,*attr->name_index);
				writejInt(fd,attr->attr_length);
				break;	
			}
			case EXCEP_ID:
			{
				if(attr->attr_length!=0)
				{
					writejShort(fd,*attr->name_index);
					writejInt(fd,attr->attr_length);
					ATTR_EXCEPTION_PTR attr_ex=attr->info.exception;
					writejShort(fd,attr_ex->nb);
					int i;
					for(i=0;i<attr_ex->nb;i++)
					{
						writejShort(fd,*attr_ex->tab[i]);
					}
				}else{
					printf("EXCEPTION LENGTH =0 WARNING\n");
				}
				break;
			}
			case CONST_ID:
			{
				if(attr->attr_length!=0)
				{
					writejShort(fd,*attr->name_index);
					writejInt(fd,attr->attr_length);
					writejShort(fd,*attr->info.constant->constant_value_index);
				}
				else{
					printf("EXEPTION LENGTH = 0 WARNING \n");
				}
				break;
			}
			default:
			{
				printf("Write Attr Error: %i",attr->tag);
			}
		}
	}
}

void class_write_code(int fd, ATTR_PTR attr)
{
	ATTR_CODE_PTR attr_c=attr->info.code;
	INSTR_PTR instr;
	list_t* list=attr_c->listCode;
	lnode_t* node;
	int i=0;
	for(node = list_first(list); node != 0; node = list_next(list, node))
	{
		instr=(INSTR_PTR)lnode_get(node);	
		writejByte(fd,instr->opcode);
		switch(instr->length)
		{	case 3:
					writejShort(fd,*(uint16*)instr->index);
					i+=3;
					break;
			case 2:
					writejByte(fd,*instr->index);
					i+=2;
					break;
			case 4:
					printf("!!! class_write_code(%s) not implemented",opcode[instr->opcode][2]);
					break;
			case 5:
					switch(instr->opcode)
					{
						case OP_INVOKEINTERFACE:
							writejShort(fd,*(uint16*)instr->index); //index
							uint16 args=*(uint16*)instr->index;
							REF_INFO_PTR ref=attr->pool->tab[args]->info.ref;						
							NAME_TYPE_INFO_PTR nt=attr->pool->tab[*ref->name_and_type_index]->info.nameandtype;
							uint8 n=(uint8)class_nb_arguments(pool_get_utf8_string(attr->pool,*nt->descriptor_index));
							writejByte(fd,n+2);
							writejByte(fd,0); 
							break;
						case OP_GOTO_W:
							printf("!!! class_write_code(%s): not implemented",opcode[instr->opcode][2]);
							break;							
						case OP_JSR_W:
							printf("!!! class_write_code(%s): not implemented",opcode[instr->opcode][2]);
							break;
						default:
						{
							printf("!!! class_write_code(%s): fatal error",opcode[instr->opcode][2]);
						}
					}
					i+=5;
					break;
			default:
			{
				i+=1;
			}				
		}
	}
}
	
void class_write_exception(int fd, ATTR_CODE_PTR attr)
{
	EXCEPTION_PTR ex;
	list_t* list=attr->listException;
	lnode_t* node;
	writejShort(fd,list_count(list));
	for(node = list_first(list); node != 0; node = list_next(list, node))
	{
		ex=(EXCEPTION_PTR)lnode_get(node);	
		writejShort(fd,ex->start_pc);
		writejShort(fd,ex->end_pc);
		writejShort(fd,ex->handler);
		writejShort(fd,*ex->index);
	}
}

/**
*
*/
int class_nb_arguments(const char* str)
{
	char *ptr1,*ptr2,*tmp1,*tmp2;
	int nb,count=0;
	ptr1=strchr(str,'(');
	ptr2=strchr(str,')');
	nb=ptr2-ptr1+1;
	if(nb==2)
		return 0;
	tmp1=malloc(sizeof(char)*nb-1);
	strncpy(tmp1,ptr1+1,nb-2);
	tmp1[nb-1]='\0';
	tmp2=tmp1;
	do
	{
		switch(*tmp2)
		{
			case 'B':
			case 'C':
			case 'D':
			case 'F':
			case 'I':
			case 'J':
			case 'S':
			case 'Z':
				count++;
				tmp2++;				
				break;
			case 'L':
				count++;
				tmp2=strchr(tmp2,';')+1;
				break;
			case '[':
				tmp2++;
				break;
		}			
	}while(*tmp2!='\0');
	free(tmp1);
	return count;
}



FIELD_PTR class_get_method(JCLASS_PTR jclass, uint16 flag, const char* methodName,\
		const char* signature)
{

	lnode_t* node;
	list_t* list = jclass->listMethods;	

	for(node = list_first(list); node != 0; node = list_next(list, node))
	{

		FIELD_PTR meth = (FIELD_PTR)lnode_get(node);

		if (meth->access_flags & flag) {
			   POOL_ENTRY_PTR* tab = meth->pool->tab;
			   char* pool_name = utf8ToString(tab[*meth->name_index]->info.utf8->utf8);
			   char* pool_signature = utf8ToString(tab[*meth->descriptor_index]->info.utf8->utf8);
	   
			   if (strcmp(pool_name, methodName) == 0 && strcmp(pool_signature, signature) == 0)
				   return meth;
		}
	}
	return NULL;
}
	
FIELD_PTR class_get_field(JCLASS_PTR jclass, uint16 flag, const char* fieldName,\
		const char* type)
{

	lnode_t* node;
	list_t* list = jclass->listFields;	

	for(node = list_first(list); node != 0; node = list_next(list, node))
	{

		FIELD_PTR field = (FIELD_PTR)lnode_get(node);

		if (field->access_flags & flag) {
			   POOL_ENTRY_PTR* tab = field->pool->tab;
			   char* pool_name = utf8ToString(tab[*field->name_index]->info.utf8->utf8);
			   char* pool_type = utf8ToString(tab[*field->descriptor_index]->info.utf8->utf8);
	   
			   if (strcmp(pool_name, fieldName) == 0 && strcmp(pool_type, type) == 0)
				   return field;
		}
	}
	return NULL;
}	
